2002-05-23  Dave Love  <fx@gnu.org>

	* language/ind-util.el: Avoid decode-char.
	(indian--puthash-char, indian--puthash-c, indian--puthash-cv):
	Use characterp, not char-valid-p.

	* language/devan-util.el: Add coding tag, avoid decode-char.

	* international/titdic-cnv.el: Add coding tag.
	(tit-process-header): Add coding tag to output.

	* language/thai.el (cp874, ibm874): New coding systems.

	* emacs-lisp/byte-opt.el <side-effect-and-error-free-fns>: Add
	character-p.

	* language/european.el (cp852, ibm852, cp857, ibm857, cp860)
	(ibm860, cp861, ibm861, cp863, cp865, ibm865, cp437, ibm437): New
	coding systems.
	<set-language-info-alist>: Avoid decode-char.

	* language/hebrew.el (cp862, ibm862): New coding systems.

	* language/greek.el (cp851, ibm851, cp869, ibm869): New coding
	systems.

	* language/cyrillic.el (cp855, ibm855): New coding systems.

	* international/mule-conf.el: Avoid decode-char in top-level code
	for self-inserting multibyte chars.
	(cp437, cp737, cp775, cp851, cp852, cp855, cp857, cp855, cp857)
	(cp860, cp861, cp862, cp863, cp864, cp865, cp869, cp874):  New
	charsets.

	* international/characters.el: Various simplifications and
	additions.

2002-05-22  Dave Love  <fx@gnu.org>

	* international/mule-conf.el (code-pages): Provide for
	compatibility.

	* international/code-pages.el: Removed.

2002-05-22  Kenichi Handa  <handa@etl.go.jp>

	* Makefile.in: Cancel the 2002-05-17 change of mine.

	* international/fontset.el: Add setting for unicode font at the
	end of the default fontset.

2002-05-21  Dave Love  <fx@gnu.org>

	* international/mule-conf.el (adobe-standard-encoding, symbol):
	Adjust :code-space.
	(ibm850): Add :ascii-compatible-p.

2002-05-21  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-conf.el (vietnamese-viscii-lower,
	vietnamese-viscii-upper): Supply them :code-offset, then unify by
	mapping table.

2002-05-20  Dave Love  <fx@gnu.org>

	* cus-start.el: Add charset-map-directory.

	* international/fontset.el (font-encoding-alist): Add
	adobe-symbol.

	* format.el (format-alist): Remove ibm, mac, hp entries (available
	natively).

	* language/romanian.el (iso-latin-10): Add :mime-charset.
	("Romanian"): Add doc.

	* international/mule-conf.el (iso-8859-10, symbol)
	(adobe-standard-encoding, ibm850): New charsets.
	(iso-8859-13): Fix IR number, final char.
	(file-coding-system-alist): Add .xml.

	* language/european.el (iso-latin-6, iso-8859-10, latin-6)
	(iso-latin-7, iso-8859-13, latin-7, hp-roman8, roman8)
	(adobe-standard-encoding, cp850, ibm850): New coding systems.
	("Latin-6", "Latin-7"): New language environments.

2002-05-19  Dave Love  <fx@gnu.org>

	* Makefile.in (DONTCOMPILE): Remove ucs-tables, utf-8,
	utf-8-subst; add vietnamese, cyrillic, czech.

	* language/romanian.el (iso-latin-10): New coding system.

	* international/mule-conf.el (emacs-mule): Set :charset-list,
	consistent with coding-system-charset-list doc.
	(iso-8859-16): New charset.

	* international/mule-diag.el (describe-coding-system): Avoid error
	for iso-2022, emacs-mule.

2002-05-17  Dave Love  <fx@gnu.org>

	* international/codepage.el: Most of code removed or commented
	out.
	(codepage-setup): Re-written as trivial, obsolete function.

	* language/utf-8-lang.el ("UTF-8"): Use utf-8, not mule-utf-8.
	Remove setup function.

	* language/english.el (ebcdic-us, ebcdic-uk): New coding systems.

	* Makefile.in (DONTCOMPILE): Add language/vietnamese.el,
	language/cyrillic.el, language/czech.el.

	* language/vietnamese.el (windows-1258, cp1258): New coding
	systems.
	(font-ccl-encoder-alist): Remove viscii, vscii.

	* language/hebrew.el (windows-1255, cp1255): New coding systems.

	* language/european.el (windows-1254, cp1254, windows-1257)
	(cp1257, next, iso-latin-7, iso-8859-13, latin-7): New coding
	systems.
	("Latin-7", "Lithuanian", "Latvian"): Don't require code-pages.
	(iso-latin-7):

	* language/greek.el (windows-1253, cp1253): New coding systems.

	* international/mule-conf.el (ebcdic-us, ebcdic-uk): Change map
	file name.
	(windows-1253, windows-1254, windows-1255, windows-1256) 
	(windows-1257, windows-1258, next): New charsets.

	* international/utf-8.el, international/utf-8-subst.el: Removed.

	* international/mule.el: Doc fixes.
	(charset-list, generic-char-p, set-coding-priority): Make
	obsolete.
	(coding-system-get): Try to convert old-style symbol to keyword.
	(define-charset): Purecopy strings in property list.
	(define-coding-system): Purecopy docstring.

	* international/mule-diag.el (list-character-sets-2): Avoid
	charset-bytes.
	(list-iso-charset-chars, list-non-iso-charset-chars): Deleted.
	(list-block-of-chars): Re-written.
	(describe-character-set): Show more properties.
	(describe-char-after): Correct codepoint display.
	(print-coding-system): Use symbolic types.

2002-05-17  Kenichi Handa  <handa@etl.go.jp>

	* Makefile.in: Be sure also to run emacs with LANG=C.

2002-05-16  Dave Love  <fx@gnu.org>

	* international/mule-diag.el: Doc fixes.
	(sort-charset-list, charset-multibyte-form-string): Removed.
	(list-character-sets, list-character-sets-1)
	(list-character-sets-2): Re-written.
	(non-iso-charset-alist): Set to nil and made obsolete.
	(decode-codepage-char): Re-written and made obsolete.
	(read-charset): Don't use non-iso-charset-alist.
	(describe-coding-system): Use keyword properties.
	(describe-character-set): Re-written.

	* international/mule-conf.el (koi8-u, koi8-t, georgian-ps) 
	(windows-1250, windows-1251, windows-1252, cp1125, ebcdic-us) 
	(ebcdic-uk): New charsets.

	* language/cyrillic.el (koi8-u, koi8-t, windows-1251, cp1125): New
	coding systems.

	* language/european.el (windows-1252): New coding system.

2002-05-16  Kenichi Handa  <handa@etl.go.jp>

	* Makefile.in: By sure to run emacs with LC_ALL=C.

	* international/encoded-kb.el (encoded-kbd-handle-8bit): Call
	encoded-kbd-self-insert-iso2022-8bit with argument 1.
	(encoded-kbd-self-insert-charset): New function.
	(encoded-kbd-setup-keymap): Handle a coding-system of type
	charset.
	(encoded-kbd-mode): Likewise.

2002-05-15  Dave Love  <fx@gnu.org>

	* international/mule-cmds.el (set-locale-environment): Comment out
	set-keyboard-coding-system stuff.

2002-05-14  Kenichi Handa  <handa@etl.go.jp>

	* international/mule.el (define-coding-system): Docstring
	fixed (sjis->shift-jis).

	* international/mule-conf.el: Use decode-char instead of
	make-char.

	* international/encoded-kb.el
	(encoded-kbd-self-insert-iso2022-8bit): New arg ARG.  Directly
	call self-insert-command.   This is a temporary workaround to
	make it work with latin-1.
	(encoded-kbd-mode): Change `sjis' to `shift-jis'.

	* international/characters.el: Setup char-width-table for CJK
	characters.

2002-05-15  Kenichi Handa  <handa@etl.go.jp>

	* international/ja-dic-utl.el (skkdic-jisx0208-hiragana-block):
	Fix the initial value to specify character range of
	japanese-jisx0208, not unicode.

	* international/characters.el: Set syntax/category for
	japanese-jisx0208.

2002-05-14  Dave Love  <fx@gnu.org>

	* mail/sendmail.el (sendmail-send-it): Use :mime-charset, not
	mime-charset.

	* language/vietnamese.el, language/korean.el, language/japanese.el: 
	* language/hebrew.el, language/greek.el, language/chinese.el: 
	Fix :mime-charset properties.

	* language/cyrillic.el (cyrillic-iso-8bit, cyrillic-koi8) 
	(cyrillic-alternativnyj): Fix :mime-charset.
	(cp878, cp866): New alias.

	* language/european.el: Fix mime-charset properties.

	* international/mule-cmds.el (sort-coding-systems) 
	(select-safe-coding-system, select-message-coding-system): Use
	:mime-charset, not 'mime-charset.

	* international/mule-conf.el (utf-8-emacs): Add various
	:mime-charset properties.

2002-05-13  Dave Love  <fx@gnu.org>

	* international/encoded-kb.el (encoded-kbd-self-insert-ccl): Fix
	getting decoder.
	(encoded-kbd-mode): Fix code for coding system type and
	designations.

	* international/mule-conf.el: Speling fixes.

2002-05-13  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el (fontset-plain-name): Handle the case
	that size, weight, slant are not specified in the fontset name.

2002-05-10  Yong Lu <lyongu@asia-infonet.com>

	* language/greek.el (greek-iso-8bit): Fix typo.

2002-05-10  Kenichi Handa  <handa@etl.go.jp>

	* language/chinese.el (chinese-big5): Change :coding-type to
	`charset'.

2002-05-09  Kenichi Handa  <handa@etl.go.jp>

	* international/characters.el: Change encoding to utf-8-emacs.
	Remove apparent duplicate codes.

2002-05-07  Kenichi Handa  <handa@etl.go.jp>

	* international/fontset.el: Change the registry for
	chinese-gb2312 and add the registry for chinese-gbk.

	* international/mule.el (charset-chars): Fix typo.

	* international/mule-conf.el (chinese-gbk): New charset.

	* international/titdic-cnv.el (titdic-convert): Read into a
	unibyte buffer then make the buffer multibyte.

2002-03-07  Kenichi Handa  <handa@etl.go.jp>

	* international/mule-conf.el (utf-16-le): Use :bom attribute
	instead of :signature.
	(utf-16-be): Likewise.

2002-03-05  Kenichi Handa  <handa@etl.go.jp>

	* language/czech.el ("Czech"): Set `iso-8859-2' for
	`nonascii-translation'.

	* language/romanian.el ("Romanian"): Likewise.

	* language/slovak.el ("Slovak"): Likewise.

	* international/characters.el: Optimize calls of
	modify-category-entry.

2002-03-01  Kenichi Handa  <handa@etl.go.jp>

	* bindings.el: Don't bind multibyte characters to
	self-insert-command here.  It's done in mule-conf.el

	* case-table.el (set-case-syntax-offset): Variable deleted.
	(set-case-syntax-1): Function deleted.  Callers changed.
	(set-case-syntax-delims): Don't check byte length of characters.

	* isearch.el (isearch-mode-map): Call set-char-table-range to bind
	characters to isearch-printing-char.

	* loadup.el: Don't load "international/utf-8".  Don't call
	update-coding-systems-internal.  Bind coding-system-for-write to
	`utf-8' while writing fns-XXX.el.  Call clear-charset-maps before
	dumping.

	* version.el (emacs-version): Set to "22.0.0".

	* emacs-lisp/regexp-opt.el (regexp-opt-charset): Adjusted for the
	change of map-char-table.

	* eshell/esh-mode.el: Adjusted for the change of map-char-table.

	* international/characters.el: Adjusted for the deletion of
	generic characters.

	* international/code-pages.el (cp-make-translation-table,
	cp-valid-codes, cp-fix-safe-chars): Deleted.  Caller changed.
	(cp-make-coding-system): Call define-coding-system.

	* international/fontset.el: Mostly re-written.

	* international/ja-dic-cnv.el (skkdic-get-kana-compact-codes):
	Call encode-char instead of split-char.

	* international/ja-dic-utl.el (skkdic-jisx0208-hiragana-block):
	Value changed.
	(skkdic-lookup-key): Call encode-char instead of split-char.

	* international/titdic-cnv.el (titdic-convert): Bind
	coding-system-for-write to 'iso-2022-7bit.  Don't work on unibyte
	buffer.

	* international/latin-1.el: Don't bind set-case-syntax-offset.

	* international/latin-2.el: Don't bind set-case-syntax-offset.

	* international/latin-3.el: Don't bind set-case-syntax-offset.

	* international/latin-4.el: Don't bind set-case-syntax-offset.

	* international/latin-5.el: Don't bind set-case-syntax-offset.

	* international/latin-8.el: Don't bind set-case-syntax-offset.

	* international/latin-9.el: Don't bind set-case-syntax-offset.

	* international/mule-cmds.el: Don't use coding category.  Call
	set-coding-system-priority instead of set-coding-priority.
	(sort-coding-systems): Call coding-system-priority-list to get the
	most preferred one.
	(select-safe-coding-system): Likewise.
	(reset-language-environment): Order of coding system priority
	changed.  Set primary charset to iso-8859-1.
	(set-language-environment-coding-systems): Call
	set-coding-system-priority instead of set-coding-priority.
	(get-charset-property, put-charset-property): Moved to mule.el.

	* international/mule-conf.el: Fully Re-written.

	* international/mule-diag.el (print-designation): Arguments
	changed.
	(print-iso-2022-flags): New function.
	(describe-coding-system): Adjusted for the new structure of coding
	system.
	(describe-current-coding-system): Likewise.

	* international/mule.el (char-valid-p): Make it an alias of
	characterp.
	(define-charset): Fully re-designed.
	(charset-quoted-standard-p): Deleted.
	(charsetp): Moved to charset.c.
	(charset-info, charset-id, charset-bytes, charset-width,
	charset-directioin, charset-iso-graphic-plane,
	charset-reverse-charset): Deleted.
	(charset-dimension, charset-chars, charset-iso-final-char,
	charset-description, charset-short-name, charset-long-name): Call
	charset-plist instead of charset-info.
	(charset-plist, set-charset-plist): Moved to charset.c.
	(get-charset-property, put-charset-property): Moved from
	mule-cmds.el.  Call charset-plist and set-charset-plist.
	(make-char): Deleted.
	(generic-char-p): Make it always return nil.
	(decode-char, encode-char): Moved to charset.c.
	(coding-spec-XXX-idx): Variables deleted.
	(coding-system-iso-2022-flags): New variable.
	(define-coding-system): New function.
	(transform-make-coding-system-args, make-coding-system): Deleted.
	(set-coding-priority): Make it obsolete.
	(after-insert-file-set-buffer-file-coding-system): Adjusted for
	the new coding system structure.
	(find-new-buffer-file-coding-system): Likewise.

	* language/chinese.el, language/cyrillic.el, language/european.el,
	language/greek.el, language/hebrew.el, language/indian.el,
	language/japanese.el, language/korean.el, language/lao.el,
	language/thai.el, language/tibetan.el, language/vietnamese.el:
	Call define-coding-system instead of make-coding-system.  All CCL
	program deleted.

	* textmodes/sgml-mode.el (sgml-mode-map): Use encode-char instead
	of make-char.
	(sgml-char-names-table): Iteration limit fixed.

	* term/mac-win.el: Deleted unnecessary calls of set-fontset-font.
	(ccl-encode-mac-roman-font): Deleted.

	* Makefile.in (DONTCOMPILE): Add latin1-disp.el, ucs-tables.el,
	utf-8.el, and utf-8-subst.el as they can't be bytecompiled
	currently.  This is just a temporary workaround.

2002-02-26  Richard M. Stallman  <rms@gnu.org>

	* paths.el (remote-shell-program): Add doc string.

2002-02-26  Colin Walters  <walters@debian.org>

	* ibuf-ext.el (sorter mode-name): New.
	(ibuffer-do-occur): Don't quote ibuffer-marked-char.

	* calc/calc-ext.el (calc-scroll-left): Call scroll-left
	interactively, so they do something.
	(calc-scroll-right): Ditto.

2002-02-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule.el (ctext-pre-write-conversion): Handle the
	case when FROM is a string, and when we are called from
	build_annotations_2.

2002-02-26  Richard M. Stallman  <rms@gnu.org>

	* rect.el (clear-rectangle-line): Reindent to the same column
	that move-to-column reached when it tried to go to endcol.

	* icomplete.el (icomplete-exhibit): Use minibuffer-prompt-end.

2002-02-26  Ivar Rummelhoff  <ivarru@math.uio.no>

	* winner.el (winner-boring-buffers, winner-set): A window which
	displays a buffer whose name is in the list
	`winner-boring-buffers', will no longer be restored by
	`winner-undo'.
	(winner-sorted-window-list): Used to improve comparison between
	window configurations.
	(winner-win-data): Simplified and moved.
	(winner-conf): Simplified (now uses `winner-win-data').
	(winner-change-fun, winner-save-old-configurations)
	(winner-save-(un)conditionally, winner-redo): Changes made while in
	the minibuffer will be ignored.  (Such changes are undone upon
	exit for the minibuffer, anyway.)
	(winner-set-conf): Preserve selected window whenever possible.
	(winner-make-point-alist): Simplified.
	(winner-mode, winner-save-unconditionally): Save current window
	configuration on entering minibuffer.
	(minor-mode-alist): Don't add winner-mode to `minor-mode-alist',
	since it does not change the overall behavior of Emacs.

2002-02-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule-conf.el (compound-text): Renamed back from
	compound-text-no-extensions.
	(ctext-no-compositions): Remove the mime-charset property.
	(compound-text-with-extensions): Renamed from compound-text.
	(x-ctext-with-extensions, ctext-with-extensions): Renamed aliases.

2002-02-26  Juanma Barranquero  <lektu@terra.es>

	* faces.el (list-faces-display): Fix typo.

2002-02-25  Richard M. Stallman  <rms@gnu.org>

	* frame.el (focus-follows-mouse): Doc fix.

2002-02-26  Miles Bader  <miles@gnu.org>

	* mwheel.el (mouse-wheel-mode): Pass vectors instead of symbols
	to `define-key', since it no longer accepts the latter.

2002-02-25  Jason Rumney  <jasonr@gnu.org>

	* term/w32-win.el (mouse-wheel-scroll-line): Use car of
	mouse-wheel-scroll-amount.

	* w32-vars.el (mouse-wheel-scroll-amount): Use same definition as
	mwheel.el.

	* language/japanese.el (iso-2022-jp-2): Add init-bol flag.

2002-02-25  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-diff-switches-list): Fix prev change, making the macro
	consistent with the others that take a backend name as a symbol.

	* vc-cvs.el, vc-rcs.el, vc-sccs.el: Fix calls to vc-diff-switches-list.

2002-02-25  Kim F. Storm  <no-spam@cua.dk>

	* comint.el (comint-replace-by-expanded-filename): Do nothing if
	comint-match-partial-filename returns nil.

	* shell.el (shell-pcomplete-setup-done): New variable.
	(shell-pcomplete): Use it instead of shell-pcomplete-setup-p.
	(shell-pcomplete-reverse): Ditto.

2002-02-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* ps-print.el (ps-print-printer): Added `lpr' customize group
	member. 

2002-02-25  Juanma Barranquero  <lektu@terra.es>

	* subr.el (save-match-data): Doc fix.

	* ielm.el (ielm-prompt): Allow customization; make it read-only.

2002-02-25  Kim F. Storm  <storm@cua.dk>

	* shell.el (shell-mode-map): Add "Complete" header so completion
	menu is shown on the menu bar in shell mode.

2002-02-25  Stefan Monnier  <monnier@cs.yale.edu>

	* ielm.el (ielm-match-data): New var.
	(inferior-emacs-lisp-mode): Make it buffer-local.
	(ielm-eval-input): Use it to preserve match-data between inputs.

2002-02-24  Juanma Barranquero  <lektu@terra.es>

	* ielm.el (inferior-emacs-lisp-mode): Use hexl for the dummy process.

2002-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-unlispify-remove-prefixes): Add to
	`custom-buffer' customize group.

2002-02-23  Kim F. Storm  <storm@cua.dk>

	* help.el (where-is): Use remap-command.

	* help-fns.el (describe-function-1): Use remap-command.

	* subr.el (global-set-key, local-set-key): Undo 2002-02-06
	change (no longer accept a symbol for the KEY argument).

2002-02-23  Colin Walters  <walters@debian.org>

	* calc/calcalg3.el (calc-invent-variables): Convert integer to string.
	* calc/calcalg2.el (math-solve-get-sign): Ditto.

	* ibuffer.el (ibuffer-compile-format): Don't uselessly bind `pt'
	in generated function.

	* ibuf-ext.el (ibuffer-old-time): Change to hours.
	(ibuffer-mark-old-buffers): Handle it.

	* shell.el (shell-pcomplete, shell-pcomplete-reverse): New functions.
	(toplevel): Bind them.
	(shell-mode): Don't set `comint-dynamic-complete-functions'; it is
	not necessary now that we use pcomplete.

	* comint.el: Document how use new pcomplete completion facility.

2002-02-23  Richard M. Stallman  <rms@gnu.org>

	* mail/rmailsum.el (rmail-summary-output): Properly advance
	to next message, by calling rmail-summary-goto-msg.

	* net/browse-url.el (browse-url-galeon): Specify --existing
	for an existing window.  Use --noraise rather than --no-raise.
	Don't use -x.

2002-02-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/etags.el (find-tag-noselect, find-tag)
	(find-tag-other-window, find-tag-other-frame, find-tag-regexp):
	Fix a typo in doc strings.

2002-02-20  Deepak Goel  <deego@glue.umd.edu>

	* play/snake.el (snake-velocity-queue, snake-update-velocity)
	(snake-final-x-velocity, snake-final-y-velocity):
	New variable and functions.  Store user's keypresses
	into a queue and pop from the queue each subsequent turn.
	(snake-update-game, snake-move-left)
	(snake-move-right, snake-move-up, snake-move-down, snake-active-p)
	(snake-start-game): Use that queue.
	(snake-use-glyphs-flag): Renamed from snake-use-glyphs.
	(snake-use-color-flag): Likewise.
	(snake-mode): Rename uses of those variables.

2002-02-22  Eli Zaretskii  <eliz@is.elta.co.il>

	Support for ICCCM  Extended Segments in X selections:

	* international/mule-conf.el (ctext-no-compositions): New coding
	system.
	(compount-text-no-extensions): Renamed from compound-text.
	(x-ctext-no-extensions, ctext-no-extensions): Aliases for
	compound-text-no-extensions.
	(compound-text): Redefined using post-read and pre-write conversions.

	* international/mule.el (non-standard-icccm-encodings-alist)
	(non-standard-designations-alist): New variables.
	(ctext-post-read-conversion, ctext-pre-write-conversion):
	New functions.

2002-02-21  Andre Spiegel  <spiegel@gnu.org>

	Patch by Jonathan Kamens <jik@kamens.brookline.ma.us>.

	* vc.el (vc-default-init-version): Update documentation to
	indicate that the backend can override the default init version.
	(vc-register): Use the backend init-version function, if it
	exists, to determine the initial version of a file.
	(vc-diff-switches-list): Don't symbol-quote backend, since it's
	already a symbol.  Don't fail if vc-BACKEND-diff-switches isn't bound.

	* vc-hooks.el (vc-mode-line): Set vc-mode to nil if the file is
	not version-controlled.  This is necessary, e.g., if the file has
	just been reverted, and thus was previously under version control
	but isn't any longer.
	(vc-find-file-hook): Likewise.

2002-02-21  Andre Spiegel  <spiegel@gnu.org>

	Patch by Martin.Lorentzson@telia.com.

	* vc-cvs.el (vc-cvs-sticky-date-format-string): New variable.
	(vc-cvs-sticky-tag-display): New variable.
	(vc-cvs-mode-line-string): Add sticky-tag to the mode-line.
	(vc-cvs-checkin): If the input revision is a valid symbolic tag
	name, we create it as a branch, commit and switch to it.
	(vc-cvs-retrieve-snapshot): Set file-property sticky-tag.
	(vc-cvs-valid-symbolic-tag-name-p): New function.
	(vc-cvs-parse-sticky-tag): New function.
	(vc-cvs-parse-entry): Added parsing of sticky tags.

2002-02-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* toolbar/tool-bar.el (tool-bar-mode): Revert the :init-value to
	nil, and then explicitly set the standard-value to t.

2002-02-20  Sam Steingold  <sds@gnu.org>

	* textmodes/flyspell.el (flyspell-mode): Autoload the variable
	since it is used in the menu bar.

2002-02-20  Richard M. Stallman  <rms@gnu.org>

	* simple.el (shell-command-on-region): Display the exit status
	when a command fails.

	* subr.el (add-hook): Doc fix.

	* frame.el (other-frame): Doc fix.

	* simple.el (yank): Clear `field' property.

2002-02-20  Tom Tromey  <tromey@cachet>

	* progmodes/tcl.el (tcl-do-fill-paragraph): Find and fill on more
	natural paragraph boundaries.  Don't fail at beginning of buffer.

2002-02-20  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* tar-mode.el (tar-next-line, tar-previous-line): Add doc string,
	call the argument "arg" to match plain next-line and
	previous-line.  From Kevin Ryde <user42@zip.com.au>.

2002-02-19  Sam Steingold  <sds@gnu.org>

	* mwheel.el (mouse-wheel-scroll-amount): Can specify different
	scroll amounts for different modifiers now.
	(mwheel-scroll): Handle the new `mouse-wheel-scroll-amount'
	format properly.
	(mouse-wheel-mode): Ditto.

2002-02-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* textmodes/bibtex.el (bibtex-parse-keys): Put save-match-data
	around function body.

	* net/browse-url.el (browse-url-maybe-new-window): Reverse the
	sense of the comparison, to match the doc strings of functions
	that use this macro.

2002-02-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* facemenu.el (describe-text-mode-map): Removed bootstrap kludge.

	* toolbar/tool-bar.el (tool-bar-mode): Made the standard value t.
	* menu-bar.el (menu-bar-mode): Ditto.

2002-02-18  Andreas Schwab  <schwab@suse.de>

	* replace.el (query-replace-regexp-eval): Doc fix.

2002-02-18  Colin Walters  <walters@verbum.org>

	* calc/calcalg2.el (math-solve-get-int): Convert return value from
	`math-get-from-counter' to a string before calling `concat' on it.

	* calc/calc-maint.el (calc-split-manual): Look for calc.texi.
	(calc-public-autoloads): Obsolete; remove.
	(calc-private-autoloads): Ditto.
	(calc-add-autoloads): Ditto.

	* calc/calc-macs.el (calc-with-default-simplification): Use &rest
	for body.

2002-02-17  Jason Rumney  <jasonr@gnu.org>

	* w32-win.el (x-option-alist, x-long-option-alist)
	(x-switch-definitions): Remove, use command-line-x-option-alist
	instead to be consistent with X.
	(x-handle-initial-switch): New function.

2002-02-17  Eli Zaretskii  <eliz@is.elta.co.il>

	* faces.el (mode-line-inactive, header-line): Add the :inherit
	attribute for the tty case.

2002-02-17  stanislav shalunov  <shalunov@internet2.edu>

	* mail/uce.el (uce-reply-to-uce): Fix incorrect behavior when
	invoked from Rmail with full headers displayed.

2002-02-17  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* emacs-lisp/lisp.el (mark-defun): Don't leave multiple marks
	when repeated.
	* textmodes/paragraphs.el (mark-paragraph): Ditto.

2002-02-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* menu-bar.el (menu-bar-showhide-menu): Added speedbar.
	(menu-bar-tools-menu): Removed speedbar.

	* textmodes/ispell.el (ispell-menu-map): Added `customize-ispell'
	and `flyspell-mode' entries.

	* textmodes/flyspell.el (flyspell): Add to ispell group.

2002-02-17  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

        * emacs-lisp/lisp.el (mark-sexp): Don't leave multiple marks when
        repeated.
        (mark-defun): Mark more if repeated.

2002-02-17  Colin Walters  <walters@verbum.org>

	* ibuf-ext.el (ibuffer-toggle-sorting-mode): Make it work.

	* ibuffer.el (ibuffer-truncate-lines): New option.
	  (ibuffer-mode):  Use it.

2002-02-17  Kim F. Storm  <storm@cua.dk>

	* cus-start.el: Add mouse-highlight.

2002-02-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* Makefile.in (DONTCOMPILE): Remove cus-start.el.

	* cus-start.el: Add automatic-hscroll-margin and
	automatic-hscroll-step.

2002-02-16  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* cus-start.el (x-autoselect-window): Allow customization.

	* eshell/em-alias.el (eshell-alias-initialize): Do not use
	make-local-hook.

	* eshell/em-cmpl.el (eshell-cmpl-initialize): Likewise.

	* eshell/em-dirs.el (eshell-dirs-initialize): Likewise.

	* eshell/em-glob.el (eshell-glob-initialize): Likewise.

	* eshell/em-hist.el (eshell-hist-initialize): Likewise.

	* eshell/em-pred.el (eshell-pred-initialize): Likewise.

	* eshell/em-prompt.el (eshell-prompt-initialize): Likewise.

	* eshell/em-rebind.el (eshell-rebind-initialize): Likewise.

	* eshell/em-smart.el (eshell-smart-initialize): Likewise.

	* eshell/em-unix.el (eshell-unix-initialize): Likewise.

	* eshell/esh-cmd.el (eshell-cmd-initialize): Likewise.

	* eshell/esh-ext.el (eshell-ext-initialize): Likewise.

	* eshell/esh-io.el (eshell-io-initialize): Likewise.

	* eshell/esh-mode.el (eshell-mode): Likewise.

	* eshell/esh-test.el (eshell-show-usage-metrics): Likewise.

	* eshell/esh-var.el (eshell-var-initialize): Likewise.

	* progmodes/idlw-shell.el (idlwave-shell-mode): Likewise.

	* progmodes/idlwave.el (idlwave-mode): Likewise.

	* textmodes/reftex-sel.el (reftex-select-label-mode)
	(reftex-select-bib-mode): Likewise.

2002-02-16  John Wiegley  <johnw@gnu.org>

	* eshell/em-hist.el (eshell-hist-initialize): When in the
	minibuffer, use the global value of `eshell-history-ring', and
	never save it to disk, or ask to save it to disk.  This allows
	users of session.el to control whether its global state should be
	persisted or not.
	(eshell-add-command-to-history): Don't write Eshell's history out
	to disk, let the governing mode control that upon exit.

2002-02-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/eshell.el (eshell-command): Before reading from the
	minibuffer, add eshell-add-command-to-history to
	minibuffer-exit-hook, and remove it after read-from-minibuffer
	returns.

	* eshell/em-hist.el (eshell-add-input-to-history): New function,
	with most of the code from eshell-add-to-history.
	(eshell-add-command-to-history): New function, to record in
	eshell-history the commands run via eshell-command.
	(eshell-add-to-history): Call eshell-add-command-to-history to do
	most of the work.

2002-02-16  John Wiegley  <johnw@gnu.org>

	* eshell/esh-ext.el (eshell-external-command): Added a fix for
	XEmacs' new dired.el, which adds a global entry in the
	`file-name-handler-alist'.

2002-02-16  John Wiegley  <johnw@gnu.org>

	* align.el (align-region): Added a missing name argument.

2002-02-16  John Wiegley  <johnw@gnu.org>

	* eshell/esh-ext.el (eshell-script-interpreter): Allow whitespace
	after the #! of a shell interpretor specification.

2002-02-15  Richard M. Stallman  <rms@gnu.org>

	* help.el (describe-key-briefly): Make output in INSERT case
	look just like what is displayed in the normal case.

2002-02-15  Andreas Schwab  <schwab@suse.de>

	* textmodes/tex-mode.el (tex-font-lock-keywords-2): Require
	non-letter after specials.

2002-02-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-tools-menu): Add an item for Calculator.

2002-02-15  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* simple.el (mark-word): Mark more if repeated.
	* textmodes/paragraphs.el (mark-paragraph): Ditto.
	(mark-end-of-sentence): Ditto.

2002-02-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (widgetp): Made it more robust.

2002-02-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* facemenu.el (describe-text-done): New function.
	(describe-text-mode-map): New variable.
	(describe-text-mode-hook): New option.
	(describe-text-mode): New function.
	(describe-text-widget): New function.
	(describe-text-sexp): New function.
	(describe-text-properties): New function.
	(describe-text-category): New command.
	(describe-text-at): New command.
	(facemenu-menu): Replace `list-text-properties-at' with
	`describe-text-at' in the menu.

	* wid-edit.el (widgetp): New function.
	* wid-edit.el (widget-keymap, widget-insert, widget-setup):
	Autoloaded.

	* emacs-lisp/pp.el (pp-to-string): Autoloaded.

	* wid-browse.el: Removed version and x-url keywords.

2002-02-13  Kim F. Storm  <storm@cua.dk>

	* cus-start.el (mode-line-in-non-selected-windows):
	Allow customization.

2002-02-13  Richard M. Stallman  <rms@gnu.org>

	* textmodes/bibtex.el (bibtex-parse-buffers-stealthily):
	Tell bibtex-parse-keys to output no progress messages.

	* international/mule-diag.el (list-input-methods):
	Use help-input-method, not describe-input-method, for button type.

	* register.el (describe-register-1): Access register contents here.

	* textmodes/text-mode.el (text-mode-hook-identify):
	Restore previous definition.  Add to text-mode-hook again.

	* mail/mailabbrev.el (define-mail-abbrev): Define as system abbrev.
	(mail-abbrev-in-expansion-header-p): Copy the code of mail-header-end
	to avoid needing sendmail.el at run time.

	* bindings.el (mode-line-minor-mode-keymap): Definition moved up.
	Initialization moved up too.
	(mode-line-modes): Use :propertize.
	(mode-line-mode-menu-keymap): Var deleted.
	(mode-line-copied-mode-name): Var deleted.
	(mode-line-mode-name): Function deleted.
	(mode-line-mode-menu): Each item now shows its mode line lighter.
	(minor-mode-alist): Don't call propertize here.

2002-02-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/pascal.el (pascal-imenu-generic-expression):
	Add menu-title and fix parentheses.

2002-02-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* menu-bar.el (menu-bar-options-save): Removed `truncate-lines'.
	(menu-bar-options-menu): Don't set default value for `truncate-lines'.

2002-02-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* menu-bar.el (menu-bar-options-save): Only save
	`current-language-environment' and `default-input-method' when
	marked as customized.

	* international/mule-cmds.el
	(setup-specified-language-environment):
	Mark `current-language-environment' as customized.
	(set-input-method): Mark `default-input-method' as customized when
	called interactively.
	(toggle-input-method): Ditto.

2002-02-11  Colin Walters  <walters@verbum.org>

	* ibuffer.el (ibuffer-switch-format): Supply required argument for
	`ibuffer-current-formats'.

2002-02-11  Miles Bader  <miles@gnu.org>

	* faces.el (mode-line-inactive): Add dark-background variant.

2002-02-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* toolbar/tool-bar.el (tool-bar-mode): Removed standard value.
	* menu-bar.el (menu-bar-mode): Ditto.
	* cus-edit.el (customize-mark-to-save): Always save variables
	without a standard value.

	* menu-bar.el (menu-bar-make-toggle): Made it aware of customize.
	(menu-bar-options-save): Ditto.
	(menu-bar-showhide-menu): Ditto.
	(menu-bar-options-menu): Ditto.
	(menu-bar-scroll-bar-right, menu-bar-scroll-bar-left)
	(menu-bar-scroll-bar-none): Remove.
	(menu-bar-showhide-scroll-bar-menu): Use customize aware lambda
	expressions instead.

	* cus-edit.el (customize-set-value): Return value.
	(customize-set-variable): Ditto.
	(customize-save-variable): Ditto.
	(customize-set-variable): Load dependencies before setting value.
	(custom-load-symbol): Autoload it.
	(customize-mark-as-set): New function.

2002-02-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* cus-start.el: Don't warn about "x-*" symbols when building a
	non-GUI version.

2002-02-11  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* strokes.el (strokes-do-stroke, strokes-do-complex-stroke):
	Doc fix.
	(strokes-help): Do not use doubled with-output-to-temp-buffer.
	Fix the help string.
	(strokes-prompt-user-save-strokes): Fix typo.
	(strokes-list-strokes): Use proper exit-action argument for
	view-buffer.  Update copyright notice.

	* international/mule-diag.el: Various doc and message fixes.
	(non-iso-charset-alist): Add mac-roman.  Don't add entries for
	codepages already present.
	(list-block-of-chars): Display space for null entries in
	translation table.  Display tab specially.
	(list-non-iso-charset-chars): Check for null charsets.  Use pop
	for clarity.  Don't break 8-bit sets into sections between ranges.
	(list-charset-chars): Avoid indent-tabs-mode.
	(describe-char-after): Maybe use the text property for syntax
	table information.  Maybe report char-code-property-table info.
	Maybe report character's unicode.  Tweak printing of list info.
	(list-input-methods): Add xref buttons.
	(dump-charsets, dump-codings): Deleted (obsolete).
	From Dave Love <fx@gnu.org>.

2002-02-10  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* menu-bar.el (menu-bar-showhide-menu): Rename functions for toggling.

2002-02-10  Michael Kifer  <kifer@cs.stonybrook.edu>

	* viper-util.el (viper-read-key-sequence): Fix so it'll read
	fast key sequences in emacs native mode
	(viper-events-to-keys): Delete.

	* viper.el (describe-key, describe-key-briefly): Get rid of
	viper-events-to-keys.

	* ediff-init.el (ediff-has-gutter-support): Steven Turnbull's patch.

	* ediff-wind.el (ediff-setup-control-frame):
	Use ediff-has-gutter-support.

	* ediff-util.el (ediff-dispose-of-variant-according-to-user):
	check if buff is alive.

	* ediff.el: Typo in comment.

2002-02-09  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* menu-bar.el (menu-bar-options-save): Take care of
	line-number-mode and column-number-mode variables.
	(menu-bar-showhide-menu): New menu-items "Show Line Number" and
	"Show Column Number" in "Show/Hide" menu.

2002-02-09  Richard M. Stallman  <rms@gnu.org>

	* mail/mailabbrev.el (mail-mode-map): Use eval-after-load to change it.

2002-02-09  Kim F. Storm  <storm@cua.dk>

	* faces.el (mode-line-inactive): New face for mode-line for
	non-selected windows.
	(mode-line): Doc fix: Only used for selected window.

2002-02-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* calendar/cal-menu.el (calendar-mode-map): Change the menu item's
	name to "Insert Diary Entry".

2002-02-08  Stefan Monnier  <monnier@cs.yale.edu>

	* font-lock.el (save-buffer-state): Use restore-buffer-modified-p.
	(c-font-lock-syntactic-face-function): Accept doxygen-style comments.

2002-02-08  Richard M. Stallman  <rms@gnu.org>

	* textmodes/text-mode.el (text-mode-hook-identify): Define as no-op.

2002-02-08  Andreas Schwab  <schwab@suse.de>

	* calc/calc.el (calcDigit-key): Use minibuffer-prompt-end instead
	of point-min.

2002-02-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* net/ange-ftp.el (ange-ftp-process-handle-line)
	(ange-ftp-set-xfer-size): If the file's size is a float, divide
	by 1024 instead of using ash.

	* international/mule-cmds.el (select-safe-coding-system):
	State the buffer's name in the message popped in the *Warning* buffer,
	and make sure the offending buffer is displayed.

2002-02-07  Markus Rost  <rost@math.ohio-state.edu>

	* ffap.el (ffap-newsgroup-p): Test for non-nil symbol-value of htb.

2002-02-07  Richard M. Stallman  <rms@gnu.org>

	* terminal.el (terminal-map): Define [menu-bar] so global def is seen.

	* register.el (list-registers): New command.
	(describe-register-1): New subroutine, taken out of view-register.

	* emacs-lisp/copyright.el (copyright-regexp):
	Delete the unibyte copyright symbol; it's redundant.
	Fix a spazz in the multibyte encoding here.

2002-02-07  Dave Love  <fx@gnu.org>

	* language/cyril-util.el (cyrillic-encode-koi8-r-char)
	(cyrillic-encode-alternativnyj-char): Get translation tables from
	symbol properties, not as variables.
	(standard-display-cyrillic-translit): Include unicodes.

2002-02-06  Kim F. Storm  <storm@cua.dk>

	* help.el (where-is): Report remapped commands.

	* help-fns.el (describe-function-1): Ditto.

	* subr.el (global-set-key, local-set-key): Accept a symbol for the
	KEY argument (like define-key).

2002-02-06  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* textmodes/flyspell.el (flyspell-insert-function): Doc fix.

2002-02-06  Richard M. Stallman  <rms@gnu.org>

	* mail/mailabbrev.el: Require sendmail only at compile time.
	(mail-mode-header-syntax-table): Var deleted.
	(mail-abbrev-syntax-table): Init to nil, will compute when needed.
	(sendmail-pre-abbrev-expand-hook): Only temporarily change
	local-abbrev-table and the syntax table.
	Compute mail-abbrev-syntax-table if that has not been done.

	* progmodes/compile.el (grep-compute-defaults): Definition moved up.

	* emacs-lisp/debug.el (debugger-frame-offset): Var deleted.
	(debugger-frame-number): Figure out the offset directly.
	(debugger-setup-buffer): Don't use debugger-frame-offset.
	(debugger-frame, debugger-frame-clear): Likewise.
	(debugger-jump): Don't alter debugger-frame-offset.

	* emacs-lisp/checkdoc.el (checkdoc-this-string-valid-engine):
	Replace foo-p as var name with foo-flag, not foo-p-flag.

	* hilit-chg.el (highlight-changes-active-string): Default to +Chg.
	(highlight-changes-passive-string): Default to -Chg.
	(highlight-changes-global-modes): Doc fix.

	* dired.el (dired-get-filename): Add /: when appropriate
	to avoid taking a local name as remote.

	* files.el (file-name-non-special): Add special handling for
	file-name-sans-versions, file-name-completion, and
	file-name-all-completions.

	* isearch.el (isearch-update): Don't update display in kbd macro.
	(isearch-lazy-highlight-new-loop): Do nothing in kbd macro.

	* subr.el (force-mode-line-update): Doc fix.

	* subr.el (atomic-change-group, prepare-change-group)
	(activate-change-group, accept-change-group, cancel-change-group):
	New functions.

	* simple.el (undo-get-state, undo-revert-to-state): Fns deleted.
	(transpose-subr-1): Use atomic-change-group.

	* subr.el (add-minor-mode): Include the mode's lighter string
	in the minor mode menu item name.

	* mail/rmail.el (rmail-toggle-header): Avoid possibly slow call to
	rmail-count-screen-lines starting from (point-min).

	* startup.el (use-fancy-splash-screens-p): Need 19 lines,
	beyond the image height, to use the fancy splash screen.

	* textmodes/text-mode.el (text-mode-hook-identify): Function deleted.
	(text-mode): Set text-mode-variant here.

2002-02-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* play/pong.el (pong-height): Don't use height that exceeds the
	frame height.
	(pong-border-options): Make the border colors slightly more bright.

	* play/gamegrid.el (gamegrid-display-type): Treat any
	color-capable display as color-x, if display-color-p is fboundp.
	(gamegrid-make-color-x-face): Don't call gamegrid-color twice.
	(gamegrid-make-color-tty-face): Use the value of color, not the
	symbol itself.  Don't call gamegrid-color.

2002-02-05  Eli Zaretskii  <eliz@is.elta.co.il>

	* gud.el (gud-refresh): Call recenter only after we are sure we
	are in the right window.

2002-02-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (customize-mark-to-save): New function.
	* menu-bar.el (menu-bar-options-save): Rewrote.

2002-02-05  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* cus-start.el (x-use-underline-position-properties):
	Allow customization.

2002-02-04  Simon Josefsson  <jas@extundo.com>

	* dired.el (dired-load-hook, dired-mode-hook)
	(dired-before-readin-hook, dired-after-readin-hook): Defcustom.

2002-02-03  Colin Walters  <walters@verbum.org>

	* ibuf-ext.el (ibuffer-filter-format-alist)
	(ibuffer-cached-filter-formats, ibuffer-compiled-filter-formats):
	New variables.
	* ibuffer.el (ibuffer): Remove link; the "home page" for ibuffer
	is now the Emacs CVS tree.
	(ibuffer-formats): Doc fix.
	(ibuffer-active-formats-name, ibuffer-current-formats): New functions.
	(ibuffer-current-format): Use them.
	(ibuffer-recompile-formats, ibuffer-check-formats)
	(ibuffer-switch-format, ibuffer-update-title):
	Add support for ibuffer-filter-format-alist.
	(define-ibuffer-column process): Remove unncessary consing.

	* ibuf-macs.el (define-ibuffer-column): Add beginnings of support
	for a summary column.

2002-02-03  Andreas Schwab  <schwab@suse.de>

	* window.el (save-selected-window): Move macro before first use.
	(balance-windows): Fix misplaced parenthesis.

2002-02-03  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* calculator.el (calculator-displayers): Doc fixes.

2002-02-03  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* menu-bar.el (menu-bar-help-menu): Use different text for tool-tip.
	(menu-bar-options-save): Save also the value of `display-time-mode'.
	(showhide-date-time): New function.
	(menu-bar-showhide-menu): New menu-item "Date and time".

2002-02-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/rmail.el (rmail): Use find-buffer-visiting instead of
	get-file-buffer to check for rmail buffer existence.

	* term.el (term-emulate-terminal): Extract proper command string
	which is supplied to term-command-hook.

2002-02-03  Richard M. Stallman  <rms@gnu.org>

	* international/quail.el (quail-help): Don't call help-setup-xref.

	* international/mule-cmds.el (describe-input-method):
	Call help-setup-xref here.
	(describe-current-input-method): Doc fix.

	* novice.el (disabled-command-hook): Clarify output text.
	Indent the paragraph from the command's doc string.

	* dabbrev.el (dabbrev--goto-start-of-abbrev):
	Exit loop on beginning of field rather than bobp.

2002-02-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/uce.el (uce-reply-to-uce): Prune the headers before copying
	the message text into the *mail* buffer, and restore the pruned
	state after that.

	* mail/rmail.el (rmail-redecode-body): Prune the headers before
	looking for X-Coding-System header, and restore the pruned state
	before returning.

2002-02-02  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* cus-edit.el (customize-save-variable): Fix typo in prompt.

	These changes integrate new version of flyspell.el from its
	maintainer, Manuel Serrano:

	* textmodes/flyspell.el (flyspell-issue-message-flag): New user option.
	(flyspell-mode-on, flyspell-notify-misspell)
	(flyspell-small-region, flyspell-external-point-words)
	(flyspell-large-region): Use it
	(flyspell-before-incorrect-word-string)
	(flyspell-after-incorrect-word-string): New user options.
	(make-flyspell-overlay): Use them.
	(flyspell-version): New function.
	(flyspell-incorrect-face, flyspell-duplicate-face): Adapt face
	definitions to use :weight.
	(flyspell-insert-function): New user option.
	(flyspell-auto-correct-word, flyspell-correct-word)
	(flyspell-xemacs-correct): Use it.
	(flyspell-define-abbrev): New function.
	(flyspell-auto-correct-word, flyspell-correct-word)
	(flyspell-xemacs-correct): Use it.
	(make-flyspell-overlay): Use `evaporate' property.
	(flyspell-auto-correct-word, flyspell-correct-word): Remove overlay.
	(flyspell-emacs-popup): Use `session' instead of `accept'.
	(flyspell-auto-correct-previous-pos): New variable.
	(flyspell-auto-correct-previous-hook)
	(flyspell-auto-correct-previous-word): New functions.

2002-02-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* novice.el (enable-command): If Emacs was invoked as "emacs -q",
	don't alter the user's ~/.emacs.
	(disable-command): If user-init-file is nil or does not exist,
	default to "~/.emacs" (~/_emacs on DOS and, maybe, Windows).
	But don't alter the init file if Emacs was invoked as "emacs -q"

2002-02-01  Stefan Monnier  <monnier@cs.yale.edu>

	* mail/sendmail.el (mail-mode): Undo half of last change.

	* indent.el (indent-for-tab-command): Remove spurious code.

	* hi-lock.el (hi-lock-find-patterns): Save restriction.

2002-02-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* calendar/time-date.el: Moved from lisp/gnus.

	* calendar/parse-time.el: Ditto.

2002-01-31  Richard M. Stallman  <rms@gnu.org>

	* international/iso-acc.el (iso-languages): Fix ", " in French.

	* cus-start.el (history-length): Specify customization for it.

	* emacs-lisp/debug.el (debugger-setup-buffer):
	When an eval-buffer frame was reading from a buffer,
	insert indication of the buffer position.
	(debugger-frame-number): Ignore ;;;-comment lines in backtrace.
	(debugger-frame-clear, debugger-frame): Error on non-frame line.

	* simple.el (shell-command-on-region): Err if no mark
	before reading the command string.

	* hl-line.el (hl-line-highlight, hl-line-unhighlight):
	Definitions moved down after hl-line-mode var's definition.

	* hilit-chg.el (hilit-chg-fixup): Don't alter overlay if not ours.
	(hilit-chg-set-face-on-change): Rename arg.
	(hilit-chg-make-ov): Detect error earlier.

	* ediff-hook.el: Delete autoload cookies.

	* comint.el (comint-scroll-show-maximum-output): Default is t.

	* emacs-lisp/bytecomp.el (batch-byte-compile): New arg noforce.
	(batch-byte-compile-if-not-done): New function.

	* Makefile.in (compile): New target.
	(compile-always): Renamed from compile-files.
	(compile-after-backup): Renamed from compile.
	(bootstrap): Depend on compile-always, not compile-files.

	* emulation/pc-select.el (pc-select-save-and-set-mode):
	Properly use MODE-VAR.

2002-01-29  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* menu-bar.el (menu-bar-help-menu): Change menu-item "Show Emacs
	Version" to "About Emacs".
	(menu-bar-options-save): Add `default-frame-alist'
	to saved variables.
	(menu-bar-showhide-scroll-bar-menu): Use frame-parameters instead
	of the variable `scroll-bar-mode'.

	* startup.el (normal-splash-screen, display-splash-screen):
	New functions (separated from command-line-1).
	(command-line-1): Use them.

2002-01-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* calendar/calendar.el (generate-calendar-month): Doc fix.

2002-01-27  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* time.el (display-time-mail-directory): New option.
	(display-time-mail-function): Update doc-string.
	(display-time-mail-icon): Use XPM image when available.
	(display-time-string-forms): Use more descriptive text as
	help-echo property.
	(display-time-mail-check-directory): New function.
	(display-time-update): Use it.

	* menu-bar.el (menu-bar-showhide-scroll-bar-menu):
	Quote `window-system'.

	* tmm.el (tmm-get-keymap): Honour :visible in `menu-item'.
	Add Keywords header.  Update Commentary section.
	Update copyright notice.

	* menu-bar.el (menu-bar-scroll-bar-right)
	(menu-bar-scroll-bar-left, menu-bar-scroll-bar-none)
	(showhide-menu-bar): New functions.
	(menu-bar-showhide-menu): New submenu "Show/Hide".
	(menu-bar-showhide-scroll-bar-menu): "Scroll-bar" submenu of
	"Show/Hide".
	Update copyright notice.

2002-01-27  Eli Zaretskii  <eliz@is.elta.co.il>

	* lazy-lock.el (lazy-lock-mode): Add a reference to jit-lock.

2002-01-26  Evgeny Roubinchtein  <evgenyr@cs.washington.edu>

	* pc-select.el (pc-selection-mode-hook)
	(pc-select-saved-settings-alist, pc-select-map)
	(pc-select-saved-global-map, pc-select-key-bindings-alist)
	(pc-select-default-key-bindings, pc-select-extra-key-bindings)
	(pc-select-meta-moves-sexps-key-bindings)
	(pc-select-tty-key-bindings, pc-select-old-M-delete-binding):
	New variables.
	(pc-select-define-keys, pc-select-restore-keys): New functions.
	(pc-select-add-to-alist, pc-select-save-and-set-var)
	(pc-select-save-and-set-mode, pc-select-restore-var)
	(pc-select-restore-mode): New macros.
	(pc-selection-mode): Completely rewrote the body of the function;
	the main goal was to make pc-selection-mode "turn-off"-able, like
	other minor modes.  Use define-minore-mode instead of just a
	defun.  Store the key bindings into four alists:
	pc-select-default-key-bindings, pc-select-extra-key-bindings,
	pc-select-meta-moves-sexps-key-bindings, and
	pc-select-tty-key-bindings; then have the pc-select-define-keys
	function walk those alists instead of calling define-key
	repeatedly.  When the mode is turned on, set the
	keybindings in global-map and remember the old keybindings; when
	the mode is turned off, restore the previously-saved keybindings.
	(pc-selection-mode defcustom): Reflect the fact that the mode is
	now "turn-off"-able.

2002-01-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/esh-cmd.el (eshell-eval-command): If eshell-resume-eval
	returns t, don't treat that as an error.

2002-01-25  Jason Rumney  <jasonr@gnu.org>

	* faces.el (face-font-registry-alternatives) [windows-nt]:
	Add ms-oemlatin as an alternative for iso8859-1.

2002-01-25  Stefan Monnier  <monnier@cs.yale.edu>

	* pcvs.el (cvs-reread-cvsrc): Distinguish between an empty list of
	args and the absence of an entry.  Don't add -f each time.

2002-01-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* emacs-lisp/cl-seq.el (mismatch): Doc fix.

	Support for more than 8 colors on character terminals:

	* term/rxvt.el: New file.

	* Makefile.in (DONTCOMPILE): Remove term/xterm.el.

	* term/xterm.el (xterm-standard-colors): New variable.
	(xterm-rgb-convert-to-16bit, xterm-register-default-colors)
	(xterm-rxvt-set-background-mode): New functions.
	(toplevel): Call xterm-register-default-colors,
	xterm-rxvt-set-background-mode, and tty-set-up-initial-frame-faces.
	Add support for more keys from xterm's terminfo entry.

	* facemenu.el (list-colors-display): If the argument is nil, don't
	show more colors that the number returned by display-color-cells.

	* term/pc-win.el (msdos-color-values): Reverse the order of the
	colors, since tty-color-define now preserves the registration order.

	* w32-fns.el (w32-tty-standard-colors): Reverse the order.

	* term/tty-colors.el (tty-standard-colors): Reverse the order.
	(tty-register-default-colors): New function; code moved from
	startup.el's command-line.
	(tty-modify-color-alist): Use nconc instead of cons, to preserve
	the order the colors where registered.

	* frame.el (display-color-cells): Use tty-display-color-cells.

	* startup.el (command-line): Call tty-register-default-colors.

2002-01-25  Richard M. Stallman  <rms@gnu.org>

	* subr.el (remove): Doc fix.

2002-01-24  Richard M. Stallman  <rms@gnu.org>

	* progmodes/compile.el (compilation-handle-exit):
	Add a compilation-handle-exit property to the "finished" message.
	(compilation-parse-errors): Stop parsing when that property is seen.

	* subr.el (substring-no-properties): New function.
	(copy-without-properties): Function deleted.

	* term/x-win.el (x-handle-geometry): Put sizes on both
	initial-frame-alist and default-frame-alist.

	* cus-edit.el (custom-save-all): Bind file-precious-flag to t
	for saving .emacs.

	* files.el (basic-save-buffer-2): Ignore file-error in delete-file.

	* calendar/calendar.el (generate-calendar-month): Doc fix.

2002-01-23  Richard M. Stallman  <rms@gnu.org>

	* play/tetris.el (tetris): New defgroup.
	(tetris-use-glyphs, tetris-use-color, tetris-draw-border-with-glyphs)
	(tetris-default-tick-period): Convert to defcustom.
	Added * in docstring to indicate user variable.
	(tetris-update-speed-function, tetris-mode-hook, tetris-tty-colors)
	(tetris-x-colors, tetris-buffer-name, tetris-buffer-width)
	(tetris-buffer-height, tetris-width, tetris-height)
	(tetris-top-left-x, tetris-top-left-y): Convert to defcustom.

2002-01-22  Stefan Monnier  <monnier@cs.yale.edu>

	* mail/sendmail.el (mail-mode): ">" is not a supercite-style prefix
	and is already matched by adaptive-fill-regexp.

2002-01-22  Richard M. Stallman  <rms@gnu.org>

	* bindings.el (mode-line-copied-mode-name): New variable.
	(mode-line-mode-name): Don't modify mode-name itself!
	Instead, make a copy and reuse it.

	* subr.el (copy-without-properties): New function.

	* progmodes/sh-script.el (sh-set-shell): Doc fix.

	* net/ange-ftp.el (ange-ftp-canonize-filename): Avoid duplicate
	slash if DIR is just slash.

	* progmodes/perl-mode.el (perl-mode-abbrev-table): Restore definition.

2002-01-21  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/copyright.el (copyright-regexp): Fix previous change.

	* net/ange-ftp.el (ange-ftp-bs2000-posix-hook-installed):
	Move defvar up.

	* textmodes/ispell.el (ispell-help): Clean up echo area if user quits.

	* ibuffer.el: Don't require ibuf-ext at load time.
	(ibuffer): Require ibuf-ext here.

2002-01-21  Francesco Potorti`  <pot@gnu.org>

	* generic-x.el (apache-conf-generic-mode): Highlight the first
	word in a line even if preceded by blanks.

2002-01-21  Richard M. Stallman  <rms@gnu.org>

	* window.el (window-body-height): Handle minibuffer window specially.
	Otherwise, don't return less than 1.

2002-01-20  Thomas Dorner  <Thomas.Dorner@start.de>

	* ange-ftp.el: Added support for BS2000, and for raw ftp
	login commands (needed in some circumstances).
	(ange-ftp-raw-login): New custom var.
	(ange-ftp-normal-login): Perform login with raw ftp commands, if
	ange-ftp-raw-login is set and account password is needed.
	(ange-ftp-host-type, ange-ftp-guess-host-type): Handle BS2000 hosts.
	(ange-ftp-bs2000-filename-pubset-regexp)
	(ange-ftp-bs2000-filename-username-regexp)
	(ange-ftp-bs2000-filename-prefix-regexp)
	(ange-ftp-bs2000-name-template): New consts.
	(ange-ftp-bs2000-short-filename-regexp)
	(ange-ftp-bs2000-fix-name-regexp-reverse)
	(ange-ftp-bs2000-fix-name-regexp): New consts.
	(ange-ftp-bs2000-special-prefix): New custom var.
	(ange-ftp-fix-name-for-bs2000)
	(ange-ftp-fix-dir-name-for-bs2000): New funs.
	(ange-ftp-bs2000-host-regexp, ange-ftp-bs2000-posix-host-regexp)
	(ange-ftp-bs2000-posix-hook-installed): New vars.
	(ange-ftp-parse-bs2000-filename, ange-ftp-parse-bs2000-listing)
	(ange-ftp-bs2000-host, ange-ftp-bs2000-posix-host)
	(ange-ftp-add-bs2000-host, ange-ftp-add-bs2000-posix-host): New funs.
	(ange-ftp-bs2000-filename-regexp): New const.
	(ange-ftp-bs2000-additional-pubsets): New custom var.
	(ange-ftp-bs2000-cd-to-posix): New fun.

2002-01-20  Colin Walters  <walters@verbum.org>

	* ibuffer.el: (toplevel) Require `ibuf-ext', which is now compiled
	with `byte-compile-dynamic'.
	(ibuffer-default-directory, toplevel): Doc files.

2002-01-20  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* tempo.el (tempo-define-template): Doc fix.

	* scroll-bar.el (scroll-bar-mode): Make argument optional.

2002-01-20  Jason Rumney  <jasonr@gnu.org>

	* w32-vars.el: New file.

	* loadup.el [windows-nt]: Load it.

	* w32-fns.el, term/w32-win.el: Move user variables to w32-vars.el
	and make them defcustoms.

	* term/w32-win.el (mouse-set-font): Use w32-list-proportional-fonts.

2002-01-19  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* language/tibet-util.el (tibetan-decompose-region)
	(tibetan-decompose-string): Fix typo in docstring.

	* ruler-mode.el (ruler-mode): New keyword.  Fix :version.

2002-01-18  Richard M. Stallman  <rms@gnu.org>

	* comint.el (comint-redirect-send-command-to-process):
	Restore previous current buffer.

	* window.el (window-body-height): New function.

2002-01-18  Zoltan Kemenczy  <kemenczy@rogers.com>

	* gud.el (easy-mmode-defmap): Enable "Up Stack", "Down Stack", and
	"Finish Function" menu map entries for jdb mode.
	(gud-jdb-use-classpath): New customization variable.
	(gud-jdb-command-name): Add customization.
	(gud-jdb-classpath, gud-marker-acc-max-length): New variables.
	(gud-jdb-classpath-string): New variable.
	(gud-jdb-source-files, gud-jdb-class-source-alist): Add doc strings.
	(gud-jdb-build-source-files-list): Likewise.
	(gud-jdb-massage-args): Record any command argument classpath
	string in `gud-jdb-classpath-string'.
	(gud-jdb-lowest-stack-level): New function, finds bottom of current
	java call stack in jdb output.
	(gud-jdb-find-source-using-classpath, gud-jdb-find-source)
	(gud-jdb-parse-classpath-string): New functions.
	(gud-jdb-marker-filter): Search/detect classpath information in
	jdb's output.  marker regexp updated to match oldjdb and jdb output
	formats.  Expand search for source files to include new/old methods
	using new functions above.  Do not allow `gud-marker-acc' to grow
	without bound.
	(jdb): Set classpath information (if available) as jdb is started.
	Change `gud-break' and `gud-remove'
	to use new %c ("class") escape in format strings.  Add
	`gud-finish', `gud-up', `gud-down' command string functions, and
	add them to the local menu map.  Update `comint-prompt-regexp' for
	jdb and oldjdb.  If attaching to an already running java VM and
	configured to use classpath, send command to query for classpath,
	else use previous method for finding and parsing java
	sources.  Set `gud-jdb-find-source' function accordingly.
	(gud-mode): Doc fix.
	(gud-format-command): Add support for new %c ("class") escape.
	(gud-find-class): New function in support of %c escape.

2002-01-17  Richard M. Stallman  <rms@gnu.org>

	* ibuf-ext.el: Enable byte-compile-dynamic.

2002-01-17  Jason Rumney  <jasonr@gnu.org>

	* term/w32-win.el: Restore conditional require of fontset.

2002-01-16  Richard M. Stallman  <rms@gnu.org>

	* mouse.el (mouse-drag-region-1): Renamed from mouse-drag-region,
	more or less.
	(mouse-drag-region): New function.  For a click in the echo area,
	show *Messages*.

	* ibuf-ext.el: Delete the autoloads for functions defined with
	ibuffer-specific commands.

	* help.el (describe-distribution): Really call view-file.

	* net/ange-ftp.el (ange-ftp-passive-mode): New arg PROC.
	(ange-ftp-get-process): Pass that arg.

	* comint.el (comint-simple-send): Fix previous change.

	* net/telnet.el (telnet-simple-send): Fix previous change.

	* progmodes/sql.el (sql-escape-newlines-and-send)
	(sql-query-placeholders-and-send): Fix previous change.

2002-01-16  Colin Walters  <walters@verbum.org>

	* ibuf-ext.el, ibuf-macs.el, ibuffer.el (toplevel): Remove X-RCS,
	URL, Compatibility headers.  Update copyright notice.
	* ibuf-macs.el (toplevel): Require `cl' when compiling.

2002-01-16  Andrew Choi  <akochoi@cse.cuhk.edu.hk>

	* startup.el (command-line): Set EOL mnemonics for the Mac.

2002-01-16  Andreas Schwab  <schwab@suse.de>

	* mail/feedmail.el (feedmail): Fix :link spec.

2002-01-16  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* net/ldap.el (ldap-ldapsearch-prog): Default to OpenLDAP version
	2 ldapsearch.

	* net/eudc.el: New maintainer.  Change author's address.
	(eudc-pre-select-window-configuration, eudc-insertion-marker):
	Variables removed.
	(eudc-insert-selected): Function removed.
	(eudc-select): Reimplemented.
	(eudc-expand-inline): Delete the strings only after its expansion
	is chosen not before.

	* net/eudcb-ph.el (eudc-ph-open-session): Remove XEmacs case.
	Minor coding style fixes.

	* net/eudcb-ldap.el: New maintainer.  Change author's address.
	(eudc-attribute-display-method-alist): Display mail with
	eudc-display-mail.

	* net/eudcb-bbdb.el, net/eudc-export.el, net/eudc-hotlist.el,
	* net/eudc-vars.el: New maintainer.  Change author's address.

	* net/eudc-bob.el: New maintainer.  Change author's address.
	(eudc-bob-mail-keymap): New keymap for e-mail addresses.
	(eudc-display-mail): New function.
	(eudc-bob-play-sound-at-point): Remove XEmacs case.

2002-01-15  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/autoload.el (make-autoload):
	Don't handle define-ibuffer-column, define-ibuffer-filter,
	define-ibuffer-sorter, and define-ibuffer-op.

2002-01-14  Richard M. Stallman  <rms@gnu.org>

	* calendar/calendar.el (diary-date-forms): Doc fix.

2002-01-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* startup.el (command-line): Register the default tty colors even
	if the terminal doesn't seem to support colors.
	<tty-long-option-alist>: New option --color.
	(tty-handle-args): Parse the --color arg.

	* term/tty-colors.el (tty-color-mode-alist): New variable.

2002-01-14  Stefan Monnier  <monnier@cs.yale.edu>

	* net/ange-ftp.el (ange-ftp-root-dir-p): New function.
	(ange-ftp-file-name-all-completions, ange-ftp-file-name-completion):
	Use it.
	(ange-ftp-hook-function): Preserve match-data.
	(ange-ftp-insert-directory): Typo.
	(ange-ftp-shell-command): Check if regexp matched.

2002-01-13  Richard M. Stallman  <rms@gnu.org>

	* international/mule-cmds.el: help-map bindings moved to help.el.

	* help.el (view-echo-area-messages): New function.
	(help-map): Add `e' binding.  Delete obsolete `d' binding.
	Change old Info bindings C-f, C-k and C-i to F, K, S.
	Move view-emacs-FAQ from F to C-f.
	Move view-emacs-problems from P to C-e.
	Bindings moved here from mule-cmds.el.
	C-l binding for describe-language-environment deleted
	(help-for-help): Update for all these changes.

	* emacs-lisp/copyright.el (copyright-regexp): Make (C) optional.

2002-01-13  Dave Love  <fx@gnu.org>

	* emacs-lisp/copyright.el: Doc fixes.
	(copyright-regexp): Add Latin-9 copyright sign.
	Match comment delimiters in year lists.
	(copyright-current-year): Initialize to load-time year.

2002-01-13  Andreas Schwab  <schwab@suse.de>

	* dired-aux.el (dired-do-shell-command): Doc fix.

2002-01-13  Jan Djarv  <Jan.Djarv@mbox200.swipnet.se>

	* startup.el (command-line-x-option-alist): New options "-fs",
	"-fw", "-fh", "--fullscreen", "--fullwidth", and "--fullheight".

	* term/x-win.el (x-handle-initial-switch): New function.

2002-01-13  Colin Walters  <walters@debian.org>

	* emacs-lisp/autoload.el (make-autoload): Handle
	define-ibuffer-column, define-ibuffer-filter,
	define-ibuffer-sorter, and define-ibuffer-op.

	* emacs-lisp/lisp-mode.el (toplevel): Ditto.

	* ibuffer.el, ibuf-ext.el, ibuf-macs.el: New files.

2002-01-12  Richard M. Stallman  <rms@gnu.org>

	* net/browse-url.el (browse-url-grail):
	Use browse-url-maybe-new-window.

	* net/telnet.el (telnet-simple-send): Handle
	comint-input-sender-no-newline like comint-simple-send.

	* progmodes/sql.el (sql-query-placeholders-and-send): Handle
	comint-input-sender-no-newline like comint-simple-send.
	(sql-escape-newlines-and-send): Likewise.

	* comint.el (comint-input-sender): Doc fix.
	(comint-input-sender-no-newline): New variable.
	(comint-simple-send): If comint-input-sender-no-newline,
	don't output newline, but maybe send eof.
	(comint-send-input): New arg NO-NEWLINE.
	(comint-send-eof): Call comint-send-eof with NO-NEWLINE.

2002-01-12  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* textmodes/flyspell.el (flyspell-check-pre-word-p): Prevent
	delaying when executing keyboard macros.

2002-01-12  Richard M. Stallman  <rms@gnu.org>

	* simple.el (line-move): If we can't move enough lines,
	go to beginning or end of line.

	* help-mode.el (help-xref-go-back): Restore POSITION in proper buffer
	and proper window.

	* help.el (describe-mode): Call help-setup-xref in the help buffer.
	Switch buffers only after calling `help-buffer'.

	* dired-aux.el (dired-shell-stuff-it): Substitute for * or ?
	only when they are surrounded by whitespace.
	Use dired-mark-separator when adding one file name to a command.
	(dired-do-shell-command): Verify that * is surrounded by whitespace.
	Ask for confirmation if * or ? is not surrounded by whitespace.
	(dired-bunch-files): Re-reverse the partial file list when it is used.

2002-01-12  Richard M. Stallman  <rms@gnu.org>

	* comint.el (comint-dynamic-list-completions): Repeating the command
	after displaying a completion list scrolls the list.

2002-01-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (find-file-noselect): Don't consider a buffer as
	visiting a file literally if it is in hexl-mode.

	* faces.el (minibuffer-prompt): A better face definition for MS-DOS.

2002-01-11  Richard M. Stallman  <rms@gnu.org>

	* startup.el (initial-scratch-message): Fix custom type, add group.

	* mail/rmail.el (rmail-decode-babyl-format): Disable undo
	around the decode-coding-region call.

	* emacs-lisp/lisp.el (lisp-complete-symbol): Repeating the command
	after displaying a completion list scrolls the list.

2002-01-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* version.el (emacs-version): Bump to 21.2.50.

2002-01-10  Thien-Thi Nguyen  <ttn@giblet.glug.org>

	* play/zone.el (zone-timeout): New var.
	(zone-hiding-modeline): New macro.
	(zone-call): New func.

	(zone): Init `modeline-hidden-level' symbol property.
	Use `zone-call' instead of `funcall'.

	(zone-pgm-whack-chars): Use `make-string' (fix bug introduced in 1.7).

	(zone-pgm-stress): Use `zone-hiding-modeline'.

	(zone-pgm-stress-destress): New zone program.

2002-01-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* faces.el (minibuffer-prompt): Special face definition for MS-DOS.

2002-01-09  Richard M. Stallman  <rms@gnu.org>

	* startup.el (fancy-splash-screens): Set tab-width in correct buffer.

2002-01-09  Michael Kifer  <kifer@cs.stonybrook.edu>

	* viper.el (viper-set-hooks): Zap viper-unfriendly bindings in
	flyspell-mouse-map.

2002-01-08  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/regexp-opt.el (regexp-opt): Bind max-specpdl-size.

	* emacs-lisp/eldoc.el (eldoc-minor-mode-string): Fix custom type.

	* textmodes/flyspell.el (flyspell-mode-line-string): Fix custom type.

2002-01-08  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* progmodes/ada-mode.el (ada-initialize-properties, ada-mode):
	Do not use make-local-hook.

2002-01-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/quail.el (quail-start-translation)
	(quail-start-conversion): Bind last-command-event, last-command,
	and this-command in the first let.  This fixes the change from
	2000-08-30.

2002-01-08  Michael Kifer  <kifer@cs.stonybrook.edu>

	* ediff-hook.el: Add an autoload cookie.

2002-01-08  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* net/eudcb-ph.el, net/ldap.el: New maintainer.  New e-mail
	address of the author.

2002-01-08  Richard M. Stallman  <rms@gnu.org>

	* replace.el (occur-mode-goto-occurrence-other-window): New command.
	(occur-mode-map): Bind `o' to that.

2002-01-07  Michael Kifer  <kifer@cs.stonybrook.edu>

	* viper-init.el (viper-cond-compile-for-xemacs-or-emacs):
	new macro that replaces viper-emacs-p and viper-xemacs-p in many
	cases. Used to reduce the number of warnings.

	* viper-cmd.el: Use viper-cond-compile-for-xemacs-or-emacs.
	(viper-standard-value): Move here from viper.el.
	(viper-set-unread-command-events): Move to viper-util.el
	(viper-check-minibuffer-overlay): Make sure
	viper-minibuffer-overlay is moved to cover the entire input field.

	* viper-util.el:  use viper-cond-compile-for-xemacs-or-emacs.
	(viper-read-key-sequence, viper-set-unread-command-events)
	(viper-char-symbol-sequence-p, viper-char-array-p): Moved here.

	* viper-ex.el: Use viper-cond-compile-for-xemacs-or-emacs.

	* viper-keym.el: Use viper-cond-compile-for-xemacs-or-emacs.

	* viper-mous.el: Use viper-cond-compile-for-xemacs-or-emacs.

	* viper-macs.el (viper-char-array-p, viper-char-symbol-sequence-p)
	(viper-event-vector-p): Move to viper-util.el

	* viper.el (viper-standard-value): Move to viper-cmd.el.
	Use viper-cond-compile-for-xemacs-or-emacs.

	* ediff-help.el: Use ediff-cond-compile-for-xemacs-or-emacs.

	* ediff-hook.el: Use ediff-cond-compile-for-xemacs-or-emacs.

	* ediff-init.el (ediff-cond-compile-for-xemacs-or-emacs):
	New macro designed to be used in many places where ediff-emacs-p or
	ediff-xemacs-p was previously used.  Reduces the number of warnings.
	Use ediff-cond-compile-for-xemacs-or-emacs in many places in lieu
	of ediff-xemacs-p.
	(ediff-make-current-diff-overlay, ediff-highlight-diff-in-one-buffer)
	(ediff-convert-fine-diffs-to-overlays, ediff-empty-diff-region-p)
	(ediff-whitespace-diff-region-p, ediff-get-region-contents):
	Move to ediff-util.el.
	(ediff-event-key): Moved here.

	* ediff-merge.el: Got rid of unreferenced variables.

	* ediff-mult.el: Use ediff-cond-compile-for-xemacs-or-emacs.

	* ediff-util.el: Use ediff-cond-compile-for-xemacs-or-emacs.
	(ediff-cleanup-mess): Improve the way windows are set up after
	quitting ediff.
	(ediff-janitor): Use ediff-dispose-of-variant-according-to-user.
	(ediff-dispose-of-variant-according-to-user): New function
	designed to be smarter and also understands indirect buffers.
	(ediff-highlight-diff-in-one-buffer)
	(ediff-unhighlight-diff-in-one-buffer)
	(ediff-unhighlight-diffs-totally-in-one-buffer)
	(ediff-highlight-diff, ediff-highlight-diff)
	(ediff-unhighlight-diff, ediff-unhighlight-diffs-totally)
	(ediff-empty-diff-region-p, ediff-whitespace-diff-region-p)
	(ediff-get-region-contents, ediff-make-current-diff-overlay):
	Moved here.
	(ediff-format-bindings-of): New function by Hannu Koivisto
	<azure@iki.fi>.
	(ediff-setup): Make sure the merge buffer is always widened and
	modifiable.
	(ediff-write-merge-buffer-and-maybe-kill): Refuse to write the
	result of a merge into a file visited by another buffer.
	(ediff-arrange-autosave-in-merge-jobs): Check if the merge file
	is visited by another buffer and ask to save/delete that buffer.
	(ediff-verify-file-merge-buffer): New function to do the above.

	* ediff-vers.el: Load ediff-init.el at compile time.

	* ediff-wind.el: Use ediff-cond-compile-for-xemacs-or-emacs.

	* ediff.el (ediff-windows, ediff-regions-wordwise)
	(ediff-regions-linewise): Use indirect buffers to improve
	robustness and make it possible to compare regions of the same
	buffer (even overlapping regions).
	(ediff-clone-buffer-for-region-comparison)
	(ediff-clone-buffer-for-window-comparison): New functions.
	(ediff-files-internal): Refuse to compare identical files.
	(ediff-regions-internal): Get rid of the warning about comparing
	regions of the same buffer.

	* ediff-diff.el (ediff-convert-fine-diffs-to-overlays): Moved here.
	Plus the following fixes courtesy of Dave Love: Doc fixes.
	(ediff-word-1): Use word class and move - to the
	front per regexp documentation.
	(ediff-wordify): Bind forward-word-function outside loop.
	(ediff-copy-to-buffer): Use insert-buffer-substring rather than
	consing buffer contents.
	(ediff-goto-word): Move syntax table setting outside loop.

2002-01-07  Richard M. Stallman  <rms@gnu.org>

	* dired.el (dired-copy-filename-as-kill): Call kill-append
	if following a kill command.

	* help-fns.el (describe-variable, describe-function):
	Do save-excursion.

2002-01-06  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* net/ldap.el (ldap-search-internal): Skip error message from
	ldapsearch.  Allow listing attribute names only.  Do not open
	non-existent files.

	* net/eudcb-ldap.el (eudc-ldap-get-field-list): Do not try to
	call non-existent function.

	* net/eudc.el (top-level): Revert previous change.

	* net/net-utils.el (nslookup-font-lock-keywords): Defvar font-lock
	variables to prevent warning from byte-compiler.

	* net/eudc.el (top-level): Use eudc-xemacs-p instead of
	string-match on emacs-version again.

	* enriched.el (enriched-make-annotation): Fix the change from
	2002-01-05.
	(enriched-handle-display-prop): Return proper values.

	* net/eudcb-ldap.el (eudc-attribute-display-method-alist): Use
	proper attribute name labeledUri instead of deprecated labeledUrl.

2002-01-05  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* net/eudc-hotlist.el (eudc-edit-hotlist): Avoid error when
	editing an empty hotlist.

	* net/ldap.el (ldap-search-internal): Make the buffer unibyte.
	Use buffer-string instead of buffer-substring for the whole
	buffer.

	* net/eudc-vars.el (eudc-external-viewers): Do not use xv, it is
	not free.

	* net/eudc-bob.el (eudc-bob-can-display-inline-images)
	(eudc-bob-display-jpeg): Use fboundp instead of boundp.
	(eudc-bob-save-object): Make the buffer unibyte.
	(eudc-bob-generic-keymap): Add new keybinding `!' to pipe the
	object to external program.

2002-01-05  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-branch-part): Return nil if there's no `.'
	(vc-default-previous-version): Renamed from vc-previous-version.
	New args BACKEND and FILE.  Return nil for revision numbers
	without a `.'
	(vc-version-diff): Call vc-BACKEND-previous-version.
	(vc-steal-lock): Steal lock before composing mail, so that no mail
	is sent when the stealing goes wrong.  And we'll actually see the
	error in that case now.
	(vc-finish-steal): Removed.

	* vc-rcs.el (vc-rcs-steal-lock): Do a real checkout after stealing
	the lock, so that we see expanded headers.
	(vc-rcs-trunk-p, vc-rcs-branch-part, vc-rcs-branch-p,
	vc-rcs-minor-part, vc-rcs-previous-version): Removed.  These are
	available from vc.el.  Updated all callers.

2002-01-05  Richard M. Stallman  <rms@gnu.org>

	* enriched.el (enriched-make-annotation): Doc fix.

	* format.el (format-replace-strings, format-subtract-regions)
	(format-annotate-region, format-annotate-location)
	(format-annotate-atomic-property-change)
	(format-annotate-single-property-change): Doc fixes.

2002-01-05  Jason Rumney  <jasonr@gnu.org>

	* term/w32-win.el: Require fontset unconditionally.
	(w32-handle-scroll-bar-event): Remove.

2002-01-04  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* emacs-lisp/copyright.el (copyright-regexp): Allow multi-line
	copyrights to be updated.

2002-01-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* textmodes/texinfo.el (texinfo-insert-@end): Fix the change from
	2001-10-24.

	* mail/sendmail.el (mail-recover-1, mail-recover): Doc fix.

2002-01-04  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* net/ldap.el (ldap-host-parameters-alist): Remove duplicated
	entry.
	(ldap-ignore-attribute-codings): Change the default value to allow
	encoding/decoding of attributes.
	(ldap-coding-system): Use UTF-8 as the coding-system.  Doc fix.

2002-01-03  Richard M. Stallman  <rms@gnu.org>

	* files.el (basic-save-buffer): Undo previous change.

	* calendar/diary-lib.el (diary-block): Doc fix.

	* custom.el (defcustom): Fix syntax of previous change.

2002-01-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* custom.el (defcustom): Documented :tag, :link and :load.

2002-01-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/sendmail.el (mail-recover-1): New function.
	(mail-recover): Switch to the *mail* buffer right away.  Use
	buffer-auto-save-file-name instead of calling
	make-auto-save-file-name.  Call dired-noselect instead of invoking
	`ls' directly.  Bind coding-system-for-read to emacs-mule-unix
	before reading the auto-save file.  If the buffer's auto-save file
	does not exist, call mail-recover-1 to allow recovery from past
	auto-saved drafts.

2002-01-03  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* time.el (display-time-load-average-threshold): Fix defcustom
	(add type and group).

	* net/ange-ftp.el (ange-ftp-shell-command): Remove port
	specification from the hostname.

2002-01-02  Richard M. Stallman  <rms@gnu.org>

	* facemenu.el (facemenu-active-faces):
	Use face-attributes-as-vector, not face-attributes-vector.

2002-01-02  Chris Hanson  <cph@aarau.ai.mit.edu>

	* xscheme.el: Eleven years of updates on a private copy.

	Extensive changes to support multiple xscheme buffers:
	(run-scheme): Break up into new functions to facilitate starting
	processes in other buffers.
	(xscheme-start, xscheme-read-command-line): New functions.
	(start-scheme, select-scheme)
	(default-xscheme-runlight)
	(global-set-scheme-interaction-buffer)
	(local-set-scheme-interaction-buffer)
	(local-clear-scheme-interaction-buffer)
	(exit-scheme-interaction-mode)
	(verify-xscheme-buffer): New functions.
	(xscheme-process-name, xscheme-buffer-name)
	(xscheme-runlight): New internal vars.
	(default-xscheme-runlight): New const.
	(xscheme-start-process): Add args for the process/buffer names.
	(reset-scheme): Pass process/buffer names.
	(scheme-interaction-mode): Initialize new local vars.
	(reset-scheme, xscheme-send-string-2, xscheme-process-running-p)
	(xscheme-select-process-buffer, xscheme-process-buffer)
	(xscheme-send-region, xscheme-send-char, xscheme-send-interrupt)
	(xscheme-goto-output-point, xscheme-write-message-1): Use new
	var xscheme-process-name.
	(xscheme-start-process): Initialize xscheme-process-name and
	xscheme-buffer-name in the process buffer.  Pass buffer name to
	xscheme-modeline-initialize.
	(xscheme-modeline-initialize): Add argument to specify buffer name
	for mode-line vars.
	(xscheme-process-sentinel): Make sure sentinel is run in the
	process buffer so it sees its local vars.
	(xscheme-process-filter-initialize, xscheme-set-runlight): More
	elaborate logic to handle multiple-buffer mode lines.

	(xscheme-enter-input-wait): Re-enable control-G handler upon
	entering input wait.

	(scheme-interaction-mode): Add arg to preserve local vars.
	(xscheme-enter-interaction-mode)
	(xscheme-enter-debugger-mode): Preserve local vars.
	(xscheme-start-process): Clobber local vars.

	(scheme-interaction-mode-commands): Allow end user to add commands
	to scheme-interaction-mode keymap.
	(scheme-interaction-mode-commands-alist): New variable.

	(xscheme-send-string): Don't use insert-before-markers.

	Implement a per-buffer kill ring:
	(xscheme-insert-expression)
	(xscheme-rotate-yank-pointer, xscheme-yank)
	(xscheme-yank-pop, xscheme-yank-push): New functions.
	(xscheme-expressions-ring)
	(xscheme-expressions-ring-yank-pointer)
	(xscheme-expressions-ring-max): New variables.
	(xscheme-send-string-1): Call xscheme-insert-expression to save
	expression in ring.
	(xscheme-yank-previous-send): Now an alias for xscheme-yank.
	(xscheme-previous-send): Deleted variable.

	(xscheme-send-string-2, xscheme-send-char, xscheme-send-proceed,
	xscheme-send-control-g-interrupt): Use process-send-string rather
	than send-string.

	(xscheme-send-region): Insert a newline after an expression that
	is submitted in the interaction buffer, for consistency with
	recent changes to Edwin.

	(xscheme-delete-output): New function mimics comint-delete-output.
	(xscheme-last-input-end): New internal variable.
	(xscheme-process-filter-output): Update xscheme-last-input-end.

	(xscheme-send-control-g-interrupt): Make sure that
	xscheme-control-g-disabled-p is looked up in the right buffer.

	(xscheme-enable-control-g): Clear C-g message if visible.
	(xscheme-control-g-message-string): New internal var.
	(xscheme-send-control-g-interrupt): Use new var.

	(xscheme-send-control-g-interrupt, xscheme-send-interrupt): Delay
	after sending interrupt in order to work around race condition.

	(xscheme-send-control-g-interrupt, xscheme-send-interrupt)
	(xscheme-send-char): Use xscheme-send-char rather than send-string
	to send single char.

	(xscheme-process-filter, xscheme-process-filter-alist): Add
	support for evaluating expressions outside of the call-excursion.
	(xscheme-process-filter:string-action-noexcursion): New func.

	(xscheme-write-value): Change output string to match that used by
	Edwin.

	(xscheme-coerce-prompt): Don't write a space after a command
	prompt.  The PROMPT-FOR-COMMAND- procedures will take care of this
	for us.

	(reset-scheme): Delete process after killing it.

2002-01-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* bindings.el (function-key-map): Don't bind shifted keypad
	numeric keys.

2002-01-02  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* enriched.el (enriched-handle-display-prop): Remove unused
	variables.
	(enriched-mode): Doc fix.

2002-01-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/ucs-tables.el (ucs-8859-8-alist): Comment away
	Hebrew points.

2002-01-01  Richard M. Stallman  <rms@gnu.org>

	* jka-compr.el (jka-compr-write-region): If START = nil, use whole buf.

2001-12-31  Richard M. Stallman  <rms@gnu.org>

	* comint.el, cus-edit.el, diff-mode.el, enriched.el, font-lock.el:
	* generic-x.el, info.el, log-view.el, pcvs-info.el, speedbar.el:
	* wid-edit.el, woman.el, calendar/calendar.el, textmodes/flyspell.el:
	* emulation/viper-init.el, eshell/em-ls.el, progmodes/antlr-mode.el:
	* progmodes/cperl-mode.el, progmodes/idlwave.el:
	* progmodes/sh-script.el, progmodes/vhdl-mode.el:
	Adapt face definitions to use :weight and :slant.

	* ps-print.el (ps-font-lock-face-attributes): Use :weight and :slant.

	* cus-edit.el (custom-face-edit-fix-value): Delete `assert' call.

	* font-lock.el (initializing from font-lock-face-attributes):
	Use :weight and :slant, not :bold and :italic.

2001-12-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-face-edit-fix-value): New function.
	(custom-face-edit): Use it, to convert :italic and :bold to new forms.

2001-12-30  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* progmodes/octave-mod.el (octave-abbrev-table):
	* progmodes/idlwave.el (idlwave-mode-abbrev-table):
	* progmodes/fortran.el (fortran-mode-abbrev-table):
	* progmodes/f90.el (f90-mode-abbrev-table):
	* progmodes/vhdl-mode.el (vhdl-mode-abbrev-table-init):
	* progmodes/sql.el (sql-mode-abbrev-table): Mark all the
	predefined abbrevs as "system" abbrevs.

2001-12-30  Richard M. Stallman  <rms@gnu.org>

	* info.el (Info-fontify-node): For a **** underline line, put the
	invisible and intangible props on the following newline, but not
	on the previous newline or the last char of the previous line.

	* faces.el (face-set-after-frame-default): Don't change `default' face.

	* faces.el (minibuffer-prompt): Adopt some default colors.

	* replace.el (query-replace-read-args): Immediate error if read-only.

	* textmodes/makeinfo.el (makeinfo-compilation-sentinel):
	Display the output buffer in a more intelligent way.

2001-12-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* ls-lisp.el (insert-directory): Modify the "total" line wording,
	in accordance with files.el's insert-directory.

2001-12-29  Richard M. Stallman  <rms@gnu.org>

	* files.el (basic-save-buffer): If a before-write hook displays
	an echo area message, pause before calling basic-save-buffer-1.

2001-12-29  Markus Rost  <rost@math.ohio-state.edu>

	* textmodes/reftex-global.el (reftex-query-replace-document)
	(reftex-change-label): Doc fix.

	* dired-aux.el (dired-do-query-replace-regexp): Doc fix.

	* progmodes/etags.el (tags-query-replace): Doc fix.

2001-12-29  Richard M. Stallman  <rms@gnu.org>

	* progmodes/compile.el (compile-internal): Fix previous change.

2001-12-28  Richard M. Stallman  <rms@gnu.org>

	* mouse.el (mouse-drag-mode-line-1): When dragging a mode line upward,
	shrink the windows above as necessary to get space.
	(mouse-drag-move-window-bottom, mouse-drag-window-above): New fns.

	* net/ange-ftp.el (ange-ftp-allow-child-lookup): Always return nil.
	This fixes a bug that treated all files as directories.
	(ange-ftp-insert-directory): Explicitly follow symlinks.

	* international/iso-transl.el (iso-transl-char-map) Eliminate the
	alias symbols--put the translated sequences here directly.

	* progmodes/cc-mode.el (c-mode-abbrev-table)
	(c++-mode-abbrev-table, objc-mode-abbrev-table)
	(java-mode-abbrev-table, pike-mode-abbrev-table):
	Mark all the predefined abbrevs as "system" abbrevs.

	* mail/sendmail.el (mail-envelope-from): Fix custom type.
	(sendmail-send-it): Check mail-specify-envelope-from
	and mail-envelope-from in the mail buffer at start.

2001-12-28  Simon Josefsson  <jas@extundo.com>

	* mail/sendmail.el (mail-envelope-from): Fix :type.
	(sendmail-send-it): Copy `mail-envelope-from' from calling buffer.

2001-12-28  Richard M. Stallman  <rms@gnu.org>

	* net/ldap.el (ldap-search-internal): Handle <file://...> in results.

	* simple.el (line-move-invisible): New subroutine.
	(line-move-to-column): New subroutine--smarter about advancing over
	invisible parts of a line, or lines, but only as long as hpos grows.
	(line-move-finish): New subroutine: repeatedly processes desired
	column, intangibility, and fields.
	(line-move): Use those subroutines.
	When moving lines downward, skip invisible text first rather than last.

2001-12-27  Richard M. Stallman  <rms@gnu.org>

	* international/mule-diag.el (describe-char-after):
	Describe the text properties of the char after point.

	* help.el (describe-key): Doc fix.

2001-12-26  Markus Rost  <rost@math.ohio-state.edu>

	* find-dired.el (find-dired-sentinel): Precede exit message by
	two spaces, to match the regexp in dired-between-files.

2001-12-28  Miles Bader  <miles@gnu.org>

	* wid-edit.el (widget-toggle-value-create): Don't eval actual
	images (which are lists too).

2001-12-27  Eli Zaretskii  <eliz@is.elta.co.il>

	* language/european.el: Fix the doc string of "Latin-5" language
	environment.

2001-12-26  Richard M. Stallman  <rms@gnu.org>

	* textmodes/flyspell.el (flyspell-mode-map): New keymap,
	defined as before 2001-11-09.
	(add-minor-mode call): Specify the keymap.

	* progmodes/compile.el (compile-internal):
	Set TERM variable in process-environment.

2001-12-25  Richard M. Stallman  <rms@gnu.org>

	* help-mode.el (help-xref-on-pp): Catch and ignore errors in scanning
	the buffer.

	* startup.el (command-line): Convert command line args
	to Emacs internal representation using locale-coding-system.

2001-12-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/fontset.el: Don't require ind-util when compiling.

2001-12-25  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* emulation/tpu-edt.el (tpu-reset-screen-size): Use
	set-frame-height and set-frame-width instead of set-screen-height
	and set-screen-width.

	* vt-control.el (vt-wide, vt-narrow): Use set-frame-width instead
	of obsolete set-screen-width.

	* locate.el (locate): Remove dot at the end of error argument.

	* emerge.el (emerge-show-file-name): Use frame-height instead of
	obsolete screen-height.

	* mail/mh-utils.el (mh-show-msg): Likewise.
	(mh-handle-process-error): Use frame-width instead of obsolete
	screen-width.

2001-12-25  Richard M. Stallman  <rms@gnu.org>

	* window.el (balance-windows): Use new PRESERVE-BEFORE arg
	to enlarge-window.  Use save-selected-window.  Don't try
	to resize windows that end at the bottom "level".
	Retry changing the sizes until the windows get the desired sizes.
	Discount the minibuffer when computing total height available.

	* emacs-lisp/debug.el (debugger-mode-map): Bind C-m, not `RET'.
	(debugger-make-xrefs): Only make a button for the first symbol
	on any line.

2001-12-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (dos-cpNNN-setup, dos-codepage-setup):
	Call IT-setup-unicode-display here instead of adding it to
	dos-codepage-setup-hook, so that Unicode display tables are set
	before dos-codepage-setup-hook runs.

2001-12-24  Richard M. Stallman  <rms@gnu.org>

	* net/net-utils.el (ftp-mode-abbrev-table): Don't define it.
	(nslookup-mode-abbrev-table): Don't define it.
	(smbclient-mode-abbrev-table): Don't define it.
	(ftp-mode): Don't use ftp-mode-abbrev-table; don't enable Abbrev mode.
	(nslookup-mode, smbclient-mode): Likewise.
	(network-connection-service-abbrev-alist): Variable deleted.
	(network-connection-mode-setup): Don't set up abbrev table.

	* faces.el (minibuffer-prompt): New face.
	(minibuffer-prompt-properties): Add `face' property.

	* replace.el (occur-mode-display-occurrence): New function.
	(occur-mode-map): Bind C-o to it.

2001-12-24  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-cmd.el (viper-change-state): Got rid of make-local-hook.
	(viper-special-read-and-insert-char): Make C-m work right in the r
	comand.
	(viper-buffer-search-enable): Fixed format string.

	* viper-ex.el (ex-token-alist): Use ex-set-visited-file-name
	instead of viper-info-on-file.
	(ex-set-visited-file-name): New function.

	* viper.el (viper-emacs-state-mode-list): Added mail-mode.

	* ediff-mult.el (ediff-meta-mark-equal-files): Added optional
	action argument.

	* ediff-init.el: Fixed some doc strings.

	* ediff-util.el (ediff-after-quit-hook-internal): New variable.
	Got rid of make-local-hook.

	* ediff-wind.el (ediff-setup-control-frame): Got rid of
	make-local-hook.

2001-12-23  Richard M. Stallman  <rms@gnu.org>

	* term/x-win.el (x-handle-geometry): Put height and width
	on default-frame-alist, left and top on initial-frame-alist.
	* term/w32-win.el (x-handle-geometry): Likewise.

	* sort.el (sort-reorder-buffer): Copy all to a temp buffer first.

	* play/yow.el (yow): Use an arg to distinguish interactive calls,
	not interactive-p.

2001-12-22  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* emacs-lisp/elint.el (elint-unknown-builtin-args): Remove
	mocklisp entries.

	* subr.el (insert-string): Moved from mocklisp.c, reimplemented in
	Lisp.  Obsoleted.

	* emulation/mlconvert.el: File removed.

	* emulation/mlsupport.el: Moved to obsolete.

	* obsolete/mlsupport.el: Moved there from lisp/emulation.

	* emacs-lisp/find-gc.el (source-files): Remove mocklisp.c.

	* emacs-lisp/byte-opt.el (byte-optimize-form-code-walker): Remove
	mocklisp case.

	* help-fns.el (describe-function-1): Remove mocklisp function
	case.

2001-12-22  Miles Bader  <miles@gnu.org>

	* textmodes/refill.el (refill-mode): Don't barf when redundantly
	turning refill-mode off.

2001-12-22  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* time.el (display-time-load-average-threshold): New variable.
	(display-time-update): Use it.

	These changes allow cycling through past 1, 5 and 15 minutes
	load-average displayed in the mode-line.

	* time.el (display-time-default-load-average): New customizable option.
	(display-time-load-average): New variable.
	(display-time-cycle-load-average): New function.
	(display-time-update): Use them.

2001-12-21  Richard M. Stallman  <rms@gnu.org>

	* apropos.el (apropos-print): SPACING is now nil or a separator string.
	(apropos-documentation, apropos-value): Pass a suitable string.

2001-12-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.el (dired-free-space-program, dired-free-space-args):
	Aliases for back-compatibility.

	* info.el (Info-select-node): If Info-use-header-line is nil, set
	header-line-format to nil.
	(Info-fontify-node): Don't put a keymap text property on the
	heading if we are not going to display the header line.  Remove
	any such text properties left over from past visits to this node.

	* ls-lisp.el (insert-directory): Insert the amount of free disk
	space, like files.el's insert-directory does.

	* files.el (directory-free-space-program): Mention
	file-system-info in the doc string.
	(get-free-disk-space): New function; code moved from
	insert-directory.
	(insert-directory): Call get-free-disk-space to get the amount of
	free space.

2001-12-21  Richard M. Stallman  <rms@gnu.org>

	* help.el (view-order-manuals, view-emacs-news, describe-copying)
	(describe-distribution, describe-project): Use view-file.

	* emacs-lisp/cl-indent.el (define-modify-macro): Better indent spec.

	* net/ange-ftp.el (ange-ftp-file-modtime): Use save-match-data.

	* emacs-lisp/easy-mmode.el (define-minor-mode):
	Make no arg by default in an interactive call,
	so that repeating the command toggles again.

	* emacs-lisp/lisp-mode.el (eval-defun-1): Cope with atoms as args.

2001-12-21  Christoph Wedler  <Christoph.Wedler@sap.com>

	* antlr-mode.el: More sophisticated indentation of cpp directive.
	(antlr-indent-at-bol-alist): New user option.
	(antlr-indent-line): Use it.
	(antlr-indent-style): New user option.
	(antlr-mode): Use it.
	(antlr-indent-item-regexp): Customize.

	* antlr-mode.el: Syntax highlighting changes.
	(antlr-font-lock-literal-regexp): New user option.
	(antlr-font-lock-syntax-face): New face used for :, |, ....
	(antlr-font-lock-default-face): New face.
	(antlr-font-lock-additional-keywords): Use them.

	* antlr-mode.el: New command to insert options -- variables.
	(antlr-mode-map): New binding [C-c C-o].
	(antlr-mode-menu): New submenus.
	(antlr-options-use-submenus): New user option.
	(antlr-tool-version): New user option.
	(antlr-options-auto-colon): New user option.
	(antlr-options-style): New user option.
	(antlr-options-push-mark): New user option.
	(antlr-options-assign-string): New user option.
	(antlr-options-headings): New variable.

	* antlr-mode.el: New command to insert options -- specific.
	(antlr-options-alists): New variable.
	(antlr-read-value): New function.
	(antlr-read-boolean): New function.
	(antlr-language-option-extra): New function.
	(antlr-language-limit-n-regexp): Change default to higher LIMIT.
	(antlr-c++-mode-extra): New function.
	(antlr-grammar-tokens): New function.
	(antlr-imenu-create-index-function): New optional argument.

	* antlr-mode.el: New command to insert options -- functions.
	(antlr-insert-option): New command.
	(antlr-insert-option-interactive): New function.
	(antlr-options-menu-filter): New function.
	(antlr-option-kind): New function.
	(antlr-scan-lists): New alias.
	(antlr-scan-lists-internal): New function.
	(antlr-skip-file-prelude): Hack for special SKIP-COMMENT.
	(antlr-option-level): New function.
	(antlr-syntactic-grammar-depth): New function.
	(antlr-option-location): New function.
	(antlr-insert-option-do): New function.
	(antlr-option-spec): New function.
	(antlr-version-string): New function.
	(antlr-insert-option-existing): New function.
	(antlr-insert-option-space): New function.
	(antlr-insert-option-area): New function.

	* antlr-mode.el: New electric keys ":;|&(){}", TAB works better
	with narrowing.  Menu change.  Miscellaneous.
	(antlr-mode-menu): Include "Indent Region" and "Customize Antlr".
	(antlr-mode-map): New bindings for characters in ":;|&(){}".
	(antlr-electric-character): New command.
	(antlr-class-header-regexp): New variable.
	(antlr-font-lock-additional-keywords): Use it.
	(antlr-imenu-create-index-function): Use it.
	(antlr-file-dependencies): Use it.
	(antlr-indent-line): Also works with restrictions.
	(antlr-indent-command): Interactive spec - changes the buffer.
	(antlr-language-for-option): Deletia.
	(antlr-language-option): New function, defined instead.
	(antlr-mode): Use it.
2001-12-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* jka-compr.el (jka-compr-partial-uncompress): Use null-device
	instead of a literal /dev/null.

	* Makefile.in (distclean): Remove Makefile in the build
	directory, not in the source directory.

2001-12-21  Simon Josefsson  <jas@extundo.com>.

	* mail/smtpmail.el (smtpmail-send-queued-mail): Use
	with-temp-buffer instead of find-file-noselect, and bind
	coding-system-for-read to no-conversion when reading the queued
	messages.  (Simon's code modified slightly by Eli Zaretskii.)

2001-12-20  Werner Lemberg  <wl@gnu.org>

	* international/mule-diag.el (describe-coding-system,
	print-coding-system-briefly): Make printed output have a similar
	format as describe-character-set.

2001-12-20  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* play/blackbox.el (bb-member): Remove, use member instead.
	(bb-delete): Remove, use delete instead.
	Update copyright notice.  Defvar for bb-board, bb-x, bb-y,
	bb-score, bb-detour-count and bb-balls-placed.
	Propertize results of rays.

2001-12-19  Karl Fogel  <kfogel@red-bean.com>

	* isearch.el (isearch-forward, isearch-edit-string): Make doc
	strings mention keybinding for `isearch-yank-word-or-char',
	rather than `isearch-yank-word', since the former is bound now
	and the latter is not.
	(isearch-yank-word-or-char): Fix formatting.

2001-12-19  Werner Lemberg  <wl@gnu.org>

	* language/czech.el, language/european.el, language/slovak.el: More
	fixes for language info doc strings.

2001-12-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* loadup.el: Add "language" to the load-path.

2001-12-19  Richard M. Stallman  <rms@gnu.org>

	* international/mule-cmds.el (describe-language-environment):
	Fix calls to help-xref-button.

2001-12-19  Miles Bader  <miles@gnu.org>

	* international/fontset.el: Require `ind-util' when compiling.

2001-12-18  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* language/ethio-util.el (ethio-modify-vowel): Use char-to-string
	instead of decompose-composite-char.

2001-12-18  Richard M. Stallman  <rms@gnu.org>

	* simple.el (eval-expression-print-level)
	(eval-expression-print-length): Doc fixes.

	* international/mule-diag.el (describe-character-set):
	Fix the arg to help-xref-button.

	* files.el (directory-free-space-program): New variable.
	(directory-free-space-args): New variable.
	(insert-directory): Use those two variables for getting free space.
	Use file-system-info instead, if that is defined.

	* dired.el (dired-free-space-program): Variable deleted.
	(dired-free-space-args): Variable deleted.
	(dired-insert-directory): Don't try to determine free space.

	* files.el (font-lock-defaults): Add risky-local-variables prop.
	(hack-one-local-variable): Treat various font-lock variables as risky.

2001-12-18  Werner Lemberg  <wl@gnu.org>

	* language/chinese.el, language/cyrillic.el:
	* language/czech.el, language/european.el, language/greek.el:
	* language/hebrew.el, language/indian.el, language/japanese.el:
	* language/korean.el, language/lao.el, language/slovak.el:
	* language/thai.el, language/tibetan.el, language/vietnamese.el:
	Improve documentation strings of coding systems and language infos.

2001-12-18  Werner LEMBERG  <wl@gnu.org>

	Add support for EUC-TW decoding/encoding.

	* language/china-util.el (big5-to-flat-code, flat-code-to-big5,
	euc-to-flat-code, flat-code-to-euc, expand-euc-big5-alist):
	New auxiliary functions to build `big5-to-cns'.
	(big5-to-cns): New translation alist.

	* language/chinese.el: Added new coding system `euc-tw' and its
	alias `euc-taiwan'.
	Updated language `Chinese-CNS' to include euc-tw encoding also.
	(ccl-decode-euc-tw, ccl-encode-euc-tw): New functions for handling
	euc-tw.

2001-12-18  Dave Love  <fx@gnu.org>

	* loadup.el: Add language/utf-8-lang, language/georgian.

	* image-file.el (image-file-name-extensions): Add pnm.  Doc fix.
	(image-file-name-regexps): Doc fix.

	* server.el (server-unload-hook): New function.

	* emacs-lisp/lisp-mnt.el (lm-copyright-prefix): Group the leader.
	(lm-crack-copyright): Cope with multi-line copyright `lines'.

	* simple.el (newline): Doc fix.
	(eval-expression-print-level, eval-expression-print-length): Doc
	fix.  Amend :type.
	(next-line, previous-line): Make arg optional.
	(newline): Doc fix.

	* Makefile.in (DONTCOMPILE): Add various language files.

	* international/quail.el (quail-input-string-to-events): Don't use
	string-to-list.

	* progmodes/f90.el (f90-break-line): Avoid infinite recursion
	calling `newline'.

2001-12-17  Richard M. Stallman  <rms@gnu.org>

	* comint.el (comint-dynamic-list-input-ring-select): New function.
	Switches back to the old window configuration.
	(comint-dynamic-list-input-ring): Bind RET to that function.
	(comint-dynamic-list-input-ring-window-conf): New variable.

2001-12-17  Werner Lemberg  <wl@gnu.org>

	* international/mule-conf.el: Improve documentation strings of
	character sets.

2001-12-16  Richard M. Stallman  <rms@gnu.org>

	* dired.el (dired-copy-filename-as-kill): Moved from dired-x.el.
	(dired-mode-map): Bind w to dired-copy-filename-as-kill.

	* dired-x.el (dired-copy-filename-as-kill): Moved to dired.el.

	* autoinsert.el (auto-insert-alist): Redo finding C and C++ headers.
	Add a DESCRIPTION for the makefile item.

	* find-file.el (ff-other-file-name): New function.

2001-12-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/quail.el (quail-input-string-to-events): Fix last
	change.

2001-12-16  Richard M. Stallman  <rms@gnu.org>

	* isearch.el (isearch-edit-string): When we set isearch-string
	to the default, also set isearch-message.

	* subr.el (temp-buffer-show-hook, temp-buffer-setup-hook): Add defvars.

	* startup.el (command-line-1): Display startup screen
	even if there are command line args.
	Add a note about how to go to editing your files.
	(fancy-splash-head): Add a note about how to go to your files.
	(fancy-splash-outer-buffer): New variable.
	(fancy-splash-screens): Bind variable fancy-splash-outer-buffer.

	* subr.el (with-temp-message): At the end, always discard
	the temp message, even by clearing the echo area.

	* progmodes/sh-script.el (sh-mode): Run sh-mode-hook.

2001-12-16  Stefan Monnier  <monnier@cs.yale.edu>

	* log-view.el (log-view-message-re, log-view-current-tag):
	Recognize Subversion's log output format.

	* international/fontset.el: Build the list L at compile time.

	* language/ind-util.el (mapthread): Make a closure.

2001-12-15  Richard M. Stallman  <rms@gnu.org>

	* isearch.el (isearch-start-hscroll): New variable.
	(isearch-mode): Set isearch-start-hscroll.
	(isearch-update): Restore original hscrolling if possible.

	* isearch.el (isearch-edit-string):
	Treat isearch-yank-word-or-char specially, like isearch-yank-word.

	* emacs-lisp/debug.el (debugger-previous-backtrace): New variable.
	(debugger-make-xrefs): Optimize by (1) using skip-syntax-forward
	rather than regexp search and (2) copying text properties
	already set up on text unchanged from the previous backtrace.

	* case-table.el (set-case-syntax-pair):
	Detect invalid calls and signal an error.

2001-12-15  Richard M. Stallman  <rms@gnu.org>

	* language/ind-util.el (range): Function deleted.
	(indian-regexp-of-hashtbl-keys): Renamed from `regexp-of-hashtbl-keys'.
	All calls changed.

	* language/devan-util.el (devanagari-range): Renamed from `range'.
	All calls changed.
	(devanagari-regexp-of-hashtbl-keys):
	Renamed from `regexp-of-hashtbl-keys'.  All calls changed.

2001-12-15  Dave Love  <fx@gnu.org>

	* language/ind-util.el: Don't require cl.
	(indian-glyph-char, indian-glyph-max-char)
	(indian-char-glyph): Moved from indian.el
	(indian--puthash-char, mapthread): Don't quote lambda.
	(indian--map): New function.
	(indian--puthash-v, indian--puthash-c, indian--puthash-m)
	(indian--puthash-cv): Use it.

	* language/indian.el (indian-glyph-char, indian-glyph-max-char)
	(indian-char-glyph): Moved to ind-util.el

	* language/devan-util.el (devanagari-post-read-conversion):
	New function.

	* language/georgian.el: New file.

	* international/mule-cmds.el (locale-language-names): Add various
	entries.  Remove utf-8 special case.
	(locale-charset-language-names, locale-preferred-coding-systems):
	Add utf-8 case.
	(set-language-environment): Process required-features earlier.

	* international/quail.el (quail-keyboard-layout-alist):
	Add pc105-uk.
	(quail-keyboard-layout-type): Fix :type.
	(quail-choose-completion-string): Simplify.
	(quail-update-leim-list-file): Don't get fooled by commented-out code.
	(quail-input-string-to-events): Run events through
	translation-table-for-input.

	* international/mule-conf.el (translation-table-for-input):
	New variable.
	(latin-iso8859-14): Amend description.
	(file-coding-system-alist): Add entry for utf-8.

	* language/utf-8-lang.el: New file.

	* international/code-pages.el: New file.

	* language/hebrew.el ("Windows-1255"): New language.

	* language/european.el ("Welsh", "Latin-7", "Lithuanian")
	("Latvian"): New languages.

2001-12-14  Stefan Monnier  <monnier@cs.yale.edu>

	* xml.el: Use setq rather than (set 'foo bar).
	Use push+nreverse rather than append.
	(xml-node-name, xml-node-attributes, xml-node-children):
	Use defsubst rather than macros.
	(xml-parse-region): Handle a nil return value from xml-parse-tag.
	(xml-parse-tag): Don't skip white space.  Return nil for a comment.
	Concat the two strings surrounding a comment into a single string.

	* newcomment.el (comment-indent): Jump to the middle of empty comments.

2001-12-14  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* select.el (xselect-convert-to-class, xselect-convert-to-name):
	Document.

2001-12-14  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-checkout-model, vc-state, vc-workfile-version):
	Return nil if FILE is not registered.
	(vc-check-master-templates, vc-default-make-version-backups-p):
	Doc fix.

2001-12-13  David Ponce  <david@dponce.com>

	* ruler-mode.el (ruler-mode-extra-left-cols): Remove.
	(ruler-mode-left-fringe-cols): New macro.
	(ruler-mode-right-fringe-cols): New macro.
	(ruler-mode-left-scroll-bar-cols): New macro.
	(ruler-mode-right-scroll-bar-cols): New macro.
	(ruler-mode-ruler): Use above new macros.

2001-12-13  Richard M. Stallman  <rms@gnu.org>

	* files.el (set-auto-mode): Fix previous change.

2001-12-13  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/easymenu.el (easy-menu-intern): New fun.
	(easy-menu-do-define, easy-menu-convert-item-1)
	(easy-menu-define-key-intern, easy-menu-get-map): Use it.
	(easy-menu-return-item): Only return nil if there is no binding.

2001-12-13  Rajesh Vaidheeswarran  <rv@gnu.org>

	* whitespace.el (whitespace-version): 3.2
	* whitespace.el (whitespace-force-mode-line-update): Replace with
	`whitespace-mode-line-update', which is an alias to the correct
	function in various emacsen.
	* whitespace.el (whitespace-{un,}highlight-the-space):
	Add colorized highlighting of the bogus whitespaces in a buffer/file,
	using the `whitespace-highlight-face' if
	`whitespace-display-spaces-in-color' is set.

2001-12-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule.el (set-auto-coding): Don't search for
	"unibyte:" or "coding:" if set-auto-mode-1 returns nil.

2001-12-13  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* mail/mailabbrev.el (mail-abbrevs-setup): Do not use make-local-hook.

	* mail/rmail.el (rmail-fontify-buffer-function): Likewise.

	* mail/rmailsum.el (rmail-summary-mode): Likewise.

2001-12-13  Richard M. Stallman  <rms@gnu.org>

	* simple.el (undo): Always set this-command to `undo',
	so that the next undo after an error will not begin redoing.

	* simple.el (shell-command): Doc fix.
	(shell-command-on-region): If there is output an an error,
	add "...Shell command failed" to the output.

2001-12-13  David Ponce  <david@dponce.com>

	* ruler-mode.el	(ruler-mode-left-fringe-cols): Variable removed.
	(ruler-mode-left-fringe-cols): Function replaced by more efficient
	implementation `ruler-mode-extra-left-cols'.
	(ruler-mode-ruler): Use above new function.  Take into account
	that the fringe areas can now be resized.

2001-12-12  Richard M. Stallman  <rms@gnu.org>

	* international/characters.el (Unicode): Comment out
	the specifications for kelvin and angstrom signs.

	* international/mule.el (make-translation-table-from-vector):
	Allow null elements in VEC.

	* international/ucs-tables.el (unify-8859-on-encoding-mode)
	(unify-8859-on-decoding-mode): Swap the code in their bodies.
	Add :version.

2001-12-11  Richard M. Stallman  <rms@gnu.org>

	* derived.el (derived-mode-p): Function moved to subr.el.

	* subr.el (derived-mode-p): Moved here from derived.el.

	* international/mule.el (set-auto-coding): Use set-auto-mode-1.

	* files.el (set-auto-mode-1): New subroutine, broken out of
	set-auto-mode.
	(set-auto-mode, hack-local-variables-prop-line): Use that.

2001-12-11  Dave Love  <fx@gnu.org>

	* language/thai-util.el, language/thai.el: Add Unicode equivalents.

	* language/european.el: Remove autoload cookies.  Fix registration
	of diacritic composition function.

2001-12-11  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* calendar/todo-mode.el: Require time-stamp.

	* net/zone-mode.el (zone-mode): Don't use make-local-hook.

2001-12-11  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/authors.el (authors-aliases): Delete "Richard Stallmao".

	* textmodes/ispell.el (ispell-buffer-local-parsing):
	Match xml like sgml.

	* emacs-lisp/advice.el (ad-compile-function):
	Byte compile the function under another (uninterned) name.

	* gud.el (gdb): Define and bind gud-jump.

	* font-lock.el (font-lock-mode):
	Put our function at the end of after-change-functions.

	* ediff-diff.el (ediff-cmp-options): Doc fix.

	* comint.el (comint-password-prompt-regexp): Match "UNIX Password".

2001-12-10  Richard M. Stallman  <rms@gnu.org>

	* isearch.el (isearch-yank-word-or-char): New function.
	(isearch-mode-map): Bind C-w to that.

	* menu-bar.el (menu-bar-mode): Make arg optional.

	* simple.el (line-move): Cope if next-single-property-change
	or previous-single-property-change returns nil.

	* emacs-lisp/lisp-mnt.el (lm-verify): New arg NON-FSF-OK.
	Don't use interactive-p; instead, pass the proper args
	in (interactive...).  Clean up most of the trouble-report strings.

2001-12-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/smtpmail.el (smtpmail-send-queued-mail): Insert the
	enqueued messages literally.

2001-12-10  Noah Friedman  <friedman@splode.com>

	* battery.el (battery-insert-file-contents): Obsolete function
	removed.
	(battery-read-function): Obsolete function removed.
	(battery-linux-proc-apm): Use insert-file-contents.

2001-12-07  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el (iswitchb-visit-buffer):
	Use `select-frame-set-input-focus'--needed when window manager
	uses "click to focus" policy.

2001-12-09  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* COPYING: Moved back.

2001-12-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (IT-character-translations): Add entries for
	more points.

	* international/characters.el: Resurrect the Hebrew category
	settings for all Hebrew characters removed by the last change.
	Add code for setting the Hebrew category of the Unicode Hebrew
	characters.  Set syntax entries for Hebrew punctuation characters.

	* international/ucs-tables.el (ucs-8859-8-alist): Add Hebrew
	points and directional formatting control characters.

2001-12-07  Dave Love  <fx@gnu.org>

	* language/lao-util.el: Add Unicode equivalents for rules.
	(lao-post-read-conversion): New function.

	* language/lao.el: Add Unicode equivalents.
	(lao): Add post-read conversion.

	* international/latin1-disp.el: Fix some 8-bit-graphic characters.
	Use iso2022 encoding.
	(latin1-char-displayable-p): Doc fix.
	(latin1-display-ucs-per-lynx): New option.
	(latin1-display-ucs-per-lynx): New command.
	(latin1-display-reset): Special-case arabic.
	(ucs-tables): Require.
	(latin1-display-sets, latin1-display-setup): Add arabic.
	(latin1-display) <variable>: Use function latin1-display.
	(latin1-display) <function>: Add mule-unicode stuff.
	(latin1-display-check-font): Don't lose if `info' is nil.

	* international/iso-transl.el: Insert Latin-1 characters, not
	unibyte codes.

	* language/european.el (diacritic-composition-pattern): New constant.
	(diacritic-compose-region, diacritic-compose-string)
	(diacritic-compose-buffer, diacritic-post-read-conversion)
	(diacritic-composition-function): New functions.

	* international/utf-8.el (ucs-mule-to-mule-unicode):
	New translation table.
	(ccl-encode-mule-utf-8): Use it.
	(utf-8-untranslated-to-ucs, utf-8-help-echo, utf-8-compose)
	(utf-8-post-read-conversion, utf-8-pre-write-conversion): New function.
	(utf-8-subst-table): New variable.
	(utf-8-compose-scripts): New option.
	(mule-utf-8): Update safe-charsets, pre-write and post-read conversion.

	* international/ucs-tables.el, international/utf-8-subst.el:
	New files.

	* international/characters.el: Don't set word syntax (the default)
	explicitly.  Add a diacritic category.  Add info for Unicode
	equivalents of characters in various Mule charsets and for extra
	Unicode characters.  Don't define specific categories for
	Indian/Devanagari, since they aren't used.

2001-12-06  Richard M. Stallman  <rms@gnu.org>

	* textmodes/fill.el (set-justification): Rename arg VALUE to STYLE.
	(set-justification-left, set-justification-right): Doc fix.

	* progmodes/f90.el (f90-break-line): Use (newline 1) to insert newline.
	(bug-f90-mode): Variable deleted.

2001-12-06  Stefan Monnier  <monnier@cs.yale.edu>

	* indent.el (indent-line-function): Default is indent-relative again.

2001-12-07  Miles Bader  <miles@gnu.org>

	* progmodes/compile.el (compilation-error-regexp-alist):
	Added regexps for RXP.

2001-12-05  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/cwarn.el (cwarn-font-lock-match-assignment-in-expression):
	Add shift-assignment operators to those highlighted, and highlight
	the whole operator rather than just the "=".

2001-12-04  Juanma Barranquero  <lektu@terra.es>

	* files.el (save-abbrevs, save-some-buffers): Don't ask the user
	before saving abbrevs if `save-abbrevs' has the value `silently'.

2001-12-04  Andreas Schwab  <schwab@suse.de>

	* xt-mouse.el (turn-off-xterm-mouse-tracking): Doc fix.

2001-12-04  Colin Walters  <walters@debian.org>

	* emacs-lisp/autoload.el (make-autoload): Also generate autoloads
	for `defmacro*' forms.

	* emacs-lisp/lisp-mode.el (toplevel): Define docstring offset for
	`defmacro*'.

2001-12-03  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/antlr-mode.el (antlr-c-common-init): Undo last change.

2001-12-02  Richard M. Stallman  <rms@gnu.org>

	* files.el (insert-directory): If the df output does not look right,
	don't try to use it.  Other cleanups in overall code structure.

2001-12-02  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/outline.el (outline-mode-prefix-map):
	Add bindings for outline-promote and outline-demote.
	(outline-minor-mode-menu-bar-map): New var.
	(outline-minor-mode): Use it.
	(outline-heading-alist): New var (renamed from outline-level-heading).
	(outline-level): Use it.
	(outline-insert-heading, outline-promote, outline-demote):
	Update to use outline-heading-alist.

	* disp-table.el (standard-display-european):
	Simplify since the function is not interactive any more.
	Don't set the existing buffers to unibyte.

	* pcvs-util.el (cvs-file-to-string): Move condition-case outside.

	* pcvs.el (cvs-reread-cvsrc): Don't use cvs-file-to-string.

	* reveal.el (reveal-mode): Fix reveal-mode's lighter.

	* shell.el (shell): Use shell-file-name.
	Pop to buffer before calling comint to set COLUMNS properly.

	* emacs-lisp/cl.el (svref): New alias.

	* progmodes/antlr-mode.el (antlr-c-common-init):
	Don't inhibit adaptive-fill-mode any more.

	* progmodes/delphi.el (delphi-mode): Don't use make-local-hook.

	* progmodes/etags.el (tags-with-face): Use make-symbol.
	(tags-search, tags-query-replace): Use backquotes.

	* textmodes/picture.el (picture-mode-map): Don't use defconst
	for a variable.

2001-12-02  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* textmodes/reftex-index.el (reftex-index-mode):
	Remove make-local-hook.

	* textmodes/reftex-toc.el (reftex-toc-mode): Likewise.

2001-12-02  Kim F. Storm  <storm@cua.dk>

	* isearch.el (isearch-resume-enabled): New variable.
	(isearch-done): Use that variable.

2001-12-01  Richard M. Stallman  <rms@gnu.org>

	* wid-edit.el (widget-button-click): Don't move point permanently:
	Avoid mouse-set-point--instead select the window,
	then do save-excursion, then move point.
	Specify the buffer for get-char-property.
	Don't use `@' in interactive.

	* indent.el (indent-line-function):
	Default is indent-to-left-margin again.

	* replace.el (query-replace-read-args): Display message
	if FROM contains `\n' or `\t'.

2001-12-01  Stefan Monnier  <monnier@cs.yale.edu>

	* indent.el (tab-to-tab-stop): Use delete-horizontal-space.

	* bindings.el (minibuffer-local-map): Bind TAB to insert-tab.

	* emacs-lisp/regexp-opt.el (regexp-opt):
	Bind completion-regexp-list to nil.

	* progmodes/hideif.el (hif-nexttoken): Move to before first def.

2001-12-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/idlwave.el, progmodes/idlw-rinfo.el:
	* progmodes/idlw-shell.el, progmodes/idlw-toolbar.el:
	Update maintainer.

2001-11-30  Stefan Monnier  <monnier@cs.yale.edu>

	* mail/smtpmail.el: Use with-current-buffer.
	(message-make-date, message-make-message-id): Autoload when needed.
	(smtpmail-send-it): Use them to add `Date:' and `Message-Id:'
	headers when missing.

	* international/encoded-kb.el (encoded-kbd-mode):
	Use define-minor-mode.

	* enriched.el (enriched-mode): Use define-minor-mode.
	Use dolist and pop and push.

	* info.el (Info-find-node-2): Don't call info-insert-file-contents
	with the `visit' argument.
	(Info-extract-menu-node-name): Use `replace-regexps-in-string'.

	* progmodes/hideif.el (hide-ifdef-mode): Only modify
	`change-major-mode-hook' locally.  Reset invisibility spec.

	* man.el (Man-build-section-alist): Remove last Man-match-substring.

2001-11-30  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* textmodes/paragraphs.el (mark-paragraph): Clarify doc.
	Clarify error message.

2001-11-29  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* textmodes/paragraphs.el (mark-paragraph): Allow prefix arg.

2001-11-30  Andre Spiegel  <spiegel@gnu.org>

	* vc-cvs.el (vc-cvs-parse-status): Store file state in property,
	don't just return it.

2001-11-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-read-lispref, menu-bar-read-lispintro)
	(menu-bar-read-emacs-man, search-emacs-glossary)
	(emacs-index-search, elisp-index-search): New functions.
	(apropso-documentation, apropos, apropos-value, apropos-variable)
	(apropos-commands): Modify menu item names and help text.
	(elisp-index-search, emacs-index-search, emacs-glossary):
	New menu items.
	(menu-bar-manuals-menu): Move the Ordering Manuals item to a
	submenu.
	(info-elisp, info-elintro): New menu items.
	(apropos): Modify the menu item name.

2001-11-30  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/lisp-mode.el (read-if): Add lisp-indent-function prop.

	* textmodes/outline.el (outline-promote, outline-demote): Typo.

	* man.el (man-follow-mouse): New function.
	(Man-mode-map): Bind mouse-2 to it.
	(Man-match-substring): Remove.  Replace with `match-string'.
	(man): Use the `default-value' argument to `read-string'.
	(Man-fontify-manpage): Add mouse-face to cross references.

	* emacs-lisp/cl-macs.el (shiftf): Fix more.  Simplify.

2001-11-29  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/crm.el (completing-read-multiple): Better preserve
	the value of require-match in minibuffer-completion-confirm.
	Use crm-local-completion-map.

	* emacs-lisp/cl-macs.el (shiftf): Fix the fast case so
	(let ((a 1) (b 2)) (shiftf a b (cons a b)) b) returns (1 . 2).
	(cl-make-type-test): Use char-valid-p for `character'.

	* info.el (Info-complete-next-re, Info-complete-cache): New vars.
	(Info-complete-menu-item): Rewrite.  Add the ability to search
	several sequential nodes.  Add a simple caching mechanism.
	(Info-goto-index): New function extracted from Info-index.
	(Info-index): Use it.  Add completion to the interactive spec.
	(Info-menu-update): Simplify call to `Info-complete-menu-item'.

2001-11-29  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* COPYING: Removed.

2001-11-29  Dave Love  <fx@gnu.org>

	* progmodes/fortran.el: Fontify rewind, backspace.  Doc fixes.
	(fortran-window-create, fortran-window-create-momentarily):
	Rewrite, moving error condition.
	(fortran-beginning-do, fortran-beginning-if): Fix regexps.
	(fortran-mode-syntax-table): Revert last change.

	* international/mule.el: Doc fixes.
	(map-charset-chars): New function.
	(register-char-codings): Use it to cope with generic chars in
	safe-chars.

2001-11-29  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* play/blackbox.el (blackbox-mode, blackbox): Doc fix.

	* play/cookie1.el (cookie, cookie-insert, shuffle-vector): Doc fixes.

	* play/studly.el (studlify-word, studlify-region)
	(studlify-buffer): Fix doc-string.
	(studlify-buffer): Add autoload cookie.

2001-11-28  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/outline.el (outline-up-heading): Add `invisible-ok' arg.
	(outline-up-heading-all): Remove.
	(hide-sublevels): Move to end-of-heading before calling flag-region.
	(outline-copy-overlay, outline-discard-overlays): Remove.
	(outline-flag-region): Use `remove-overlays'.
	Don't move to end-of-heading.
	(outline-next-visible-heading, outline-back-to-heading)
	(outline-on-heading-p): Use outline-invisible-p.
	(outline-font-lock-level): Use outline-up-heading's new arg.
	(outline-minor-mode): Simplify.
	(outline-map-tree, outline-reveal-toggle-invisible): New funs.
	(outline): Put a `reveal-toggle-invisible' property.
	(outline-level-heading): New var.
	(outline-insert-heading, outline-promote, outline-demote)
	(outline-toggle-children): New commands.

	* progmodes/hideif.el (hif-end-of-line): New function.
	(hide-ifdef-mode): Set line-move-ignore-invisible.
	(hide-ifdef-region-internal): New function.
	(hide-ifdef-region): Use it.
	(hif-defined): Return an integer.
	(hif-infix-to-prefix): Remove.
	(hif-tokenize): Parse from the buffer rather than from a string.
	Correctly tokenize integers.  Use forward-comment.
	(hif-expr): Use hif-or.
	(hif-term): Use hif-and.
	(hif-factor): Use hif-not.  Handle numbers properly.
	Don't require parenthesis around `defined's argument.
	(hif-and, hif-or, hif-not): New funs.
	(hif-canonicalize): Pass a region to hif-tokenize.  Use hif-not.
	(hif-hide-line): Don't hide the \n before the line.
	(hif-possibly-hide): Correctly handle numeric evaluation results.

	* progmodes/make-mode.el: Use line-(end|beginning)-position.
	(makefile-mode): Set indent-line-function.
	(makefile-browser-insert-continuation): Use with-current-buffer.
	(makefile-beginning-of-line-point, makefile-end-of-line-point): Remove.

2001-11-28  Karl Fogel  <kfogel@red-bean.com>

	* isearch.el (isearch-yank-internal): New helper function.
	(isearch-yank-char): New function.
	(isearch-yank-word, isearch-yank-line): Rewrite to use
	isearch-yank-internal.

2001-11-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* mouse.el (mouse-set-font): Make it a no-op if multiple fonts
	aren't supported.  Print a message to that effect if invoked.

2001-11-27  Stephen Eglen  <stephen@gnu.org>

	* locate.el (locate): Put point at first matching file rather
	than top of buffer.

2001-11-27  Stefan Monnier  <monnier@cs.yale.edu>

	* reveal.el: New file.

	* progmodes/hideif.el: Misc cleanup.
	(hide-ifdef-mode-submap): Put the def in the defvar.
	Use substitute-key-definition.
	(hide-ifdef-mode): Use define-minor-mode.
	(hif-outline-flag-region): Remove.
	(hif-show-all): Define in terms of hif-show-ifdef-region.
	(hif-after-revert-function): Rename from hif-before-revert-function.
	(hide-ifdef-region, hif-show-ifdef-region): Use overlays.
	(hif-tokenize): Use with-syntax-table.
	(hif-make-range): Use `else' also for `else-p'.
	(hif-range-else-p): Remove.
	(hif-find-range): Simplify.
	(hif-hide-line): Don't bother preserving buffer-modified-p.
	(hide-ifdefs, show-ifdefs, hide-ifdef-block, show-ifdef-block):
	Don't use selective-display and inhibit-read-only.

	* subr.el (copy-overlay, remove-overlays): New funs.

	* emacs-lisp/regexp-opt.el (regexp-opt-depth): Fix off-by-two error.

2001-11-27  Sam Steingold  <sds@gnu.org>

	* ansi-color.el, bookmark.el, dired.el, emerge.el, fast-lock.el
	* lazy-lock.el, mouse-sel.el, mail/feedmail.el
	* emacs-lisp/advice.el, emacs-lisp/checkdoc.el, emacs-lisp/ewoc.el
	* obsolete/c-mode.el, obsolete/cplus-md.el
	* progmodes/dcl-mode.el, progmodes/idlw-shell.el, progmodes/idlwave.el
	* term/sun-mouse.el, textmodes/artist.el:
	Converted backquote to the new style.
	* mouse.el, reposition.el: Likewise (in comments).
	* expand.el: Likewise (in a string).

2001-11-27  Richard M. Stallman  <rms@gnu.org>

	* cus-edit.el (custom-load-symbol): Don't always load locate-library.

2001-11-26  Richard M. Stallman  <rms@gnu.org>

	* wid-edit.el (widget-toggle-value-create): On graphic terminal,
	if :on-glyph or :off-glyph is a list, eval it and store it back.
	(checkbox): Quote the values for :on-glyph and :off-glyph.

	* cus-start.el (recursive-load-depth-limit): Delete item.

2001-11-26  Stefan Monnier  <monnier@cs.yale.edu>

	* help-fns.el (describe-categories, help-describe-category-set): New.
	describe-categories moved here from src/category.c.

2001-11-26  Sam Steingold  <sds@gnu.org>

	* progmodes/cc-mode.el (c-submit-bug-report): Make sure that the
	arguments to `insert' are strings.

2001-11-26  Richard M. Stallman  <rms@gnu.org>

	* startup.el (command-line-1): Call kill-buffer only in non-fancy case.

2001-11-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule-diag.el: Require help-fns instead of
	help-funs.

	* help-fns.el: Renamed from help-funs.el.

	* startup.el (command-line-1): Don't try to call process-list if
	it is not fboundp.

2001-11-26  Sam Steingold  <sds@gnu.org>

	* frame.el (show-trailing-whitespace): Remove :set argument (the
	value was essentially identical to the defalt).

2001-11-26  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* hexl.el (hexl-mode, hexl-follow-ascii): Remove make-local-hook.

	* icomplete.el (icomplete-minibuffer-setup): Likewise.

	* hilit-chg.el (hilit-chg-set): Likewise.

	* speedbar.el (speedbar-mode): Likewise.

	* calendar/calendar.el (calendar-mode): Likewise.

	* play/yow.el (psychoanalyze-pinhead): Use insert instead of
	insert-string.

	* play/gamegrid.el (gamegrid-init-buffer): Likewise.

	* term/bg-mouse.el (bg-insert-moused-sexp): Likewise.

	* term/sun-mouse.el (sun-yank-selection): Likewise.

	* textmodes/bib-mode.el (return-key-bib): Likewise.

	* calendar/appt.el (appt-disp-window): Likewise.

	* calendar/diary-lib.el (list-diary-entries): Likewise.

	* array.el (array-reconfigure-rows): Likewise.

	* filecache.el (file-cache-minibuffer-complete): Likewise.

	* obsolete/cplus-md.el (fill-c++-comment): Likewise.

	* strokes.el (strokes-prompt-user-save-strokes): Likewise.

	* allout.el (outline-version, outline-open-topic)
	(outline-rebullet-heading, outline-insert-listified)
	(outline-latex-verbatim-quote-curr-line)
	(outline-latexify-one-item, outlineify-sticky): Likewise.

	* vc.el (vc-next-action-on-file): Likewise.
	(vc-dired-mode): Remove make-local-hook.

2001-11-26  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-find-version): New function.
	(vc-version-other-window): Redefined in terms of the above.

	* log-view.el (log-view-find-version): New function.
	(log-view-mode-map): Bind it to `f'.

2001-11-26  Gerd Moellmann  <gerd@gnu.org>

	* language/devan-util.el (dev-char-glyph): Escape `"' in
	string literals.
	(dev-glyph-glyph, dev-glyph-glyph-2)
	(devanagari-compose-syllable-region): Likewise.

2001-11-26  Richard M. Stallman  <rms@gnu.org>

	* window.el (save-selected-window): No error if saved window is dead.

	* help-funs.el (describe-syntax): Put (interactive) after doc string.

2001-11-26  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* international/quail.el (quail-help): Require help-mode in
	top-level instead.

	* iswitchb.el (iswitchb-exhibit): Use insert instead of
	insert-string.

	* icomplete.el (icomplete-exhibit): Likewise.

2001-11-25  Stefan Monnier  <monnier@cs.yale.edu>

	* diff-mode.el (diff-end-of-hunk): Watch out for ambiguities.
	(diff-hunk-kill): Simplify.
	(diff-post-command-hook): Only apply to a single hunk.
	(diff-hunk-text): Make `char-offset' non-optional.
	(diff-find-text): Return a cons cell.
	(diff-find-approx-text): New fun.
	(diff-find-source-location): Use it.
	(diff-apply-hunk, diff-test-hunk, diff-goto-source):
	Adapt to new retval of diff-find-text.

	* vc-cvs.el (vc-cvs-parse-entry): Rewrite, comparing the string-
	rather than integer- representation of dates.

	* textmodes/fill.el (fill-indent-according-to-mode): Default to nil.

	* emacs-lisp/syntax.el: Don't profile syntax-ppss any more.
	(syntax-after): New fun.

	* help-funs.el (describe-syntax): New fun.

	* font-lock.el (font-lock-cache-state, font-lock-cache-position)
	(font-lock-ppss-stats, font-lock-ppss): Remove.
	(font-lock-fontify-syntactically-region): Remove tuning code.
	(font-lock-compile-keywords): Fix off-by-one bug.
	(font-lock-set-defaults): Don't set removed vars.
	(c-keywords): Add `inline'.
	(c-type-names): Add `_Complex', `_Imaginary' and `_Bool'.

	* emacs-lisp/lisp-mode.el (lisp-mode-variables):
	Set syntax-begin-function.
	(lisp-interaction-mode-abbrev-table): Defvar to its correct value.
	(lisp-interaction-mode): Don't set local-abbrev-table any more.
	(lisp-mode-auto-fill): Use syntax-ppss and obey
	comment-auto-fill-only-comments.
	(lisp-fill-paragraph): Use syntax-ppss.

2001-11-25  ShengHuo ZHU  <zsh@cs.rochester.edu>

	* mail/rmail.el (rmail-enable-mime-composing): New. A lightweight
	version of rmail-enable-mime.
	(rmail-forward): Use it.

2001-11-25  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-indent-function): Add doc string.

	* international/quail.el (quail-keyboard-layout-button):
	Define button type.
	(quail-keyboard-customize-button): Likewise.
	(quail-help): Use those button types.  Require `help-mode'.
	Avoid altering the argument `package'.

	* help-mode.el (help-function, help-variable, help-face)
	(help-coding-system, help-input-method, help-character-set):
	Define each button type with its own explicit define-button-type.

	* language/devan-util.el: Comment out parts of the file
	which apparently are garbled.

2001-11-25  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* mail/smtpmail.el (smtpmail-deduce-address-list): Don't use
	insert-string.

2001-11-25  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* play/snake.el (snake-mode): Remove make-local-hook.

	* play/tetris.el (tetris-mode): Likewise.

	* play/decipher.el (decipher-mode): Likewise.

	* tmm.el (tmm-add-prompt): Likewise.

2001-11-25  Sam Steingold  <sds@gnu.org>

	* menu-bar.el (menu-bar-apropos-menu): New variable.
	Moved all `apropos' bindings to this menu.
	(menu-bar-help-menu): Added `menu-bar-apropos-menu'.

2001-11-24  KAWABATA, Taichi <batta@beige.ocn.ne.jp>

	The following changes are for new indian languages support based
	on Unicode charset and CDAC fonts.

	* international/mule-conf.el: Change indian-1-column charset to
	indian-glyph charset.

	* international/characters.el: Adjusted for the change of
	indian-1-column -> indian-glyph.

	* international/fontset.el: Delete the setting for indian-1-column
	and add the setting for indian-glyph in the default fontset.

	* language/indian.el: Completely re-written.

	* language/devanagari.el: Completely re-written.

	* language/devan-util.el: Completely re-written.

	* language/ind-util.el: New file.

2001-11-24  Richard M. Stallman  <rms@gnu.org>

	* startup.el (command-line-1): Don't do startup screen
	if a subprocess is running.  Call the startup screen buffer
	"GNU Emacs".  Make a special mode-line-format for it.

	* net/browse-url.el (browse-url-galeon-new-window-is-tab): New var.
	(browse-url-galeon): Use that variable.

	* mail/supercite.el (sc-toggle-var): Don't use set-variable or
	eval-expression.  Eval and set the variable simply.

	* files.el (temporary-file-directory): Use defcustom.
	(small-temporary-file-directory): Likewise.
	(normal-backup-enable-predicate): Move down in file
	after definition of temporary-file-directory.

	* bindings.el (last-buffer, unbury-buffer): Doc fixes.

2001-11-24  Colin Walters  <walters@debian.org>

	* calc/calc-ext.el (calc-init-extensions): Update the rest of the
	autoload names to match files renamed on initial calc import.

	* calc/calc.el (Commentary): Cleanup, and add logistic curve
	fitting suggestion from Robert J. Chassell <bob@rattlesnake.com>.

2001-11-23  Colin Walters  <walters@debian.org>

	* Makefile.in (finder_setwins, setwins): Include Calc again.

	* calc/calc-rules.el: Add header comment.

2001-11-23  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (with-vc-properties): Don't bind `filename' locally.
	(with-vc-file, edit-vc-file): Use `make-symbol' for local bindings
	to avoid name clashes.  Fix `lisp-indent-function' property for
	both.

2001-11-23  Francesco Potorti`  <pot@gnu.org>

	* generic-x.el (mailrc-generic-mode): Highlight the `source' keyword.

2001-11-22  Colin Walters  <walters@debian.org>

	* calc/calc-misc.el (report-calc-bug):
	Use `reporter-prompt-for-summary-p'.

	* calc/INSTALL, calc/Makefile: Remove.

2001-11-22  Miles Bader  <miles@gnu.org>

	* emacs-lisp/re-builder.el (reb-match-0, reb-match-1)
	(reb-match-2, reb-match-3): Add dark-background variants.

2001-11-22  Colin Walters  <walters@debian.org>

	* calc/calc-misc.el (calc-info): Don't perform voodoo, just
	(info "Calc").
	(report-calc-bug): Use reporter.el.

	* mail/reporter.el (reporter-submit-bug-report): Doc fixes.

2001-11-21  Richard M. Stallman  <rms@gnu.org>

	* which-func.el (which-function): Call imenu--make-index-alist
	if necessary to get a list of functions.
	(which-function-imenu-failed): New variable.
	(which-func-update): Handle all visible windows.
	(which-func-update-1): New subroutine broken out of which-func-update.

	* files.el (temporary-file-directory, null-device)
	(small-temporary-file-directory): Definitions moved up.

	* progmodes/cperl-mode.el (cperl-problems, cperl-tips)
	(cperl-non-problems, cperl-praise): Doc fixes.

	* progmodes/sh-script.el (sh-mode): Don't use define-derived-mode.
	(sh-mode-syntax-table): Function restored.
	Variable set up for use by function sh-mode-syntax-table.
	(sh-set-shell): Set the syntax table.

	* play/gomoku.el (gomoku-mode): Don't use define-derived-mode.

	* progmodes/perl-mode.el (perl-mode): Don't use define-derived-mode.

	* international/encoded-kb.el: Don't alter minor-map-alist.

2001-11-20  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* files.el (auto-save-file-name-transforms): Put remote files in
	temporary-file-directory rather than /tmp.

2001-11-21  Colin Walters  <walters@debian.org>

	* calc/calc-macs.el (calc-slow-wrapper): Move (point) call outside
	of (function ...) wrapper.

2001-11-20  Stefan Monnier  <monnier@cs.yale.edu>

	* derived.el (define-derived-mode): Create the abbrev-table
	from inside the `defvar'.

	* jit-lock.el (jit-lock-defer-time): New var.
	(jit-lock-defer-timer, jit-lock-buffers): New vars.
	(jit-lock-mode): Initialize them.  Cancel the timers more carefully.
	(jit-lock-function): Defer fontification if requested.
	(jit-lock-stealth-chunk-start): Pay attention to the new non-nil value.
	(jit-lock-stealth-fontify): Check the new `jit-lock-defer-multiline'
	text property.
	(jit-lock-deferred-fontify): New fun.

2001-11-20  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-interaction-mode):
	Set local-abbrev-table to lisp-mode-abbrev-table.

	* emacs-lisp/re-builder.el (reb-mode):
	Don't use define-derived-mode.  Call kill-all-local-variables.

	* emacs-lisp/lisp-mode.el (lisp-mode, emacs-lisp-mode):
	Don't use define-derived-mode.

	* help-mode.el (help-mode): Undo 2001-10-07 change.

	* replace.el (occur-mode): Undo 2001-5-20 change.

2001-11-20  Jason Rumney  <jasonr@gnu.org>

	* w32-fns.el (w32-system-coding-system): Change to an alias for
	locale-coding-system.
	(set-w32-system-coding-system): Document the above change.
	Set locale-coding-system instead.

2001-11-20  Richard M. Stallman  <rms@gnu.org>

	* ruler-mode.el: Add pagination.
	(ruler-mode-toggle-show-tab-stops): No need to
	test `ruler-mode' variable.

2001-11-20  Eli Zaretskii  <eliz@is.elta.co.il>

	* play/landmark.el: Mark lm-mode as special.

	* play/gomoku.el: Mark gomoku-mode as special.

2001-11-20  Juanma Barranquero  <lektu@terra.es>

	* emacs-lisp/re-builder.el (reb-change-target-buffer): New function.
	(top-level): Bind it to C-c C-b.
	(re-builder): Don't re-enter RE Builder Mode.

	* bs.el (bs-delete): Signal an error if the buffer cannot be deleted.

2001-11-20  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/cperl-mode.el (cperl-perldoc): Require man before binding
	`manual-program'.

	* emacs-lisp/lisp-mode.el (lisp-fill-paragraph): Don't move back
	to a line without a comment.

2001-11-20  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.el (dired-listing-switches): Mention in the doc string
	that some switches are not supported by ls-lisp.el

2001-11-19  Stefan Monnier  <monnier@cs.yale.edu>

	* imenu.el (imenu--split-menu): Use dolist and copy-sequence.
	(imenu--create-keymap-2): Remove.
	(imenu--create-keymap-1): Simplify, remove third argument.
	(imenu--generic-function): Use dolist.
	(imenu-find-default): New function.
	(imenu--completion-buffer): Use it.
	(imenu--mouse-menu): Use popup-menu.
	(imenu--menubar-select): Return t rather than calling imenu.

	* textmodes/fill.el (fill-delete-prefix, fill-delete-newlines):
	New functions, extracted from fill-region-as-paragraph.
	(fill-region-as-paragraph): Use them.
	Use an end marker instead of eob.
	Ignore whitespace-only fill-prefixes when indenting according to mode.
	Simplify the loop that searches for spaces backwards.

	* textmodes/picture.el (picture-vertical-step)
	(picture-horizontal-step): Don't use defconst for variables.

	* mail/mail-extr.el: Use backquote/dolist/mapc/when.  Docstring fixes.
	(mail-extract-address-components): Downcase domain names.
	(mail-extr-delete-char): Remove.  Use delete-char instead.

	* emulation/pc-select.el: Doc string fixes.
	(pc-selection-mode): Don't treat macos as a tty.

	* emacs-lisp/lisp.el (mark-sexp): Mark more if repeated.

	* progmodes/cc-engine.el (c-parse-state): Typo. From Martin Stjernholm.

	* mwheel.el (mouse-wheel-scroll-amount): Allow float values.
	(mouse-wheel-progessive-speed): New var.
	(mwheel-scroll): Use it and handle float values.

	* lazy-lock.el (lazy-lock-install-hooks): Remove make-local-hook.

	* iswitchb.el (iswitchb-mode): Use define-minor-mode.
	(iswitchb): Fix the case where the result was selected with the mouse.
	(iswitchb-completion-help): Use the normal *Completions* now that
	mouse selection works.
	(iswitchb-minibuffer-setup): Simplify.

	* newcomment.el (comment-column, comment-style, comment-multi-line)
	(comment-auto-fill-only-comments): Remove :group arg.
	(comment-padding): Add :type.
	(comment-indent-new-line): Ignore comment-auto-fill-only-comments
	if called interactively.

2001-11-19  Colin Walters  <walters@verbum.org>

	* calc/calc.el (toplevel): Add comment and version header.
	(calc-init-base): Bump version to 2.02f, update date.

2001-11-19  Richard M. Stallman  <rms@gnu.org>

	* net/browse-url.el: Support Mozilla and Galeon.
	By default, find the installed browser whichever it is.
	(browse-url-mozilla): New function.
	(browse-url-mozilla-sentinel): New function.
	(browse-url-galeon, browse-url-galeon-sentinel): New functions.
	(browse-url-default-browser): New function.
	(browse-url-process-environment): Use browse-url-browser-display.
	(browse-url-browser-display): Renamed from browse-url-netscape-display.
	(browse-url-mozilla-startup-arguments, browse-url-galeon-program)
	(browse-url-galeon-arguments, browse-url-galeon-startup-arguments)
	(browse-url-mozilla-program, browse-url-mozilla-arguments): New vars.
	(browse-url-browser-function): New default, new options.

2001-11-19  Sam Steingold  <sds@gnu.org>

	* bindings.el (last-buffer, unbury-buffer): New function.
	(mode-line-unbury-buffer): Use `unbury-buffer'.

2001-11-18  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el (iswitchb-cannot-complete-hook): New variable to
	control behaviour when no further completion is possible.

2001-11-19  Colin Walters  <walters@verbum.org>

	* calc/calc-macs.el (calc-wrapper, calc-slow-wrapper)
	(math-showing-full-precision, math-with-extra-prec, math-working)
	(calc-with-default-simplification)
	(calc-with-trail-buffer): Use backtick.
	(Math-zerop, Math-integer-negp, Math-integer-posp, Math-negp)
	(Math-looks-negp, Math-posp, Math-integerp, Math-natnump)
	(Math-ratp, Math-realp, Math-anglep, Math-numberp, Math-scalarp)
	(Math-vectorp, Math-messy-integerp, Math-objectp, Math-objvecp)
	(Math-integer-neg, Math-equal, Math-lessp, Math-primp)
	(Math-num-integerp, Math-bignum-test, Math-equal-int)
	(Math-natnum-lessp, math-format-radix-digit): Change to `defsubst'.
	(calc-record-compilation-date-macro): Deleted.  Callers updated.
	(math-format-radix-digit): Move to calc-bin.el.

	* calc/calc.el (calc-record-compilation-date): Remove.
	(calc-bug-address): Update.
	(calc-settings-file): Use `user-init-file'.

	* calc/calc-mode.el (calc-settings-file-name, calc-save-modes):
	Handle null `calc-settings-file'.

	* calc/calc-frac.el (calc-over-notation): Use `completing-read'.
	* calc/calc-keypd.el (calc-keypad-mode): New.
	(calc-do-keypad): Use it.
	(calc-keypad-map): Move into `calc-keypad-mode'.

	* calc-math.el (calcFunc-sqrt, calcFunc-hypot): Add missing quote
	to defalias argument.

	* calc-misc.el (math-fixnump, math-fixnatnump, calcFunc-trunc)
	(calcFunc-floor): Ditto.

	* calc-units.el (calcFunc-usimplify): Ditto.

	* calc-aent.el, calc-ext.el, calc-incom.el, calc-misc.el
	* calc-sel.el, calc-vec.el, calc-alg.el, calc-fin.el
	* calc-keypd.el, calc-mode.el, calc-stat.el, calc-yank.el
	* calc-arith.el, calc-forms.el, calc-lang.el, calc-mtx.el
	* calc-store.el, calc.el, calc-bin.el, calc-frac.el, calc-macs.el
	* calc-poly.el, calc-stuff.el, calcalg2.el, calc-comb.el
	* calc-funcs.el, calc-maint.el, calc-prog.el, calc-trail.el
	* calcalg3.el, calc-cplx.el, calc-graph.el, calc-map.el
	* calc-rewr.el, calc-undo.el, calccomp.el, calc-embed.el
	* calc-help.el, calc-math.el, calc-rules.el, calc-units.el
	* calcsel2.el: Change all toplevel `setq' forms to `defvar' forms,
	and move them before their first use.  Use `when', `unless'.
	Remove trailing periods from error forms.  Add description and
	headers suggested by Emacs Lisp coding conventions.

2001-11-19  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el (comment-indent):
	Fix misindentation for comment-only lines.
	(comment-indent-new-line): Only obey comment-multi-line if the
	comment-ender is not the end-of-line.

2001-11-19  Richard M. Stallman  <rms@gnu.org>

	* net/net-utils.el (network-connection-service-abbrev-alist):
	New variable.

	* emacs-lisp/cl-indent.el (lisp-indent-defmethod):
	Advance to start of 3rd sexp by moving fwd and backing over it.
	At first three elements, act like defun.

	* delsel.el (delete-selection-pre-hook): Handle and resignal
	file-supersession errors to interact properly with userlock.el.

2001-11-18  Richard M. Stallman  <rms@gnu.org>

	* progmodes/fortran.el (fortran-mode-syntax-table):
	Specify punctuation syntax for backslash.

	* progmodes/sh-script.el (sh-must-be-shell-mode): Function deleted.
	All calls deleted.

	* international/mule-util.el (string-to-sequence): Make it obsolete.
	(string-to-list, string-to-vector): Implement them directly
	using append and vconcat, not with string-to-sequence.

	* startup.el (command-line): Set abbrevs-changed to nil after
	reading the init file and the abbrevs file.

	* isearch.el (isearch): Use magenta2 as bg for (background light)

2001-11-17  Richard M. Stallman  <rms@gnu.org>

	* menu-bar.el (menu-bar-update-buffers-1): Don't pad the buffer name.

	* simple.el (minibuffer-history-sexp-flag): Doc fix.

2001-11-17  Stefan Monnier  <monnier@cs.yale.edu>

	* font-lock.el (font-lock-compile-keywords): New arg `regexp'.
	If set and if applicable, add a regexp to highlight defun-like
	text inside comments and strings.
	(font-lock-fontify-keywords-region): Pass that new arg.
	(font-lock-set-defaults): Move the code to set `font-lock-keywords'
	to the end and pass that new arg.
	(c-font-lock-keywords-2): Fix regex for labels.
	(font-lock-match-c++-style-declaration-item-and-skip-to-next):
	Make it work when LIMIT is several lines further.
	(c-font-lock-keywords-3, c++-font-lock-keywords-3)
	(objc-font-lock-keywords-3, java-font-lock-keywords-3):
	Use backquote and make the regexes for `int a, b, c;' work on
	multiple lines.

	* emacs-lisp/re-builder.el (reb-mode): Use define-derived-mode.
	(font-lock-defaults-alist): Don't change it any more.
	(reb-subexp-mode-map): Cleanup.

	* custom.el (custom-current-group-alist): New var.
	(custom-declare-group): Set it.
	(custom-current-group): New fun.
	(custom-declare-variable, custom-handle-all-keywords):
	Use it as a default if no :group argument is specified.

	* international/mule-cmds.el (locale-name-match): Use \` and \(?:.
	(standard-keyboard-coding-systems): New var.
	(set-locale-environment): Use it to decide whether or not to call
	set-keyboard-coding-system.
	(locale-language-names): Use \"French\" for "fr".

2001-11-17  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/checkdoc.el (princ-list, checkdoc-read-event)
	(add-to-list): Delete compatibility code.
	(checkdoc-next-message-error): Doc fix.

2001-11-17  Stephen Eglen  <stephen@gnu.org>

	* locate.el (locate): Show default locate pattern within the
	prompt, but don't insert it into the minibuffer contents.
	Catch the case when pattern is the empty string.

2001-11-17  Eli Zaretskii  <eliz@is.elta.co.il>

	* language/european.el ("French"): New language environment.

2001-11-16  Richard M. Stallman  <rms@gnu.org>

	* calendar/todo-mode.el (todo-save): Fix previous change.

	* subr.el (functionp): Do use cdr-safe on object.

2001-11-16  Stefan Monnier  <monnier@cs.yale.edu>

	* bindings.el (mode-line-mode-name): Only put the help-echo property
	if the local-map property was put as well.
	(global-map): Bind switch-frame, delete-frame, iconify-frame
	and make-frame-visible events.

	* emacs-lisp/elp.el (elp-not-profilable): New var.
	(elp-not-profilable-p): New function.
	(elp-instrument-function): Use it.  Use backquotes and push.

	* emacs-lisp/bytecomp.el (byte-compile-call-tree, byte-code-vector)
	(byte-stack+-info, byte-compile-last-warned-form)
	(byte-compile-last-logged-file): Don't defconst a variable.
	(no-byte-compile): Declare.
	(byte-compile-file): Don't boundp-check no-byte-compile any more.
	(byte-compile-defvar): Leave defconst as is.

	* emacs-lisp/edebug.el (edebug-form-data, edebug-offsets)
	(edebug-offsets-stack, edebug-read-dotted-list, edebug-def-name)
	(edebug-current-offset, edebug-old-def-name, edebug-error-point)
	(edebug-best-error): Don't defconst a variable.
	(edebug-read-syntax-table): Use a char-table.
	(edebug-lemacs-specific): Remove.
	Toplevel: Eliminate check for Lucid Emacs.

	* pcvs-util.el (cvs-prefix-define): Don't defconst a variable.

	* rect.el (move-to-column-force): Mark obsolete.
	(operate-on-rectangle, delete-extract-rectangle-line)
	(insert-rectangle, delete-whitespace-rectangle-line)
	(open-rectangle-line, clear-rectangle-line): Use move-to-column.
	(string-rectangle-history): New var.
	(string-rectangle, string-insert-rectangle): Use it.
	(delete-rectangle-line): Fix pos/column mixup and simplify.

	* startup.el (normal-top-level-add-subdirs-to-load-path): Simplify.
	(normal-top-level, command-line, command-line-1): Simplify.

	* tar-mode.el (tar-mode): Use define-derived-mode.

	* view.el (view-mode-enable): Don't use make-local-hook.

	* emacs-lisp/eldoc.el (eldoc-mode): Use define-minor-mode.

2001-11-16  Richard M. Stallman  <rms@gnu.org>

	* mail/mail-extr.el (mail-extr-voodoo): Treat a number as a word
	if it doesn't make sense as anything else.
	Don't recognize a "telephone number" at the beginning of the name.
	(mail-extr-leading-garbage): Match non-word characters only.

2001-11-16  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* startup.el (command-line-processed): Doc fix.

	* apropos.el (apropos-next-label-button): Doc fix.

2001-11-16  Stefan Monnier  <monnier@cs.yale.edu>

	* comint.el (comint-mode): Simplify.
	(make-comint-in-buffer): Run `comint-mode' only if necessary.

	* subr.el (eval-after-load): Make it work with features as well.

	* log-view.el (log-view-mode): Don't mark the buffer unmodified.

	* international/mule-cmds.el (describe-input-method): Setup xref.
	(set-language-environment): Use functionp.
	(locale-language-names, locale-charset-language-names)
	(locale-preferred-coding-systems): Defconst and purecopy.

	* language/european.el (mac-roman): Add mime-charset property.

2001-11-15  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/cl.el (values, values-list, multiple-value-list)
	(multiple-value-apply, nth-value): Use defsubst rather than defalias
	to get better doc strings.

2001-11-15  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* derived.el: Fix autoload cookie.

2001-11-15  Richard M. Stallman  <rms@gnu.org>

	* jka-compr.el (jka-compr-partial-uncompress): Fix previous change.

2001-11-15  Stefan Monnier  <monnier@cs.yale.edu>

	* menu-bar.el (menu-bar-edit-menu) <copy>: Put an explicit key binding.

2001-11-15  Richard M. Stallman  <rms@gnu.org>

	* dired.el (dired-undo): Display a message to explain
	that this does not undo file system changes.

2001-11-15  David Kastrup  <David.Kastrup@t-online.de>

	* mouse-drag.el (mouse-drag-throw): Push back non-drag events
	into `unread-command-events' instead of trying keymap
	lookups ourselves.  This makes mouse-clicks do the right
	thing even when keymaps of overlays are involved.
	(mouse-drag-drag): Likewise.

2001-11-15  Andreas Schwab  <schwab@suse.de>

	* progmodes/ada-mode.el (ada-add-extensions): Quote regexp special
	characters and append anchor to pattern added to auto-mode-alist.

2001-11-15  Stefan Monnier  <monnier@cs.yale.edu>

	* server.el (server-process-filter): Run pore/post-comment-hook
	before/after visiting the file.

	* info-look.el (makefile-mode): Add info for automake.
	(autoconf-mode): Fix the name of the index for automake.

	* international/latin-9.el: Give pilcrow punctuation syntax.

2001-11-15  Andre Spiegel  <spiegel@gnu.org>

	* vc.el: Documentation fixes.

2001-11-14  Stefan Monnier  <monnier@cs.yale.edu>

	* smerge-mode.el (smerge-match-conflict): Fix typo.
	(smerge-diff): Be careful to read match-data early enough.

2001-11-14  Colin Walters  <walters@verbum.org>

	* calc/calc-alg.el (calcFunc-esimplify, calcFunc-simplify)
	(calcFunc-subst): Use `defalias' instead of `fset' and
	`symbol-function'.

	* calc/calc-arith.el (calcFunc-abs, calcFunc-float)
	(calcFunc-ceil, calcFunc-round): Ditto.

	* calc/calc-bin.el (calcFunc-clip): Ditto.

	* calc/calc-ext.el (calcFunc-evalv): Ditto.

	* calc/calc-math.el (calcFunc-sqrt, calcFunc-hypot): Ditto.

	* calc/calc-misc.el (math-fixnump, math-fixnatnump)
	(calcFunc-trunc, calcFunc-floor, calc-report-bug): Ditto.

	* calc/calc-units.el (calcFunc-unsimplify): Ditto.

	* calc-aent.el, calc-ext.el, calc-incom.el, calc-misc.el
	* calc-sel.el, calc-vec.el, calc-alg.el, calc-fin.el
	* calc-keypd.el, calc-mode.el, calc-stat.el, calc-yank.el
	* calc-arith.el, calc-forms.el, calc-lang.el, calc-mtx.el
	* calc-store.el, calc.el, calc-bin.el, calc-frac.el, calc-macs.el
	* calc-poly.el, calc-stuff.el, calcalg2.el, calc-comb.el
	* calc-funcs.el, calc-maint.el, calc-prog.el, calc-trail.el
	* calcalg3.el, calc-cplx.el, calc-graph.el, calc-map.el
	* calc-rewr.el, calc-undo.el, calccomp.el, calc-embed.el
	* calc-help.el, calc-math.el, calc-rules.el, calc-units.el
	* calcsel2.el: Style cleanup; don't put closing parens on their
	own line, add "foo.el ends here" to each file, and update
	copyright date.

	* README: Update maintainer.

2001-11-13  Richard M. Stallman  <rms@gnu.org>

	* progmodes/compile.el (recompile): Use compilation-arguments if
	set, so as to be able to M-x recompile the exact command which
	created a compilation-mode buffer.

	* progmodes/ada-mode.el (ada-fill-comment-prefix): Doc fix.

2001-11-13  Gerd Moellmann  <gerd@gnu.org>

	* mouse.el (mouse-drag-region): Don't run the up-event
	handler if window start changed due to the down-mouse event.

2001-11-13  Richard M. Stallman  <rms@gnu.org>

	* mouse.el (mouse-show-mark): Either move point to the mark
	or use highlighting, never both.
	(mouse-buffer-menu): If WINDOW is a frame, select its selected window.

2001-11-13  Simon Josefsson  <jas@extundo.com>

	* mail/smtpmail.el (top-level): Change maintainer to Simon
	Josefsson, cleanup the smtpmail.el header.

	* mail/smtpmail.el (top-level): Don't require cl or base64.
	(smtpmail-cred-server, smtpmail-cred-port, smtpmail-cred-key)
	(smtpmail-cred-user, smtpmail-cred-cert, smtpmail-cred-passwd):
	Defsubst instead of defmacro.
	(smtpmail-intersection): Return value in reverse order.
	(smtpmail-open-stream): Use stringp instead of string-to-list.
	(smtpmail-open-stream, smtpmail-try-auth-methods): New functions,
	separated from smtpmail-via-smtp.

	* mail/smtpmail.el (top-level): Autoload starttls, mail-utils and
	rfc2104.  Require base64 and cl.
	(smtpmail-smtp-service): Doc fix.  :type fix.
	(smtpmail-debug-info): Doc fix.
	(smtpmail-debug-verb, smtpmail-auth-credentials)
	(smtpmail-starttls-credentials, smtpmail-auth-supported):
	New variables.
	(smtpmail-deduce-address-list, smtpmail-send-it): Don't require
	mail-utils (it is autoloaded).
	(smtpmail-cred-server, smtpmail-cred-port, smtpmail-cred-key)
	(smtpmail-cred-user, smtpmail-cred-cert, smtpmail-cred-passwd)
	(smtpmail-find-credentials, smtpmail-intersection): New utility funs.
	(smtpmail-via-smtp): Support STARTTLS, if binary is installed.
	(smtpmail-via-smtp): Support AUTH.
	(smtpmail-via-smtp): Use `smtpmail-debug-verb' to control VERB.

2001-11-13  Richard M. Stallman  <rms@gnu.org>

	* ebuff-menu.el (electric-buffer-update-highlight): New function.
	(electric-buffer-overlay): New variable.
	(electric-buffer-menu-looper): Call electric-buffer-update-highlight.
	(electric-buffer-list): Likewise.

	* isearch.el (isearch-whitespace-chars): Doc fix.
	(isearch-mode): Handle negative search-slow-window-lines correctly.

2001-11-13  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el (comment-normalize-vars): Handle a nil comment-padding.

	* progmodes/ada-mode.el (ada-fill-comment-prefix): GNAT wants 2 spaces.
	From Emmanuel Briot <briot@act-europe.fr>.

2001-11-13  Colin Walters  <walters@debian.org>

	* calc/calc.el (calc-unread-command): Use `unread-command-events'.

	* calc/calc-mode.el (calc-settings-file-name): Don't hardcode
	"~/.emacs"; use `read-file-name'.

	* calc/calc-graph.el, calc/calc-embed.el, calc/calc-graph.el
	* calc/calc-misc.el, calc/calc-mode.el, calc/calc-prog.el
	* calc/calc-sel.el, calc/calc-store.el, calc/calc-yank.el
	* calc/calc.el: Use `frame-width' instead of `screen-width',
	`frame-height' instead of `screen-height', and,
	`executing-kbd-macro' instead of `executing-macro'.

	* calc/calc-embed.el (calc-do-embedded): Call `y-or-n-p' with
	correct number of arguments.

	* calc/calc-aent.el (calc-do-alg-entry):
	Use `blink-paren-function' instead of `blink-paren-hook'.

2001-11-12  Richard M. Stallman  <rms@gnu.org>

	* calendar/todo-mode.el (todo-save): Add save-excursion
	and save-restriction.

	* server.el (server-edit, server-done): Doc fix.

	* simple.el (clone-indirect-buffer): Error if major mode symbol
	has a no-clone-indirect property.
	(clone-buffer): Check for obvious errors before reading clone name.

	* info.el (Info-mode): Add a no-clone-indirect property.

2001-11-12  Sam Steingold  <sds@gnu.org>

	* vc.el (vc-print-log): Bind `inhibit-read-only' to t before and
	set-buffer-modified-p to nil after `vc-exec-after'.
	* log-view.el (log-view-mode-map): Bind "q", "z", "m" and "d".
	(log-view-mode): Make read-only.
	(log-view-current-file): Do final `expand-file-name' in the
	current `default-directory'.
	(log-view-current-tag): Take an optional `where' arg.
	(log-view-diff): New user command.

2001-11-12  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* progmodes/cpp.el (cpp-choose-face): Fix typo.

2001-11-12  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/cl-indent.el (toplevel): Indent properly
	`generic-flet', `generic-labels', `with-accessors',
	`with-condition-restarts'.

2001-11-12  Richard M. Stallman  <rms@gnu.org>

	* dired.el: Many trivial doc fixes.
	(dired-get-file-for-visit): New function.
	(dired-find-alternate-file, dired-mouse-find-file-other-window):
	(dired-view-file, dired-find-file-other-window, dired-display-file):
	(dired-find-file): Use dired-get-file-for-visit.

2001-11-12  Alex Schroeder  <kensanata@yahoo.com>

	* sql.el (sql-mode): Doc change.

	* sql.el (sql-mode-syntax-table): The backslash is no longer an
	escape character.

2001-11-12  Colin Walters  <walters@debian.org>

	* calc/calc-keypd.el (toplevel): Bind mouse buttons.
	(calc-do-keypad): Don't attempt to use nonexistent global
	mouse-map, use calc-keypad-map.
	(calc-keypad-x-left-click): Renamed to calc-keypad-left-click.
	(calc-keypad-left-click): Don't use mouse-map; update to new event
	interface.
	(calc-keypad-x-middle-click, calc-keypad-x-right-click): Ditto.
	(calc-keypad-press): Use `unread-command-events' instead of
	`unread-command-char'.

	* calc/calc-ext.el (calc-init-extensions): Update autoload names
	to match files renamed on initial calc import.

2001-11-12  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* textmodes/flyspell.el (flyspell-default-dictionary):
	Fix previous change.

2001-11-12  Richard M. Stallman  <rms@gnu.org>

	* textmodes/flyspell.el (flyspell-default-dictionary):
	Fix custom type.

2001-11-11  Richard M. Stallman  <rms@gnu.org>

	* calendar/solar.el (solar-sunrise-and-sunset):
	Exchange the two extreme values of day-length.

	* progmodes/sh-script.el (sh-must-be-shell-mode):
	Allow modes derived from sh-mode.

	* emacs-lisp/checkdoc.el (checkdoc-file-comments-engine):
	Turn off error in some re-search-forward calls.

	* replace.el (query-replace-skip-read-only): New variable.
	(perform-replace): If that variable is non-nil, ignore matches
	that have a read-only property.

	* derived.el (define-derived-mode): Doc fix.

	* server.el (server-buffer-done): Test of server-existing-buffer
	was backwards.
	(server-existing-buffer): Doc fix.

	* textmodes/flyspell.el (flyspell-default-dictionary):
	Allow nil as value, and make nil the default.

2001-11-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-edit-menu): Don't use x-selection-exists-p if
	it is not fboundp.
	(clipboard-yank): Ditto.

2001-11-11  Colin Walters  <walters@verbum.org>

	The following changes are based on patches from
	Eli Zaretskii <eliz@is.elta.co.il>, Kai Gro,A_(Bjohann
	<Kai.Grossjohann@CS.Uni-Dortmund.DE>, and others.

	* calc/calc.el (toplevel): Require calc-macs.
	(calc-minibuffer-size): New.
	(calcDigit-nondigit): Use it instead of `buffer-size'.
	(calcDigit-backspace): Likewise.
	(calcDigit-nondigit): Use `minibuffer-contents' instead of
	`buffer-string'.
	(calc-minibuffer-contains): Use `minibuffer-prompt-end' instead of
	`point-min'.
	(calcDigit-key): Use `calc-minibuffer-contains' instead of a
	`save-excursion'.

	* calc/calc-macs.el (calc-record-compilation-date-macro): Return a
	simple `setq' form.

	* calc/calc-ext.el: (toplevel): Require calc.
	(calc-fancy-prefix-map): New.
	(calc-fancy-prefix): Use it.
	(calc-fancy-prefix-other-key): New.

	* calc/calc-aent.el (toplevel): Require calc-macs during compilation.
	(calc-do-quick-calc): Use `frame-width' instead of `screen-width'.
	(calcAlg-edit): Use `minibuffer-contents' instead of `buffer-string'.
	(calcAlg-enter): Likewise.
	(calcAlg-enter): Use `minibuffer-prompt-end' instead of `point-min'.

2001-11-10  Richard M. Stallman  <rms@gnu.org>

	* abbrev.el (read-abbrev-file): Don't set save-abbrevs.
	(quietly-read-abbrev-file): Doc fix.

	* startup.el (command-line): Read standard abbrev
	file (abbrev-file-name), if it exists.

	* files.el (save-abbrevs): Default value is t.

	* progmodes/compile.el (compile-goto-error): Fix previous change
	in the case where subsequent errors have not been parsed yet
	because they are in a different source file.

2001-11-10  Peter Kleiweg  <kleiweg@let.rug.nl>

	* progmodes/ps-mode.el (ps-mode-font-lock-keywords-1):
	Merge two regular expressions into one.
	(ps-mode): Make local bindings for `comment-start' and
	`comment-start-skip'.
	(ps-mode-looking-at-nested): Simplify an if-else construct;
	use `set-match-data' to set the result.

2001-11-10  Richard M. Stallman  <rms@gnu.org>

	* textmodes/flyspell.el (flyspell-correct-word/local-keymap):
	Function deleted.
	(flyspell-correct-word): Old definition deleted.
	(flyspell-correct-word/mouse-keymap): Renamed to flyspell-correct-word.
	All references renamed too.

2001-11-10  Gerd Moellmann  <gerd@gnu.org>

	* Makefile.in (finder_setwins, setwins): Exclude Calc.

2001-11-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* wid-edit.el (checklist): Removed `:menu-tag'.
	(radio-button-choice): Ditto.
	(editable-list): Ditto.

2001-11-09  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* play/gomoku.el: Move definitions of constants to the beginning
	of file, before their use.

2001-11-09  Richard M. Stallman  <rms@gnu.org>

	* textmodes/flyspell.el: Use the keymap property
	instead of local-map, and don't use a minor-mode map.
	(flyspell-mode-map): Variable deleted.
	Don't mess with minor-mode-map-alist.
	(calling add-minor-mode): Specify nil for keymap.
	And always use add-minor-mode, now that it exists.
	(flyspell-overlay-keymap-property-name): Set it to `keymap'.
	(flyspell-mode-on): Don't locally bind flyspell-mouse-map
	or flyspell-local-mouse-map.
	(make-flyspell-overlay): Use flyspell-mouse-map directly.
	(flyspell-mode): Doc fix.
	(flyspell-mode-on): Don't call make-local-hook.

2001-11-09  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/debug.el (debugger-make-xrefs):
	Add buttons to all symbols.

2001-11-09  Andre Spiegel  <spiegel@gnu.org>

	* vc.el: Add John David Smith to credits.

	Suggested by Kalle Olavi Niemitalo <kon@iki.fi>:

	* vc-hooks.el (vc-error-occured): Backquotified.
	(vc-file-prop-obarray): Use prime length for better efficiency.

	* vc.el (vc-clear-context): Fill obarray with 0, not nil.

2001-11-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-file-list-for-emacs): Add entries for Calc.

2001-11-09  Miles Bader  <miles@gnu.org>

	* subr.el (functionp): Don't consider macros as functions.

2001-11-08  Miles Bader  <miles@gnu.org>

	* subr.el (functionp): Make work correctly for macros and unbound
	symbols.

	* comint.el (comint-send-input): Fix description of
	`comint-process-echoes' in the doc-string.

2001-11-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/mule.el (make-translation-table): Doc fix.
	Suggested by Alex Schroeder <alex@gnu.org>.

2001-11-07  Richard M. Stallman  <rms@gnu.org>

	* info.el (Info-fontify-node): Highlight every third menu item.

2001-11-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-face-value-create): Don't ignore the
	`customized-face' attribute when finding the current face spec.

2001-11-07  Stefan Monnier  <monnier@cs.yale.edu>

	* subr.el (with-local-quit): New macro.
	(make-syntax-table): Always inherit.
	(functionp): Be more careful when `object' is a symbol.

	* dabbrev.el (dabbrev-completion): Use "*Completions*".

2001-11-07  Paul Eggert  <eggert@twinsun.com>

	* dired.el (dired-move-to-filename-regexp):
	Do not distinguish between ASCII letters and non-ASCII characters.
	Don't allow comma except in the form "month day, year".
	Don't allow space between month name and comma.
	Clean up the code that checks for trailing period, comma, and space.
	Remove now-obsolete comments, and add more commentary about
	Japanese dates.
	Always gobble up trailing spaces, instead of doing it only sometimes.

2001-11-07  Miles Bader  <miles@gnu.org>

	* paren.el (show-paren-match-face): Add dark-background variant.

2001-11-06  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/lisp-mode.el (lisp-imenu-generic-expression): Paren typo.
	(lisp-mode-variables): Don't set paragraph-{start,separate}.
	Don't disable adaptive-fill-mode.
	(lisp-fill-paragraph): Use tab-width rather than 8.
	Prevent filling the first line of docstrings.

2001-11-06  Richard M. Stallman  <rms@gnu.org>

	* play/gomoku.el (gomoku): Doc fix.

	* jka-compr.el (jka-compr-partial-uncompress):
	Support an alternative of not using dd.
	(jka-compr-dd-program): Use defcustom to define this.
	(jka-compr-load-suffixes): Use defcustom.
	(jka-compr-mode-alist-additions): Use defcustom.

2001-11-06  Stefan Monnier  <monnier@cs.yale.edu>

	* font-lock.el (font-lock-match-c-style-declaration-item-and-skip-to-next):
	Also work when LIMIT is further than the end of line.

2001-11-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/quail.el (quail-update-leim-list-file): Print the
	offending file name if some of its quail-define-package forms is broken.

2001-11-05  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/lisp-mode.el (eval-last-sexp-1): Return the value
	of the evaluated form.

2001-11-05  Paul Eggert  <eggert@twinsun.com>

	* ls-lisp.el (ls-lisp-time-to-seconds): New function.
	(ls-lisp-format-time): Emulate GNU fileutils 4.1.1 ls, whose time
	stamps always line up by default.  Also, it uses a slightly
	different window to determine whether files are "recent".

2001-11-05  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in (bootstrap-clean-CMD, bootstrap-clean-SH):
	Don't attempt to remake autoloads before nuking .elc files.

2001-11-04  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/lisp-mode.el (last-sexp-toggle-display): Cope if
	previous-single-property-change or next-single-char-property-change
	returns nil.

	* international/mule-cmds.el (set-locale-environment):
	Make it interactive; make arg optional.

	* international/mule-diag.el (help-funs): Require help-funs.

2001-11-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (term-setup-hook): Add IT-setup-unicode-display.

2001-11-04  Miles Bader  <miles@gnu.org>

	* startup.el (fancy-splash-head): Reapply Gerd's hack to make the
	shadow of the splash image grey on a dark background instead of black.

2001-11-03  Stefan Monnier  <monnier@cs.yale.edu>

	* term.el (all faces): Don't (copy-face 'default <foo>).

	* term/xterm.el (function-key-map):
	Add entry for `ESC [ 3 ~' -> <delete>
	Add entries `ESC O 5 [ABCD]' -> C-{up,down,right,left}.
	Use inheritance so that .emacs and terminfo take precedence.

2001-11-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* tooltip.el (tooltip-delay): Decrease to 0.7.
	(tooltip-hide-delay): Enlarge to 10.

2001-11-03  Richard M. Stallman  <rms@gnu.org>

	* startup.el (fancy-splash-tail): Explain how to recover
	from a crash, if there was a crash.
	(command-line-1): Reorganize display of startup screen,
	to simplify the logic.  Use a temp buffer for it.

2001-11-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.el (set-background-color, set-foreground-color):
	Call face-set-after-frame-default, to propagate the new colors to
	the frame's parameters alist.

	* calendar/timeclock.el (timeclock-out): Signal an error if
	timeclock-last-event is nil.

2001-11-02  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/fill.el (fill-context-prefix): Fix braino.

	* international/quail.el (quail-help):
	Use `help-buffer' and move `help-setup-xref' to beginning.

	* international/mule-cmds.el (describe-language-environment):
	Use `help-buffer' and move `help-setup-xref' to beginning.

	* international/mule-diag.el (list-character-sets)
	(sort-listed-character-sets, describe-character-set)
	(describe-coding-system, describe-fontset, list-fontsets):
	Use `help-buffer' and move `help-setup-xref' to beginning.
	(describe-char-after): Use `internal-describe-syntax-value'.

2001-11-02  Richard M. Stallman  <rms@gnu.org>

	* mouse.el (popup-menu): If the user refuses to select
	from a menu, don't try to invoke the menu.

2001-11-02  Miles Bader  <miles@gnu.org>

	* help-mode.el (help-xref): New button type.
	(help-function, help-variable, help-face, help-coding-system)
	(help-input-method, help-character-set, help-type, help-symbol)
	(help-back, help-info, help-customize-variable, help-customize-face)
	(help-function-def, help-variable-def): Use it as a supertype.
	Remove `action' property.

	* international/mule-diag.el (describe-character-set)
	(describe-coding-system): Pass correct args to `help-xref-button'.
	(sort-listed-character-sets): New button type.
	(list-character-sets): Use it.
	(list-charset-chars): New button type.
	(list-character-sets-1): Use it.

2001-11-01  Stefan Monnier  <monnier@rum.cs.yale.edu>

	* indent.el (tab-always-indent, indent-for-tab-command):
	Remove redundant `never' setting.

	* fill.el (fill-region-as-paragraph): Don't forget to skip
	over current whitespace before looking for a preceding space.

2001-11-01  Richard M. Stallman  <rms@gnu.org>

	* files.el (file-newest-backup): Don't pass backup file name
	thru file-name-sans-versions, because it never has version numbers.

	* textmodes/sgml-mode.el (sgml-xml-guess): Fix regexp
	to avoid ambiguous nested loops.

	* files.el (find-file-noselect): Offer to change buffer-read-only
	only when the file's read-only status has changed from before
	as well as disagreeing with the buffer's current status.
	(buffer-file-read-only): New var, local in all buffers.

	* buff-menu.el (buffer-menu): Doc fix.
	(buffer-menu-other-window): Doc fix.
	(list-buffers, list-buffers-noselect): Doc fix.

2001-11-01  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (command-line): If the terminal Emacs is running on
	has erase char set to ^H, use the Backspace key for deleting
	backward, and the Delete key for deleting forward.

2001-11-01  Miles Bader  <miles@gnu.org>

	* button.el (define-button-type): Make sure every user-defined
	button type has a supertype.

2001-10-31  Jason Rumney  <jasonr@gnu.org>

	* international/mule-cmds.el (locale-language-names): Add chs and
	cht as aliases for Chinese-GB and Chinese-BIG5.

2001-10-31  Richard M. Stallman  <rms@gnu.org>

	* bindings.el (mode-line-frame-identification): Add doc string.
	(mode-line-position, mode-line-modes): New variables.
	(mode-line-format): Use mode-line-position for the part
	that displays the position-in-buffer info.
	Use mode-line-modes for the part that displays major and minor modes.

2001-10-31  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/debug.el (debugger-make-xrefs): New function.
	(debugger-setup-buffer): Call it.
	(debugger-mode-map): Bind RET and mouse-2.

2001-10-31  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* startup.el: Document command line option --no-window-system
	instead of --no-windows.

2001-10-30  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/autoconf.el (autoconf-mode): Fix comment-start-skip.

	* font-lock.el (java-font-lock-syntactic-face-function): New fun.
	(font-lock-defaults-alist): Use it.
	From David Ponce <david.ponce@wanadoo.fr>

	* progmodes/perl-mode.el (perl-indent-line): Use `eq' to compare
	output of `char-after'.

	* bindings.el (ctl-x-map): Add binding for C-x (, C-x ) and C-x e.

	* simple.el (reindent-then-newline-and-indent): Insert the newline
	before indenting the first line.
	(undo-get-state, undo-revert-to-state): New funs.
	(shell-command): Don't kill the buffer even if empty.
	(transpose-subr-start1, transpose-subr-start2, transpose-subr-end1)
	(transpose-subr-end2): Remove.
	(transpose-subr): Add `special' arg and simplify.
	(transpose-subr-1): Rewrite.
	(do-auto-fill): Use fill-indent-according-to-mode and fill-nobreak-p.
	(rfc822-goto-eoh): Simplify.

2001-10-30  Richard M. Stallman  <rms@gnu.org>

	* enriched.el (enriched-face-ans): Fix previous change.

2001-10-30  Gerd Moellmann  <gerd@gnu.org>

	* international/iso-acc.el (iso-accents-compose): Remove a
	superfluous setq.

2001-10-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* buff-menu.el (list-buffers-noselect): If the buffer's name
	starts with a blank, but it visits a file, do show it (for files
	whose names start with a blank).

2001-10-30  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/fill.el (sentence-end-double-space)
	(sentence-end-without-period): Move to paragraphs.el.
	(fill-indent-according-to-mode): Change default to t.
	(fill-context-prefix): Simplify control-flow and use a more
	sophisticated merge that unifies both previous checks.
	(fill-single-word-nobreak-p, fill-french-nobreak-p): New funs.
	(fill-nobreak-predicate): Make it into a defcustom'd hook.
	(fill-nobreak-p): New fun.
	(fill-region-as-paragraph): Use it.
	Handle `fill-indent-according-to-mode' slightly differently.
	(fill-individual-paragraphs-prefix): Simplify the control-flow.
	(fill-individual-paragraphs-citation): Fix.

	* textmodes/paragraphs.el (use-hard-newlines): Use define-minor-mode.
	(paragraph-start): Change default to the `text-mode' value.
	(sentence-end-double-space, sentence-end-without-period):
	Move from fill.el.
	(forward-paragraph): Use `parstart' and `parsep' for temp variables
	rather than rebinding `paragraph-start' and `paragraph-separate'.

	* indent.el (indent-line-function): Change default to indent-relative.
	(tab-always-indent): Add an `never' setting.
	(indent-according-to-mode): Handle `indent-relative' and
	`indent-relative-maybe' specially.
	(indent-for-tab-command): Rename `prefix-arg' to `arg'.
	Handle the `never' case for `tab-always-indent'.
	Don't call indent-according-to-mode for indent-relative' and
	`indent-relative-maybe'.
	(insert-tab): Rename `prefix-arg' to `arg'.
	(indent-region): Indent the first line as well.
	(indent-relative): Don't mark the buffer modified if the indentation
	is unchanged.

	* textmodes/text-mode.el (paragraph-indent-minor-mode):
	Don't set paragraph-separate.  Set paragraph-start more carefully.
	Set indent-line-function.
	(paragraph-indent-text-mode): Use it and define-derived-mode.
	(text-mode-map): Remove the \t binding.
	(text-mode): Simplify now that the default is more favorable.

2001-10-29  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/find-func.el (find-function-search-for-symbol):
	If the regexp doesn't match, use a looser one.
	(find-variable-noselect): Add `file' argument.

	* pcvs.el (cvs-mode-commit-hook): New hook.
	(cvs-mode-commit): Run it.

	* log-edit.el (log-edit): Run hook after `log-edit-files'.

	* emacs-lisp/edebug.el (delay-mode-hooks): Add edebug-spec.
	(edebug-instrument-function): Use `find-function-noselect'.

2001-10-29  Richard M. Stallman  <rms@gnu.org>

	* term.el (term-if-emacs19): Macro deleted.
	Callers changed to use progn instead.

	* frame.el (blink-cursor-mode): Doc fix.

	* files.el (find-backup-file-name): Use make-backup-file-name.

	* emacs-lisp/edebug.el (edebug-window-live-p): Always alias to
	window-live-p.
	(edebug-set-conditional-breakpoint): Unconditionally use
	the former Emacs >=19 definition.
	(edebug-mark): Define unconditionally.
	(edebug-eval-expression): Always call read-from-minibuffer
	and specify history list.
	(edebug-lemacs-specific): Override emacs-mark, edebug-window-live-p,
	edebug-set-conditional-breakpoint.
	(edebug-emacs-version-specific): Function deleted;
	do the job at top level.
	(edebug-emacs-19-specific): Function deleted, this is the default.

2001-10-29  Sam Steingold  <sds@gnu.org>

	* w32-fns.el (convert-standard-filename): Handle cygwin-specific
	"/cygdrive/LETTER/" pathnames.

2001-10-29  Eli Zaretskii  <eliz@is.elta.co.il>

	* faces.el (invert-face): Check for 'unspecified, not for nil,
	when testing whether face colors are not specified.
	From David.Kastrup@t-online.de (David Kastrup).
	(read-face-name): Doc fix.
	(make-face-bold, make-face-unbold, make-face-italic)
	(make-face-unitalic, make-face-bold-italic, invert-face):
	Remove trailing blank from the prompt passed to read-face-name.

2001-10-29  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/bytecomp.el (byte-recompile-directory):
	Report numbers of files skipped and failed too.
	(byte-compile-file): Return 'no-byte-compile for skipped files.

2001-10-29  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* log-view.el (log-view-mode-map): Bind `M-n' and `M-p', not `M n'
	and `M p'.

2001-10-29  Gerd Moellmann  <gerd@gnu.org>

	* international/iso-acc.el (iso-accents-compose): Push SECOND-CHAR
	as is on unread-command-events instead of `(SECOND-CHAR)'.

2001-10-29  Andre Spiegel  <spiegel@gnu.org>

	* vc.el: Mention vc-*-switches in backend API documentation.
	(vc-annotate): Adapt doc string to recent change.

2001-10-29  Gerd Moellmann  <gerd@gnu.org>

	* enriched.el (enriched-face-ans): Handle face attributes
	of the form `(FACE1 FACE2 ...)'.

	* dired-x.el (dired-omit-startup): Show ``Omit'' only in Dired buffers.

2001-10-29  Alex Schroeder  <kensanata@yahoo.com>

	* progmodes/sql.el (sql-mysql): Doc change by RMS.

	* progmodes/sql.el (sql-db2): Doc change.
	(sql-help): Doc change by Christian Egli <christian.egli@stest.ch>.
	(sql-mysql): Doc change by Christian Egli <christian.egli@stest.ch>.

2001-10-29  Gerd Moellmann  <gerd@gnu.org>

	* env.el (substitute-env-vars): Don't quote argument to `rx';
	it's a macro.

2001-10-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-start.el (recursive-load-depth-limit): Added.

2001-10-28  Richard M. Stallman  <rms@gnu.org>

	* textmodes/ispell.el (version18p, version20p): Vars deleted.
	All uses removed--assume Emacs version is >= 20.

	* mail/supercite.el (sc-emacs-features): Test for "Emacs 19"
	by really checking that it is not version 18.

	* emacs-lisp/lisp-mode.el (eval-defun): Doc fix.

2001-10-28  Miles Bader  <miles@gnu.org>

	* faces.el (face-attribute): Add INHERIT argument, consider face
	inheritance if it's non-nil.
	(face-attribute-merged-with): New function.
	(face-attribute-specified-or): New macro.
	(face-foreground, face-background, face-stipple): Add INHERIT
	argument.  Use `face-attribute-specified-or'.

2001-10-28  Stefan Monnier  <monnier@cs.yale.edu>

	* font-lock.el: Require `syntax'.
	(font-lock-defaults-alist): Don't define keywords for lisp languages.
	Use `c-font-lock-syntactic-face-function' for c languages.
	(font-lock-mode): Don't unset vars when turning the mode off.
	(font-lock-default-fontify-buffer): Don't unset vars at the end.
	(font-lock-extra-managed-props): New var.
	(font-lock-default-unfontify-region): Use it.
	(font-lock-apply-syntactic-highlight): Flush the syntax cache.
	Don't eval the value when there's no match.
	(font-lock-ppss-stats): New var.
	(font-lock-ppss): New fun.
	(font-lock-fontify-syntactically-region): Use it and syntax.ppss.
	(font-lock-apply-highlight): Allow `highlight' to set several props.
	(font-lock-set-defaults): Use dolist.
	(font-lock-unset-defaults): Remove.
	(font-lock-match-c-style-declaration-item-and-skip-to-next):
	Try to recognize prototypes using `foo P_ ((args))'.
	({c,c++,java,objc}-font-lock-keywords-{1,2,3}): Don't setq a defconst.
	(c-font-lock-keywords-2): Fix last change to still use Anders' trick.
	(c-font-lock-syntactic-face-function): New function.
	(font-lock-match-c++-style-declaration-item-and-skip-to-next)
	(c++-keywords): Use a more sophisticated regexp to handle
	shallowly nested templates.

2001-10-27  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/sgml-mode.el (sgml-empty-tags): New var.
	(sgml-tag): Use it.  Cleanup with `cond'.
	(sgml-tags-invisible): Make sgml-tags-invisible buffer-local.
	Mark the overlays and only delete those that are marked.
	(sgml-skip-close-p): Remove.
	(sgml-value): Replace sgml-skip-close-p with its definition.
	(html-tag-alist): Use sgml-xml a bit more.
	(html-mode): Set sgml-empty-tags.

	* textmodes/texnfo-upd.el: Use `when', `dolist', `push', ...
	(texinfo-update-node, texinfo-sequential-node-update):
	Don't bind the obsolete `auto-fill-hook'.
	(texinfo-multi-file-included-list,texinfo-multi-file-master-menu-list):
	Use `set-buffer' rather than `switch-to-buffer'.
	(texinfo-multi-file-update): Use "Top" rather than `up-node-name'.
	Use `set-buffer' rather than `switch-to-buffer'.

	* mail/sendmail.el (mail-mode-syntax-table): Let it inherit from
	text-mode-syntax-table.
	(mail-mode): Use define-derived-mode.
	Fix ordering of alternatives in adaptive-fill-regexp.
	(mail-mode-map): Don't rely on keymap's internal representation.

2001-10-27  Sam Steingold  <sds@gnu.org>

	* textmodes/sgml-mode.el (sgml-xml): Renamed from `html-xhtml'.
	(sgml-xml-guess): Extracted from `html-mode' and generalized.
	(sgml-mode-common): Call it.
	(sgml-mode, html-mode): Set `mode-name' based on `sgml-xml'.
	(sgml-tag, sgml-skip-close-p, html-tag-alist, html-line)
	(html-horizontal-rule, html-image, html-ordered-list):
	(html-unordered-list, html-list-item, html-paragraph):
	(html-checkboxes, html-radio-buttons): Use `sgml-xml' instead of
	`html-xhtml'.

2001-10-26  Masayuki Ataka  <ataka@milk.freemail.ne.jp>

	* textmodes/texinfmt.el (texinfo-format-ifnotinfo): New function.
	(ifnothtml): New alias.

2001-10-27  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/text-mode.el (text-mode): Use define-derived-mode.
	(toggle-text-mode-auto-fill): Use derived-mode-p.

2001-10-27  Gerd Moellmann  <gerd.moellmann@t-online.de>

	* net/ange-ftp.el (ange-ftp-send-cmd): Call fix-name-func for
	`mdtm'.  From "Forrest Cahoon" <forrest.cahoon@merrillcorp.com>.

2001-10-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/pc-win.el (x-frob-font-slant, x-frob-font-weight):
	Add make-obsolete cookies, to follow faces.el.

	These changes avoid warnings from the byte compiler in faces.el:

	* faces.el (internal-get-face): Use facep instead of the obsolete
	internal-find-face.
	(internal-frob-font-weight, internal-frob-font-slant):
	New defaliases for obsolete functions.
	(x-make-font-bold, x-make-font-demibold, x-make-font-unbold)
	(x-make-font-italic, x-make-font-oblique, x-make-font-unitalic)
	(x-make-font-bold-italic): Use internal-frob-font-weight and
	internal-frob-font-slant aliases instead of the obsolete
	x-frob-... functions.

2001-10-26  Sam Steingold  <sds@gnu.org>

	* textmodes/sgml-mode.el (html-mode): Set `html-xhtml' from the
	DOCTYPE; set `mode-name' based on it.
	(html-tag-alist): Use `html-xhtml' for "li", "dt" and "dd".
	(sgml-tag): Close empty tags in XHTML.

2001-10-26  Jason Rumney  <jasonr@gnu.org>

	* w32-fns.el: (w32-charset-info-alist): Use ANSI for iso10646-1
	when UNICODE is not defined.

2001-10-26  Sam Steingold  <sds@gnu.org>

	* font-lock.el (c-font-lock-keywords-2): Do not require labels to
	be alone on the line.

2001-10-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* button.el (button): Special face definition for MS-DOS terminals.

2001-10-26  Sam Steingold  <sds@gnu.org>

	* progmodes/sh-script.el (sh-font-lock-syntactic-keywords):
	Protect the /= test by checking that the args are non-nil.
	(sh-font-lock-close-heredoc): Check eof for being non-nil.

2001-10-26  Tomas Abrahamsson  <tab@lysator.liu.se>

	* textmodes/artist.el (artist-version): 1.2.4.
	(artist-butlast-fn): New variable.
	(artist-butlast): New function.
	(artist-ellipse-mirror-quadrant): Use it.
	(artist-mouse-draw-poly): Use nil for `point-list'.
	(artist-mouse-draw-poly): Check for point-list being nil.

2001-10-26  Peter Kleiweg  <kleiweg@let.rug.nl>

	* progmodes/ps-mode.el (ps-mode-print-function): Remove quote for
	lambda expression.
	(ps-mode-menu-main): Submenu with options on/off was replaced with
	a toggle button.
	(ps-mode, ps-run-mode): Define with `define-derived-mode'
	(ps-mode): Autoload cookie added on same line as comment
	(ps-mode-tabkey, ps-mode-backward-delete-char):
	(ps-mode-r-balance): Replace `delete-horizontal-space' and
	`indent-to' with `indent-line-to'
	(ps-mode-print-buffer, ps-mode-print-region): Use `funcall'
	instead of `eval'.
	(ps-mode-print-region): Use `with-temp-buffer'.
	(ps-run-start): Use of `mapconcat'.  Use `apply' instead of `eval'.
	(numerous places): Add back-tick and tick around names in
	docstrings, fix punctuation in docstrings, remove trailing spaces.

2001-10-25  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/sgml-mode.el (sgml-font-lock-keywords-1): Ignore comments.
	(sgml-font-lock-keywords-2): Use `eval'.  Moved from sgml-mode-common.
	(sgml-font-lock-syntactic-keywords): New var.
	(sgml-mode-common): Drop the two args.
	Don't make buffer-local variables that aren't used.
	Don't set sgml-font-lock-keywords-2 now that it uses `eval instead.
	Don't set `before-string' props from sgml-display-text.
	(sgml-mode): Use define-derived-mode.
	(sgml-tags-invisible): Use sgml-display-text.
	(sgml-quote): New command.
	(html-tag-alist): Add args for `span'.
	(html-mode): Use define-derived-mode.
	Set sgml-display-text and sgml-tag-face-alist.

2001-10-25  Sam Steingold  <sds@gnu.org>

	* add-log.el (add-log-always-start-new-record): New user option.
	(add-change-log-entry): Use it.

2001-10-25  Richard M. Stallman  <rms@gnu.org>

	* progmodes/etags.el (tags-query-replace): Make tags-loop-scan
	bind case-fold-search if FROM is not all lower case.

2001-10-25  Gerd Moellmann  <gerd@gnu.org>

	* startup.el (normal-top-level): Check for frame-initial-frame
	only if it's really used.

	* mail/mh-utils.el (mh-recenter): Call recenter with arg `(4)'.

	* progmodes/compile.el (compilation-parse-errors-filename-function):
	New variable.
	(compilation-parse-errors): Use it.

2001-10-25  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/checkdoc.el (checkdoc-eval-defun): Call eval-defun
	interactively so that C-u M-C-x still does edebug.
	(checkdoc-sentencespace-region-engine): Don't force a double-space
	after `.' if it doesn't look like an end-of-sentence.
	(debug-ignored-errors): Add `disambiguate ...'.

2001-10-24  Stefan Monnier  <monnier@cs.yale.edu>

	* textmodes/texinfo.el (texinfo-environments)
	(texinfo-environment-regexp): Hoist.
	(texinfo-font-lock-keywords): Use `italic' and `bold' faces.
	Only highlight the menu name in menu items.
	Setup `@foo ... @end foo' as text clones.
	(texinfo-clone-environment): New function.
	(texinfo-mode): Simplify auto-fill-inhibit-regexp.
	(texinfo-insert-block): Simplify.
	(texinfo-insert-quote): Insert a plain " if preceded by \ or if
	the command is repeated.
	(texinfo-last-unended-begin, texinfo-next-unmatched-end): New funs.
	(texinfo-insert-@end): Simplify.

	* textmodes/texnfo-upd.el (texinfo-section-types-regexp)
	(texinfo-section-level-regexp, texinfo-subsection-level-regexp)
	(texinfo-subsubsection-level-regexp)
	(texinfo-update-menu-same-level-regexps)
	(texinfo-update-menu-higher-regexps)
	(texinfo-update-menu-lower-regexps): Hoist to eliminate warnings.

	* derived.el (define-derived-mode): Use {delay,run}-mode-hooks.
	(derived-mode-p): Autoload.

	* subr.el (delay-mode-hooks, delayed-mode-hooks, run-mode-hooks):
	New vars and functions.
	(text-clone-maintain, text-clone-create): New functions.

2001-10-25  Miles Bader  <miles@gnu.org>

	* facemenu.el (facemenu-add-new-face): Fix variable names.

2001-10-24  Richard M. Stallman  <rms@gnu.org>

	* facemenu.el (facemenu-unlisted-faces): Improve doc strings
	of t and nil values.
	(facemenu-set-face): Handle START and END interactively.
	(facemenu-set-foreground): Don't use a face; specify color directly.
	(facemenu-set-background): Likewise.
	(facemenu-set-face-from-menu): Doc fix.
	(facemenu-active-faces): Use face-attribute-vector
	to handle bare attributes not in faces.
	(facemenu-get-face): Don't handle face names fg:... and bg:...
	specially.
	(facemenu-add-new-face): New argument MENU.
	New way to handle adding colors to the color menus.

	* env.el (substitute-env-vars): Quote the arg to rx.

2001-10-24  Sam Steingold  <sds@gnu.org>

	* mouse.el (mouse-buffer-menu-mode-groups): Added "Version
	Control" and "SGML" groups.

2001-10-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* progmodes/cc-engine.el (c-beginning-of-member-init-list):
	Better handling of C++ template args to avoid confusion with `<'
	and `>' used as operators in member init expressions.

2001-10-24  Gerd Moellmann  <gerd@gnu.org>

	* replace.el (perform-replace): Move START and END parameters
	to the end of the argument list and make them optional.

	* progmodes/ebrowse.el, progmodes/etags.el: Adapt to change in
	perform-replace.

	* international/fontset.el (x-must-resolve-font-name): New function.
	(x-complement-fontset-spec): Use it.

2001-10-23  Stefan Monnier  <monnier@cs.yale.edu>

	* uniquify.el (uniquify-get-proposed-name): Fix (.. "usr" "/usr" 0).

	* progmodes/compile.el (compile-mouse-goto-error, compile-goto-error):
	Turn caadr into caar of cdr.

2001-10-23  Gerd Moellmann  <gerd@gnu.org>

	* info.el (Info-fontify-node): Bind down-mouse-{1,2} instead
	of mouse-{1,2} since dragging is on the down event.

	* play/doctor.el (make-doctor-variables): Remove a '($ please)'.

	* mail/mh-utils.el (mh-recenter): Call `recenter' with arg t
	if ARG is nil.

	* desktop.el (desktop-last-buffer): New variable.
	(desktop-create-buffer): Set it.
	(desktop-read): Bind it and switch to that buffer.

2001-10-22  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/compile.el (compilation-set-window-height):
	Select old window only if it's still live.

2001-10-22  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* help-mode.el (help-buffer): Remove debugging code.
	From Stefan Monnier <monnier@cs.yale.edu>.

2001-10-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (file-name-sans-extension, file-name-extension):
	Don't count the leading dots in file names as signaling an extension.

2001-10-22  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-diff-switches): Doc rewritten.

2001-10-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* tooltip.el (tooltip-set-param): Doc fix.

	* textmodes/sgml-mode.el (sgml-mode-map): Bind 8-bit codes above
	127 to sgml-maybe-name-self.
	(sgml-name-8bit-mode): Doc fix.
	(sgml-char-names-table): New variable.
	(sgml-name-char): Support non-ASCII and mule-unicode-*
	characters.  Doc fix.
	(sgml-maybe-name-self): Convert unibyte characters to multibyte.

	* tooltip.el (tooltip-x-offset, tooltip-y-offset): Mention in the
	doc string the effect of `left' and `top' parameters in
	tooltip-frame-parameters, the default values, and the units.
	(tooltip-frame-parameters): Mention `top' and `left' in the doc string.
	(tooltip-show): Mention in the doc string the `top' and `left'
	parameters in tooltip-frame-parameters, and x-max-tooltip-size.

2001-10-22  Andre Spiegel  <spiegel@gnu.org>

	Add autoscaling support for vc-annotate.
	From J.D. Smith <jdsmith@alum.mit.edu>.

	* vc.el (vc-annotate-display-default): Accept colormap scaling
	ratio (now deprecated).
	(vc-annotate-display-autoscale): Added.
	(vc-annotate-add-menu): New autoscaling menu options "Span to
	Oldest" and "Span Oldest->Newest".  Easymenu support added for
	toggle menus driven by customize variable `vc-annotate-display-mode'.
	(vc-annotate-display-select): Added.
	(vc-annotate): Changed temp-buffer-show-function to
	`vc-annotate-display-select'.
	(vc-annotate-display): Removed arguments BUFFER and BACKEND.
	Added argument OFFSET.  Instead of backend function, calls now
	generic `vc-annotate-difference'.
	(vc-annotate-difference): Added as generic function instead of
	backend-specific function.  No longer takes argument POINT, but
	instead accepts a time OFFSET.
	(vc-default-annotate-current-time): Added.

	* vc-cvs.el (vc-cvs-annotate-difference): Removed to generic
	version in vc.el, with
	(vc-cvs-annotate-current-time): Added, as override of default.
	(vc-cvs-annotate-time): Added.  Taken mostly from the (now removed)
	`vc-cvs-annotate-difference'.

2001-10-22  Gerd Moellmann  <gerd@gnu.org>

	* saveplace.el (save-place): Require `saveplace'.

	* progmodes/cwarn.el (cwarn-font-lock-feature-keywords-alist):
	Use `sexp' for :value-type instead of `face'.

2001-10-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/rmailsum.el (rmail-summary-font-lock-keywords): Fix the
	regexps due to 5-digit message IDs.

2001-10-21  Jason Rumney  <jasonr@gnu.org>

	* term/w32-win.el (redisplay-dont-pause): Don't set.

2001-10-21  Miles Bader  <miles@gnu.org>

	* help-funs.el (help-manyarg-func-alist): Variable removed.

2001-10-21  Miles Bader  <miles@gnu.org>

	* help-funs.el (help-manyarg-func-alist): Remove entries for
	`insert', `insert-and-inherit', `insert-before-markers',
	`insert-before-markers-and-inherit', `message', `message-box',
	`message-or-box', `propertize', `format', `encode-time', `append',
	`concat', `vconcat', `nconc', `widget-apply', `make-hash-table',
	`insert-string', `ml-if', `ml-provide-prefix-argument', and
	`ml-prefix-argument-loop'.

2001-10-21  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-diff-internal, vc-coding-system-for-diff)
	(vc-default-diff-tree): New functions.
	(vc-version-diff): Use them.  As a result, coding systems are now
	set up properly for all sorts of diffs, and tree diffs can now
	also be done locally.
	(vc-diff): With a prefix argument, don't require that it's called
	from a buffer under version control.
	(diff-switches): Remove duplicate definition.

	* vc-cvs.el (vc-cvs-diff-tree): New function.

2001-10-21  Miles Bader  <miles@gnu.org>

	* help-funs.el (help-manyarg-func-alist): Remove entries for
	`list', `vector', `make-byte-code', `call-process',
	`call-process-region', `string', `+', `-', `*', `/', `max', `min',
	`logand', `logior', and `logxor'.

	* wid-edit.el (checkbox): Swap bg/fg colors in image, and invert
	image bits to compensate.  Use `make-string' instead of
	`make-bool-vector' (XBM apparently wants byte-aligned rows).

2001-10-20  Kim F. Storm  <storm@cua.dk>

	* simple.el (kill-ring-save): Don't show extent of copied region
	if using transient-mark-mode and region is fully visible.

2001-10-20  Gerd Moellmann  <gerd@gnu.org>

	* (Version 21.1 released.)

2001-10-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (auto-mode-alist): Associate .indent.pro with
	Fundamental mode.  Suggested by Samuel Padgett <spadgett1@nc.rr.com>.

2001-10-18  Sam Steingold  <sds@gnu.org>

	Put the *Compile-Log* buffer in `compilation-mode'.
	* emacs-lisp/bytecomp.el (byte-goto-log-buffer): New function.
	(byte-compile-log-1, byte-compile-log-file)
	(displaying-byte-compile-warnings): Use it

2001-10-18  Stefan Monnier  <monnier@cs.yale.edu>

	* mail/smtpmail.el (smtpmail-via-smtp): Use mail-envelope-from if set.

	* xml.el (xml-parse-tag): Use eq on char-after's return value.

2001-10-18  Gerd Moellmann  <gerd@gnu.org>

	* isearch.el (isearch-mode-map): Bind `mouse-movement' to nil.

	* obsolete/hilit19.el (hilit-lookup-face-create):
	Call set-face-font only if display-graphic-p.
	(toplevel): Remove references to window-system.

2001-10-18  Miles Bader  <miles@gnu.org>

	* simple.el (what-line): Avoid problems with field properties.

2001-10-17  Eli Zaretskii  <eliz@is.elta.co.il>

	* wid-edit.el (widget-field-face, widget-single-line-field-face):
	Define special colors for a tty.

2001-10-17  Francesco Potorti`  <pot@gnu.org>

	* comint.el (comint-password-prompt-regexp): Make it less
	restrictive, letting comint recognise OpenSSH2 passphrase prompts.

2001-10-17  John Wiegley  <johnw@gnu.org>

	* eshell/em-unix.el (eshell/cat): Do a quick test if something is
	a regular file, before checking if it is a directory or symlink.
	This avoids a call to eshell-file-attributes, which can be
	expensive in some situations.

	* eshell/em-ls.el (eshell-ls-dired-initial-args): Added an extra
	customization variable, to differentiate ls-in-dired from regular
	uses of ls.

2001-10-17  Miles Bader  <miles@gnu.org>

	* custom.el (defface): Mention `:inherit' in doc-string.

2001-10-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* paren.el: Update the Commentary with installation instructions.

2001-10-15  Dave Love  <fx@gnu.org>

	* international/mule.el (set-auto-coding): Fix regexps for local
	variables section not to eat newlines.

2001-10-15  Miles Bader  <miles@gnu.org>

	* simple.el (display-message-or-buffer): Pass the correct buffer
	to `display-buffer'.

2001-10-14  Stefan Monnier  <monnier@cs.yale.edu>

	* progmodes/executable.el (executable-binary-suffixes): Make varalias.
	(executable-find): Use exec-suffixes.
	(executable-set-magic): Don't use make-local-hook.

	* bindings.el (exec-suffixes): Initialize to a system-dependent value.

2001-10-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* bindings.el (completion-ignored-extensions) [ms-dos, windows-nt]:
	Add .ico, .pif, .lnk, .dll, .drv, .vxd, and .386.
	Add .so to the Unix and GNU branch.

	* international/latin-1.el:
	* international/latin-2.el:
	* international/latin-3.el:
	* international/latin-4.el:
	* international/latin-5.el:
	* international/latin-8.el:
	* international/latin-9.el: Add no-byte-compile: t, since
	Makefile.in instructs make-docfile to look at .el files.

2001-10-14  Miles Bader  <miles@gnu.org>

	* button.el (define-button-type): Allow supertype property to be
	specified with a keyword `:supertype' too.
	(button-put, make-text-button): Allow button type property to be
	specified using the keyword `:type' too.
	(button-type): New function.
	(button): Add `button-category-symbol' property.

2001-10-13  Stefan Monnier  <monnier@cs.yale.edu>

	* bindings.el (esc-map): Revert `j' and `C-j' bindings to
	indent-new-comment-line from comment-indent-new-line.

	* textmodes/refill.el (refill-mode):
	Bind DEL to backward-delete-char-untabify.
	Set backward-delete-char-untabify-method to `hungry'.

	* textmodes/bib-mode.el (bib-mode):
	* play/gomoku.el (gomoku-mode):
	* textmodes/page-ext.el (pages-directory-mode):
	* textmodes/scribe.el (scribe-mode): Use define-derived-mode.

	* textmodes/two-column.el (2C-mode): Don't use make-local-hook.

	* emacs-lisp/syntax.el (syntax-ppss): Autoload.

	* progmodes/sh-script.el (sh-font-lock-syntactic-keywords):
	Handle here-docs differently.
	(sh-font-lock-heredoc): Remove.
	(sh-here-doc-open-re, sh-here-doc-markers, sh-here-doc-re): New vars.
	(sh-font-lock-here-doc, sh-font-lock-close-heredoc)
	(sh-font-lock-open-heredoc): New functions.
	(sh-mode): Don't copy sh-font-lock-syntactic-keywords any more.
	(sh-font-lock-keywords-1): Use regexp-opt.
	(sh-in-comment-or-string): Use syntax-ppss.
	(sh-case, sh-for, sh-indexed-loop, sh-function, sh-if, sh-repeat)
	(sh-select, sh-tmp-file): Add explicit terminating \n.

	* net/ange-ftp.el (ange-ftp-raw-send-cmd, ange-ftp-wait-not-busy):
	Use with-current-buffer.
	(ange-ftp-cd): New arg `noerror' to prevent signalling an error.
	(ange-ftp-send-cmd): If a `cd' is used (because of a space in the
	filename), catch any error that occurs in `ange-ftp-cd'.
	If an error happened, don't bother sending `cmd' at all.
	Fix a parenthesis typo.
	(ange-ftp-write-region): Don't blindly use binary if the remote host
	is unix-like.

	* play/pong.el (pong-init): Don't use make-local-hook.

2001-10-13  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-ex.el (ex-edit): Make checks for modified buffer/file.
	(viper-get-ex-address-subr): More precise addr for the $ marker

2001-10-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* version.el (emacs-version): Bump to 21.1.50.

2001-10-13  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* mail/mailalias.el (mail-directory-stream): Do not double
	variables in the lambda-list.

	* play/gomoku.el (gomoku-init-display): Ditto.

	* play/landmark.el (lm-init-display): Ditto.

	* delim-col.el (delimit-columns-rectangle-max): Ditto.
	(delimit-columns-rectangle-line): Ditto.

2001-10-12  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el (comment-region-internal): Don't rebind
	invisibility_spec now that the C routines handle it correctly.

	* help-funs.el (locate-library): Use load-suffixes and abbrev filename.

	* frame.el (special-display-popup-frame): Obey new specs `same-window'
	and `same-frame'.

	* menu-bar.el (minibuffer-local-*map): Take inheritance into account.

	* simple.el (minibuffer-local*-map): Remove redundant bindings.

	* bindings.el (minibuffer-local-map): Also bind next, C-n, C-s, prior,
	C-p and C-r.  Remove redundant bindings from inheriting maps.

	* progmodes/cperl-mode.el: Merged in changes from v4.32.
	 After 4.23 and: After 4.24:
	(cperl-contract-levels): Restore position.
	(cperl-beautify-level): Likewise.
	(cperl-beautify-regexp): Likewise.
	(cperl-commentify): Rudimental support for length=1 runs
	(cperl-find-pods-heres): Process 1-char long REx comments too /a#/x
	 After 4.25:
	(cperl-commentify): Was recognizing length=2 "strings" as length=1.
	(imenu-example--create-perl-index): Was not enforcing
	syntaxification-to-the-end.
	(cperl-invert-if-unless): Allow `for', `foreach'.
	(cperl-find-pods-heres): Quote `cperl-nonoverridable-face'.
	Mark qw(), m()x as indentable.
	(cperl-init-faces): Highlight `sysopen' too.
	Highlight $var in `for my $var' too.
	(cperl-invert-if-unless): Was leaving whitespace at end.
	(cperl-linefeed): Was splitting $var{$foo} if point after `{'.
	(cperl-calculate-indent): Remove old commented out code.
	Support (primitive) indentation of qw(), m()x.
	 After 4.26:
	(cperl-problems): Mention `fill-paragraph' on comment. \"" and
	q [] with intervening newlines.
	(cperl-autoindent-on-semi): New customization variable.
	(cperl-electric-semi): Use `cperl-autoindent-on-semi'.
	(cperl-tips): Mention how to make CPerl the default mode.
	(cperl-mode): Support `outline-minor-mode'.  From Mark A. Hershberger.
	(cperl-outline-level): New function.
	(cperl-highlight-variables-indiscriminately): New customization var.
	(cperl-init-faces): Use `cperl-highlight-variables-indiscriminately'.
	From Sean Kamath <kamath@pogo.wv.tek.com>.
	(cperl-after-block-p): Support CHECK and INIT.
	(cperl-init-faces, cperl-short-docs): Likewise and "our".
	From Doug MacEachern <dougm@covalent.net>.
	 After 4.27:
	(cperl-find-pods-heres): Recognize \"" as a string.
	Mark whitespace between q and [] as `syntax-type' => `prestring'.
	Allow whitespace between << and "FOO".
	(cperl-problems): Remove \"" and q [] with intervening newlines.
	Mention multiple <<EOF as unsupported.
	(cperl-highlight-variables-indiscriminately): Doc misprint fixed.
	(cperl-indent-parens-as-block): New configuration variable.
	(cperl-calculate-indent): Merge cases of indenting non-BLOCK groups.
	Use `cperl-indent-parens-as-block'.
	(cperl-find-pods-heres): Test for =cut without empty line instead of
	complaining about no =cut.
	(cperl-electric-pod): Change the REx for POD from "\n\n=" to "^\n=".
	(cperl-find-pods-heres): Likewise.
	(cperl-electric-pod): Change `forward-sexp' to `forward-word':
	POD could've been marked as comment already.
	(cperl-unwind-to-safe): Unwind before start of POD too.
	 After 4.28:
	(cperl-forward-re): Throw an error at proper moment REx unfinished.
	 After 4.29:
	(x-color-defined-p): Make an extra case to peacify the warning.
	Toplevel: `defvar' to peacify the warnings.
	(cperl-find-pods-heres): Could access `font-lock-comment-face' in -nw.
	No -nw-compile time warnings now.
	(cperl-find-tags): TAGS file had too short substring-to-search.
	Be less verbose in non-interactive mode
	(imenu-example--create-perl-index): Set index-marker after name
	(cperl-outline-regexp): New variable.
	(cperl-outline-level): Made compatible with `cperl-outline-regexp'.
	(cperl-mode): Made use `cperl-outline-regexp'.
	 After 4.30:
	(cperl-find-pods-heres): =cut the last thing, no blank line, was error.
	(cperl-outline-level): Make start-of-file same level as `package'.
	 After 4.31:
	(cperl-electric-pod): `head1' and `over' electric only if empty.
	(cperl-unreadable-ok): New variable.
	(cperl-find-tags): Use `cperl-unreadable-ok', do not fail
	on an unreadable file.
	(cperl-write-tags): Use `cperl-unreadable-ok', do not fail
	on an unreadable directory.

	* progmodes/compile.el (compile-mouse-goto-error, compile-goto-error):
	Consider the text between two errors as belonging to the first error.
	(compilation-goto-locus): Use pop-to-buffer rather than
	switch-to-buffer-other-frame.

	* progmodes/awk-mode.el (awk-mode-syntax-table): / has string syntax.
	(awk-font-lock-syntactic-keywords): New var.
	(awk-mode): Use it.

	* expand.el (expand-c-for-skeleton): Add explicit terminating \n.

	* faces.el (describe-face): Call help-setup-xref earlier.

	* jka-compr.el (jka-compr-load-suffixes): New var.
	(jka-compr-install): Add its content to load-suffixes.
	(jka-compr-uninstall): Remove its content from load-suffixes.

2001-10-12  Sam Steingold  <sds@gnu.org>

	* bindings.el (completion-ignored-extensions): CL-related
	extensions are platform-independent.

	* net/ange-ftp.el (ange-ftp-copy-files-async): New function for
	asynchronous multiple file copying.

2001-10-12  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-check-lambda-list):
	Turn error for repeated variables into warning.

	* emacs-lisp/bytecomp.el (byte-compile-check-lambda-list):
	New function checking that lambda-list consists of non-constant
	symbols, that &rest and &optional are followed by variable names,
	that &rest VAR is the last element, and that variables aren't doubled.
	(byte-compile-lambda): Use it.

2001-10-12  Eli Barzilay <eli@barzilay.org>

	* calculator.el (calculator-eng-display): Don't call concat
	with an integer argument.

2001-10-12  Miles Bader  <miles@gnu.org>

	* help-mode.el (help-customize-face): New button-type.

	* faces.el (list-faces-display): Fix args to `help-xref-button'.
	(describe-face): Fix args to `help-xref-button'.
	Don't switch to help-buffer around call to `help-setup-xref'.
	Use `help-buffer' instead of hard-wired "*Help*".
	Require `help-mode'.

2001-10-11  Stefan Monnier  <monnier@cs.yale.edu>

	* net/goto-addr.el (goto-address-mail-regexp): Allow + in username.

	* help-mode.el (help-buffer): New function.
	Returns the buffer-name to use for help output.
	Change all the code to use it instead of hard-coding *Help*.
	(help-mode-map): Put back the mouse-2 binding.
	(help-xref-stack): Change the format and make buffer-local.
	(help-xref-stack-item): Make buffer-local.
	(help-setup-xref): Do the `push' here rather than in help-do-xref.
	(help-xref-interned): Display the face doc as well.
	(help-follow-mouse): Re-introduce.
	(help-xref-go-back): Adapt to the new use of help-xref-stack.
	(help-do-xref): Don't `push' any more.
	(help-follow): Also follow face names.

	* help-funs.el (describe-function-1): Remove unused `parens' arg.
	Don't call help-setup-xref anymore and remove its `interactive-p' arg.
	Autoload and cleanup.
	(describe-function): Call help-setup-xref.
	(describe-variable): Call help-setup-xref earlier.

	* help.el (describe-bindings-internal): New fun moved from keymap.c.
	(view-lossage): Call help-setup-xref correctly and earlier.
	(describe-bindings): Call help-setup-xref earlier.
	(describe-key): Call help-setup-xref.  Fix call to describe-function-1.
	(describe-mode): Don't autoload.  Call help-setup-xref earlier.

2001-10-11  Gerd Moellmann  <gerd@gnu.org>

	* master.el (master-mode): Use define-minor-mode instead of
	easy-mmode-define-minor-mode.  Add autload cookie.
	(Commentary): Remove the line showing how to autoload master-mode,
	since it's always autoloaded.

	* master.el: New file.

2001-10-11  Dave Love  <fx@gnu.org>

	* emacs-lisp/byte-opt.el (byte-optimize-lapcode)
	<byte-constref-ops>: Consider byte-constant2 and clarify the code.
	<const-C varset-X const-C>: Fix car/cdr typo.

2001-10-11  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-display-log-head-p):
	New function extracted from byte-compile-log-1.
	(byte-compile-log-1): Change output to be more in line with
	the output of other GNU tools.
	(byte-compile-warn): Emit `warning' instead of `**' for warnings.
	(byte-compile-report-error): Downcase error message.
	Use `error' instead of `!!' for error messages.
	(byte-compile-print-syms): Treat non-interactive case specially.
	(displaying-byte-compile-warnings): Use backquote.
	(byte-compile-from-buffer): Bind byte-compile-last-line.
	(batch-byte-compile): Remove `Done' message.

2001-10-11  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/copyright.el (copyright): Add final \n.

2001-10-11  Miles Bader  <miles@gnu.org>

	* diff.el (diff): Display default values in prompts as
	`(default ...)', not `(...)'.

	* info.el (Info-follow-reference): Likewise.

2001-10-10  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs-lisp/autoload.el (doc-string-elt): Remove.

	* newcomment.el (comment-indent): Be a little more robust in case
	comment-indent-function does funny things.
	(comment-normalize-vars): Autoload.
	(comment-region-internal): Fiddle with the visibility spec.
	(comment-valid-prefix): New function.
	(comment-indent-new-line): Use it.  Ignore adaptive-fill-prefixes
	that would turn comment-text into non-comment-text.

	* emacs-lisp/syntax.el: New file.

	* progmodes/tcl.el: Change maintainer to FSF and remove loads of
	compatibility cruft.
	(tcl-using-emacs-19, tcl-using-emacs-19-23, tcl-using-xemacs-19)
	(tcl-version, tcl-maintainer, tcl-use-hairy-comment-detector): Remove.
	(tcl-mode-map): Remove bindings for tcl-beginning-of-defun,
	tcl-end-of-defun, tcl-mark-defun, tcl-indent-for-comment,
	tcl-submit-bug-report.
	(tcl-mode-syntax-table): Leave \f alone.
	(inferior-tcl-mode-map): Remove bindings for tcl-beginning-of-defun,
	tcl-end-of-defun, tcl-submit-bug-report.
	(tcl-xemacs-menu): Fix up and pass it directly to easymenu.
	(tcl-add-emacs-menu): Remove.
	(tcl-fill-mode-map, tcl-fill-inferior-map): Moved into the defvar.
	(tcl-keyword-list): Add `chain'.
	(tcl-font-lock-syntactic-keywords): New variable.
	(tcl-pps-has-arg-6): Remove.
	(tcl-internal-beginning-of-defun, tcl-internal-end-of-defun)
	(tcl-internal-mark-defun): Remove.
	(tcl-set-proc-regexp, tcl-set-font-lock-keywords): Use regexp-opt.
	(tcl-mode): Use define-derived-mode.  Simplify.
	Set comment-indent-function.
	(tcl-indent-command): Use line-beginning-position and comment-indent.
	(tcl-calculate-indent): Renamed from calculate-tcl-indent.
	(tcl-indent-line): Use tcl-calculate-indent.
	(tcl-indent-exp): Renamed from indent-tcl-exp.  Use new names.
	(tcl-add-log-defun): Renamed from add-log-tcl-defun.  Use match-string.
	(tcl-filter): Use with-current-buffer, simplify.
	(inferior-tcl-mode): Use define-derived-mode.
	(tcl-hairy-in-comment): Renamed tcl-in-comment.
	(tcl-simple-in-comment, tcl-in-comment): Removed.
	(tcl-files-alist): New function.
	(tcl-help-snarf-commands): Use it and return the result directly
	rather than through a global variable.
	(tcl-reread-help-files): Fix up the call to tcl-help-snarf-commands.
	(tcl-help-on-word): Provide the default value to completing-read.
	(tcl-hilit): Remove.
	(tcl-hashify-buffer, tcl-popup-menu): Simplify.
	(tcl-comment-indent): New function.
	(tcl-submit-bug-report): Remove.
	(tcl-uncomment-region, tcl-indent-for-comment, add-log-tcl-defun)
	(indent-tcl-exp, calculate-tcl-indent, tcl-beginning-of-defun)
	(tcl-end-of-defun, tcl-mark-defun, tcl-mark): Redefine as aliases.

2001-10-10  Miles Bader  <miles@gnu.org>

	* info.el (Info-insert-dir): Don't call `Info-fontify-menu-headers'.
	(Info-fontify-node): Don't fontify the node if it's already been done.

2001-10-10  Gerd Moellmann  <gerd@gnu.org>

	* international/iso-transl.el (iso-transl-e-caret)
	(iso-transl-i-caret, iso-transl-o-caret, iso-transl-u-caret):
	Fix duplicates.  From Dave Love <d.love@dl.ac.uk>.

	* simple.el (end-of-buffer): Fix code scrolling specially
	for the buffer end.

	* startup.el (command-line-1): Bind tab-width to 8.

2001-10-10  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* emulation/tpu-edt.el: Use defalias instead of fset for
	user-visible commands.  From Rob Riepel
	<riepel@Networking.Stanford.EDU>.

2001-10-09  Gerd Moellmann  <gerd@gnu.org>

	* ruler-mode.el: New file.

2001-10-09  Miles Bader  <miles@gnu.org>

	* apropos.el (button): New require.

	* help-funs.el: New file, contents mostly from `help.el'.
	(describe-variable): Use `condition-case' instead of `ignore-errors'.

	* help-mode.el: New file, contents mostly from `help.el'.

	* help.el: Don't require `view' when compiling.
	(help-with-tutorial, describe-function, describe-function-1)
	(variable-at-point, describe-variable, locate-library):
	Functions moved into `help-funs.el'.
	(help-manyarg-func-alist): Variable moved into `help-funs.el'.
	(help-mode, help-mode-setup, help-mode-finish, help-button-action)
	(help-setup-xref, help-xref-following, help-make-xrefs)
	(help-xref-button, help-insert-xref-button, help-xref-interned)
	(help-xref-go-back, help-go-back, help-do-xref, help-follow)
	(help-xref-on-pp): Functions moved into `help-mode.el'
	(help-mode-map, help-xref-stack, help-xref-stack-item)
	(help-highlight-p, help-highlight-face, help-back-label)
	(help-xref-symbol-regexp, help-xref-mule-regexp)
	(help-xref-info-regexp): Variables moved into `help-mode.el'.
	(help-symbol, help-back, help-info, help-customize-variable)
	(help-function-def, help-variable-def):
	Button-types moved into `help-mode.el'.
	(load-symbol-file-load-history, symbol-file):
	Functions moved into `subr.el'.
	(symbol-file-load-history-loaded): Variable moved into `subr.el'.
	(view-lossage): Call `help-setup-xref' instead of doing it manually.

	* subr.el (symbol-file-load-history-loaded)
	(load-symbol-file-load-history, symbol-file): Moved from `help.el'.

	* loadup.el ("button"): Load removed.

	* button.el (define-button-type): Respect any `supertype' property.
	(button-type-subtype-p, button-has-type-p): New functions.

	* rfn-eshadow.el (rfn-eshadow-regexp): Deal correctly with escaped
	dollar-signs.

	* comint.el (comint-insert-previous-argument): New function.
	(comint-mode-map): Bind `C-c .' to `comint-input-previous-argument'.
	(comint-insert-previous-argument-last-start-pos)
	(comint-insert-previous-argument-last-index): New variables.

	* apropos.el (apropos-next-label-button): Use the presence of a
	`apropos-label' property to detect label buttons.

2001-10-08  Miles Bader  <miles@gnu.org>

	* button.el (next-button, previous-button): Remove N and WRAP
	parameters.  Don't pay attention to `skip' properties.
	(forward-button): Implement wrapping, iterating, and skipping here
	instead.
	(button-activate): USE-MOUSE-ACTION is optional.
	(button-nop): Function removed.
	(default-button): Use `ignore' as default button action.

	* apropos.el (apropos-next-label-button): Update arguments to
	`next-button'.
	(apropos-symbol): Add `skip' property.
	(apropos-function, apropos-macro, apropos-command)
	(apropos-variable, apropos-face, apropos-group, apropos-widget)
	(apropos-plist): New button types.
	(apropos-label-properties): Variable removed.
	(apropos-print): Pass button-type to apropos-print-doc, rather
	than help function and label text.
	(apropos-print-doc): Remove ACTION and STR args, add TYPE arg.
	Get button label from TYPE.

2001-10-07  Stefan Monnier  <monnier@cs.yale.edu>

	* help.el (help-mode): Use define-derived-mode.
	(describe-mode): Add optional `buffer' arg.
	Use it instead of going through help-xref-mode.
	Avoid doubling the word `minor' when prettifying.
	(describe-function-1): List the corresponding key bindings.
	(describe-variable): Say if the var is automatically buffer-local.
	If the source is `loaddefs.el', look for the real source.
	(help-xref-mode): Remove.

	* emacs-lisp/bytecomp.el (byte-compile-file): Return success when
	the file says no-byte-compile.

2001-10-08  Miles Bader  <miles@gnu.org>

	* button.el (next-button, previous-button): Respect `skip' property.

2001-10-07  Miles Bader  <miles@gnu.org>

	* woman.el (woman-mode-map): Copy button-buffer-map instead of
	making a new keymap.  Don't bind mouse-2.  Bind M-mouse-2 to
	`woman-follow-word' instead of `woman-mouse-2'.
	(woman-follow-word): Renamed from `woman-mouse-2'.
	Follow current unconditionally, since this function is now only
	bound to M-mouse-2.  Use accessor functions.
	(WoMan-highlight-references): Use `make-text-button'.
	(woman-xref): New button type.

	* loadup.el ("faces"): Move load before loading "loaddefs.el".
	("button"): New load, just before "help" (which uses it).

	* help.el (help-mode-map): Make button-buffer-map our parent.
	Don't bind mouse events or tab/backtab.
	(help-function, help-variable, help-face, help-coding-system)
	(help-input-method, help-character-set, help-back, help-info)
	(help-customize-variable,  help-function-def, help-variable-def):
	New button types.
	(help-button-action): New function.
	(describe-function-1): Pass help button-types to
	`help-xref-button' rather than help function and help-echo string.
	Don't put multiple help-function args in a list to pass them to
	help-xref-button, just pass them as multiple arguments.
	Use `help-insert-xref-button' to make [back]-button, rather than
	`help-xref-button'.
	(help-xref-button): Take a button-type TYPE as a parameter rather
	than a function.  Remove HELP-ECHO parameter.  Remove DATA parameter
	and add a &rest parameter ARGS to serve the same purpose.
	Use `make-text-button' to add the button.
	(help-insert-xref-button): Use `insert-text-button' to add the button.
	(help-follow-mouse, help-next-ref, help-previous-ref):
	Functions removed.
	(help-do-xref): New function.
	(help-follow): Use `push-button' and `help-do-xref' to do most of
	the work.

	* apropos.el (apropos-symbol, apropos-label): New button types.
	(apropos-symbol-button-display-help)
	(apropos-label-button-display-help, apropos-next-label-button):
	New functions.
	(apropos-mode-map): Make button-buffer-map our parent.
	Don't bind mouse events.
	(apropos-print, apropos-print-doc): Create buttons instead of text
	properties.
	(apropos-mouse-follow): Function removed.
	(apropos-follow): Use buttons.

	* button.el: New file.

2001-10-07  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/cl.el (most-positive-fixnum, most-negative-fixnum):
	Remove.

2001-10-05  Richard M. Stallman  <rms@gnu.org>

	* add-log.el (add-change-log-entry): Skip copyright notice
	and copying permission notice at start of file, if any.
	Make use of terms "entry" and "item" accord with Emacs manual.
	Simplify the logic for moving point while entering or creating
	an entry and then an item.
	(add-change-log-entry-other-window): Doc fix.

2001-10-06  Miles Bader  <miles@gnu.org>

	* rfn-eshadow.el (read-file-name-electric-shadow): Autoload cookie
	removed; they apparently don't work with faces.

2001-10-05  Sam Steingold  <sds@gnu.org>

	* textmodes/sgml-mode.el (html-xhtml): New user option.
	(html-tag-alist, html-horizontal-rule, html-image, html-line)
	(html-ordered-list, html-unordered-list, html-list-item)
	(html-paragraph, html-checkboxes, html-radio-buttons): Use it.
	(sgml-skip-close-p): New function.
	(sgml-value): Use it.

2001-10-05  Sam Steingold  <sds@gnu.org>

	* calendar/diary-lib.el (diary-entry-compare): When times are
	identical, compare the entries lexicographically.

2001-10-06  Miles Bader  <miles@gnu.org>

	* rfn-eshadow.el (rfn-eshadow-update-overlay):
	Use `minibuffer-prompt-end'.

	* simple.el (previous-matching-history-element): Fix misplaced
	parentheses.

2001-10-05  Miles Bader  <miles@gnu.org>

	* rfn-eshadow.el: New file.

2001-10-05  Miles Bader  <miles@gnu.org>

	* cus-face.el (custom-face-attributes): Make sure each attribute
	has a valid default value.  Remove hacks that mapped `nil' to
	`off' and used nil to mean `unspecified'.  Remove `unspecified'
	choices from all attributes (unspecified is handled by the parent
	checklist).
	* cus-edit.el (custom-face-edit-convert-widget)
	(custom-face-edit-deactivate, custom-face-edit-activate)
	(custom-face-edit-delete, custom-face-edit-attribute-tag):
	New functions.
	(custom-face-edit): Specify a custom :convert-widget.
	(custom-pre-filter-face-spec, custom-post-filter-face-spec):
	Don't pass in default filters that map between `nil' and `off' and
	`unspecified' and `nil'.

2001-10-05  Gerd Moellmann  <gerd@gnu.org>

	* progmodes/compile.el (compilation-buffer-name): New function.
	(compile-internal): Use it to determine the name of the
	compilation buffer.

2001-10-05  Miles Bader  <miles@gnu.org>

	* progmodes/compile.el (grep-use-null-device): New variable.
	(grep-command): Mention `grep-use-null-device'.
	(grep-compute-defaults): Compute `grep-use-null-device' if necessary.
	Make computation of `grep-command' respect `grep-use-null-device'.
	(grep): Respect `grep-use-null-device'.
	Call `grep-compute-defaults' even if grep-command is set, if
	grep-use-null-device is still tentative.

	* subr.el (call-process-shell-command): New function.

2001-10-05  Miles Bader  <miles@gnu.org>

	* simple.el (previous-matching-history-element)
	(next-history-element, next-complete-history-element): Use
	`minibuffer-' functions instead of calling `field-' functions directly.
	(minibuffer-prompt-end, minibuffer-contents):
	(minibuffer-contents-no-properties, delete-minibuffer-contents):
	Functions removed (now subrs).
	(minibuffer-prompt-width): Use `minibuffer-prompt-end'.

	* minibuf-eldef.el (minibuf-eldef-setup-minibuffer)
	(minibuf-eldef-update-minibuffer): Use `minibuffer-' functions
	instead of calling `field-' functions directly.
	(minibuf-eldef-setup-minibuffer): Remove unused variable `prompt'.

2001-10-05  Gerd Moellmann  <gerd@gnu.org>

	* files.el (find-file-noselect): If file's read-only status has
	changed on disk, ask if buffer's read-only status should be
	changed, unless NOWARN is set.

	* emacs-lisp/cl-macs.el (define-setf-expander): Make it an
	alias for define-setf-method.

	* bindings.el: Remove no-byte-compile from file local variables
	to enable bootstrapping.

2001-10-04  Andrew Innes  <andrewi@gnu.org>

	* faces.el (face-font-registry-alternatives) [windows-nt]:
	Make gb2312 an alias for gb2312.1980.

2001-10-04  Stefan Monnier  <monnier@cs.yale.edu>

	* uniquify.el (uniquify-get-proposed-name): Don't assume dirsep is /.
	(uniquify-reverse-components): Remove.

	* emacs-lisp/bytecomp.el (byte-recompile-directory):
	Make sure the file is readable.
	(byte-compile-file): Don't compile if `no-byte-compile' is set.
	(byte-compile-defvar): Update to reflect the change in Fdefvar.
	(batch-byte-recompile-directory): Pass arg=0.

	* progmodes/perl-mode.el (perl-indent-continued-arguments): New var.
	(perl-calculate-indent): Use it.
	(perl-backward-to-noncomment): Use forward-comment.

	* derived.el (define-derived-mode, derived-mode-make-docstring):
	Allow `parent' to be nil.

	* textmodes/nroff-mode.el (nroff-mode-abbrev-table, nroff-mode):
	Use define-derived-mode.
	(nroff-mode-map, nroff-mode-syntax-table): Massage.

	* mail/mailabbrev.el (mail-abbrev-in-expansion-header-p): Simplify.

	* emacs-lisp/lselect.el: Use facep iso find-face.

	* emacs-lisp/lisp-mode.el (lisp-imenu-generic-expression):
	Use regexp-opt.
	(doc-string-elt): Set symbols' prop.  Copied from autoload.el.
	(lisp-font-lock-syntactic-face-function): New function.
	(lisp-mode-variables): Use it.  Make arg optional.
	(emacs-lisp-mode): Don't pass an arg to lisp-mode-variables.
	(lisp-mode): Don't pass an arg to lisp-mode-variables.
	Set comment-start-skip.

	* emacs-lisp/lisp-mnt.el (lm-history-header): Accept `ChangeLog'.

	* emacs-lisp/cl-macs.el (frame-parameter): Add a setf method.
	(ignore-errors): Don't bother using a `err' symbol.

	* emacs-lisp/autoload.el (autoload-ensure-default-file)
	(autoload-insert-section-header, autoload-before-p)
	(autoload-remove-section): New functions.
	(generate-file-autoloads): Use them.
	(update-file-autoloads): Use them.  Return FILE if there's no cookie.
	Make sure the autoload file is properly formatted when creating it.
	(update-autoloads-from-directories): Use them as well.
	Only update autoloads for files whose timestamp has changed.
	Add a dummy entry to remember the files which had no autoload cookies.

	* timer.el (timer-relative-time): Fix computation for negative `micro'.

	* subr.el (define-key-after): Allow `key' to be longer than 1.
	(make-local-hook): Make obsolete.
	(add-hook, remove-hook): Don't use make-local-hook any more.
	(make-syntax-table): Inherit all chars from s-s-t.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	This is a fix for a report saying that resuming a search with C-s
	C-s doesn't use the case-fold-search setting of the previous
	search (C-s ... M-c ... then C-s C-s).

	* isearch.el (isearch-last-case-fold-search): New variable.
	(isearch-mode): Remember value of isearch-case-fold-search
	in isearch-last-case-fold-search.
	(isearch-done): Quote value of isearch-case-fold-search.
	(isearch-repeat): When resuming a search, restore
	isearch-case-fold-search from isearch-last-case-fold-search.

	Added to NEWS.

	* startup.el (inhibit-startup-buffer-menu): New user-option.
	(command-line-1): If inhibit-startup-buffer-menu is set, don't
	display the buffer menu.  From Simon Josefsson <jas@extundo.com>.

	This allows upto 99999 messages in the summary without screwing up
	the summary sorting.  Previously 9999 was the maximum.  Added to NEWS.

	* mail/rmailsum.el (rmail-make-summary-line)
	(rmail-make-summary-line-1, rmail-summary-next-same-subject)
	(rmail-summary-goto-msg, rmail-summary-goto-msg):
	Allow 5-digit message ids instead of 4.

	This adds expansion of environment variables in the value
	specified with M-x setenv.  Added to NEWS.

	* env.el (substitute-env-vars): New function.
	(setenv): Add parameter SUBSTITUTE-ENV-VARS.  If set, substitute
	environment variables in VALUE.  Return VALUE.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	* Branch for 21.1.

2001-10-03  Stefan Monnier  <monnier@cs.yale.edu>

	* pcvs-util.el (cvs-prefix-define): Typo cons->concat.

2001-10-03  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* emulation/tpu-edt.el: Make messages match original TPU/edt
	editor.  From riepel@Stanford.EDU (Rob Riepel).

2001-10-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* rect.el: Update maintainer's email address.

2001-10-02  Andreas Schwab  <schwab@suse.de>

	* net/ange-ftp.el (ange-ftp-skip-msgs): Add 227 and 228 for Long
	and Extended Passive Mode, resp.

2001-10-01  Eli Zaretskii  <eliz@is.elta.co.il>

	These changes add support for Calendar-related items in the
	menu bar on tty's as well:

	* calendar/calendar.el (calendar-mode-map): Require cal-menu
	unconditionally.
	(calendar-mode): Set up activate-menubar-hook unconditionally.

	* calendar/cal-menu.el (cal-menu-x-popup-menu): New function,
	calls x-popup-menu only if popup menus are supported.
	(calendar-mouse-insert-hebrew-diary-entry)
	(calendar-mouse-insert-islamic-diary-entry)
	(calendar-mouse-holidays, calendar-mouse-view-diary-entries)
	(calendar-mouse-view-other-diary-entries)
	(calendar-mouse-print-dates, calendar-mouse-2-date-menu)
	(calendar-mouse-cal-tex-menu, cal-tex-mouse-filofax):
	Call cal-menu-x-popup-menu instead of x-popup-menu.

2001-10-01  Gerd Moellmann  <gerd@gnu.org>

	* gs.el (gs-set-ghostview-window-prop): Fix args of `elt'.

	* emacs-lisp/edebug.el (rx): Add def-edebug-spec.

	* emacs-lisp/rx.el: New file.

2001-10-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* help.el (help-for-help): Doc fix.  From Pavel@Janik.cz (Pavel Janik).

2001-09-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.el (select-frame-by-name, other-frame): Doc fix.

2001-09-29  Eli Zaretskii  <eliz@is.elta.co.il>

	* play/snake.el (snake-score-file): Use temporary-file-directory
	instead of a literal "/tmp".  Suggested by Robert
	<robert@chezmarshall.freeserve.co.uk>.

	* play/tetris.el (tetris-score-file): Ditto.

2001-09-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* apropos.el (apropos-print): Make the directions inserted at the
	beginning of the *Apropos* buffer more clear.

2001-09-27  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-mult.el (ediff-get-meta-info): Installed Gerd's changes.
	Added comments.

2001-09-27  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el (comment-normalize-vars): Use " \t" rather than
	"\\s-" when defining comment-end-skip.

2001-09-27  Gerd Moellmann  <gerd@gnu.org>

	* mail/feedmail.el (feedmail-queue-send-edit-prompt-help):
	Call get-buffer-window first second arg `visible'.

	* international/mule-diag.el (list-input-methods-1):
	Output something that's independent of Emacs' version.

	* tar-mode.el (tar-mode-write-file): Don't signal an error by
	calling byte-to-position with a nil tar-header-offset.

2001-09-27  Simon Josefsson  <jas@extundo.com>

	* mail/sendmail.el (send-mail-function): Doc fix.
	(mail-do-fcc): Error if header-end is not a marker.
	(mail-do-fcc): Add a comment.
	(mail-reply-to): Doc fix.
	(mail-signature): Make ATPOINT optional.
	(mail-yank-original): Use cond instead of nestled if.

2001-09-26  Stefan Monnier  <monnier@cs.yale.edu>

	* info.el (Info-on-current-buffer): Default arg to "Top".

2001-09-25  Eli Barzilay  <eli@barzilay.org>

	* calculator.el (calculator-copy-displayer): New user-option.
	(calculator-displayer-prev, calculator-displayer-next):
	Renamed from calculator-displayed-{left,right}.
	(calculator, calculator-standard-displayer)
	(calculator-num-to-string, calculator-update-display)
	(calculator-copy, calculator-put-value): Bug and display fixes.

2001-09-24  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ebnf2ps.el: Eliminate make-local-hook calls.  Doc fix.
	(ebnf-version): New version (3.6.1).

	* ebnf-bnf.el: Fix character range regexp.  Doc fix.
	(ebnf-bnf-non-terminal-chars): New internal const.
	(ebnf-bnf-lex): Fix code.

	* ebnf-iso.el: Fix character range regexp.  Doc fix.
	(ebnf-iso-non-terminal-chars): New internal const.
	(ebnf-iso-lex): Fix code.

	* ebnf-yac.el: Fix character range regexp.  Doc fix.
	(ebnf-yac-skip-chars): New internal const.
	(ebnf-yac-skip-code): Fix code.

2001-09-24  Stefan Monnier  <monnier@cs.yale.edu>

	* vc.el (vc-checkin): Use vc-delete-automatic-version-backups.

	* pcvs-parse.el (cvs-parse-commit): Expand the file name before
	passing it to VC.

	* vc-hooks.el (vc-delete-automatic-version-backups): Handle the
	case where the file is relative.

2001-09-24  Gerd Moellmann  <gerd@gnu.org>

	* xml.el (xml-parse-attlist): Quotes around attributes must be the
	same on each side.  Make sure we properly handle simple quotes.
	From Daiki Ueno <ueno@unixuser.org>.

2001-09-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/sendmail.el (mail-mode): Doc fix.  From Simon Josefsson
	<jas@extundo.com>.

	* menu-bar.el (top-level): Minor fixes for text of help-echo in
	some items of the Options menu.

2001-09-22  Stefan Monnier  <monnier@cs.yale.edu>

	* pcvs-parse.el (cvs-parse-commit): Remove the temp files used by VC.

	* vc-hooks.el (vc-delete-automatic-version-backups):
	Don't fail if the directory doesn't exist.

	* diff-mode.el (diff-default-read-only): New var.
	(diff-mode): Use it.

2001-09-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* hexl.el (hexl-mode-map): Fix the change of 2001-08-23:
	Use make-keymap instead of copy-keymap, since copying the global
	keymap messes up the menu bar.

	* info.el (Info-goto-node, Info-menu): Doc fix.  Suggested by
	Roland Winkler <Roland.Winkler@physik.uni-erlangen.de>.

2001-09-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.el (dired-build-subdir-alist): Accept optional arg SWITCHES.

	* dired-aux.el (dired-insert-subdir): Pass switches to
	dired-build-subdir-alist.

2001-09-21  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* time-stamp.el (time-stamp-string-preprocess): Fix bug that
	caused %#a and %#b to be mis-formatted.

2001-09-20  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-file-list-for-emacs): Add elements for ada-mode,
	ccmode, emacs-mime, and eudc manuals.

2001-09-19  Sam Steingold  <sds@gnu.org>

	w32 find cannot be used with `grep-find'.
	* progmodes/compile.el (find-program): New variable.
	(grep-compute-defaults): Use it to set `grep-find-command'.

2001-09-19  Gerd Moellmann  <gerd@gnu.org>

	* ps-bdf.el (bdf-read-bitmap): Initialize returned values to defaults.

2001-09-19  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ebnf2ps.el: Replace "Prologue" by "Prolog" in PostScript
	programming.  Doc fix.
	(ebnf-version): New version (3.6).
	(ebnf-eps-begin): Data fix.
	(ebnf-begin-file): Code fix.

	* ebnf-bnf.el: Doc fix.
	(ebnf-bnf-lex): Fix regexp for non-terminal and terminal tokens.

	* ebnf-iso.el, ebnf-otz.el, ebnf-yac.el: Doc fix.

2001-09-18  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Better face mapping for black/white PostScript printers.
	Check if mark is active when printing a region.  Doc fix.
	(ps-print-version): New version number (6.5.5).
	(ps-print-color-p): Customization fix.
	(ps-black-white-faces): New option.
	(ps-black-white-faces-alist): New internal var.
	(ps-count-lines-preprint, ps-print-preprint-region): New funs.
	(ps-print-region, ps-print-region-with-faces, ps-nb-pages-buffer)
	(ps-nb-pages-region): Interactive fix.
	(ps-extend-face-list, ps-extend-face, ps-setup, ps-begin-job)
	(ps-face-attributes, ps-generate-postscript-with-faces): Code fix.

2001-09-18  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.el (dired-move-to-filename-regexp): Allow one digit in the
	numeric month value, and allow the Kanji character after the it to
	be missing (happens with ls-lisp's output on Japanese versions of
	MS-Windows).

2001-09-18  Miles Bader  <miles@gnu.org>

	* diff-mode.el (diff-mode): Don't make the buffer read-only if
	it's empty (and thus probably a new patch file about to be edited).

2001-09-17  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/checkdoc.el (checkdoc-this-string-valid-engine):
	Check for '(' in column 0 of doc string.

	* gs.el (gs-set-ghostview-window-prop): Use `elt' instead
	of `nth' so that using a vector as bounding-box works.
	From David.Kastrup@neuroinformatik.ruhr-uni-bochum.de.

2001-09-17  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-annotate): Use current workfile version explicitly as
	a default, suggested by Gustav H,Ae(Bllberg <gustav@virtutech.se>.

2001-09-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* ps-bdf.el (bdf-cache-file) <ms-dos>: Use _bdfcache.el, since
	convert-standard-filename doesn't guarantee that the .el extension
	is preserved.

	* dos-fns.el (convert-standard-filename): Replace invalid
	characters only after converting dash/underscore to a period.
	(original-make-auto-save-file-name): New.
	(make-auto-save-file-name): New function, overrides the definition
	on files.el and calls the original function via
	original-make-auto-save-file-name.

	* mail/rmail.el (top-level): Require mule-utils when compiling.
	(rmail-decode-babyl-format): Use detect-coding-with-priority
	instead of detect-coding-region, to favor detection of emacs-mule
	encoded Babyl files written by rmailout.el etc.  Suggested by
	Kenichi Handa <handa@etl.go.jp>.

2001-09-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/em-unix.el (eshell-shuffle-files, eshell-shuffle-files):
	Use `equal', not `=', since the device number can be a cons cell.

2001-09-14  Gerd Moellmann  <gerd@gnu.org>

	* simple.el: Comment out change of 2001-09-13.

2001-09-13  Milan Zamazal  <pdm@zamazal.org>

	* progmodes/compile.el (grep-compute-defaults): Don't set
	grep-command/grep-find-command when it is already non-nil.
	(grep-command): Make it a user option.
	(grep-find-command): Likewise.

2001-09-13  Michael Kifer  <kifer@cs.sunysb.edu>

	* viper-cmd.el (viper-replace-char-subr, viper-envelop-ESC-key):
	inhibit quit.

2001-09-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* files.el (make-auto-save-file-name): If long file names are not
	supported on MS-DOS, truncate the file name to DOS 8+3 limits before
	generating an auto-save file name from it.

2001-09-13  Gerd Moellmann  <gerd@gnu.org>

	* ps-print.el (ps-print-region, ps-print-region-with-faces)
	(ps-nb-pages-region): Signal an error if called interactively
	and the mark is not active.

	* simple.el (minibuffer-prompt-modification)
	(minibuffer-prompt-insertion): New functions.
	(minibuffer-prompt-properties): Use `modification-hooks' and
	`insert-in-front-hooks'.

2001-09-12  Richard M. Stallman  <rms@gnu.org>

	* textmodes/outline.el (outline-regexp): Doc fix.
	Initialize it in the defcustom, the usual way.

2001-09-12  Gerd Moellmann  <gerd@gnu.org>

	* ediff-mult.el (ediff-get-meta-info): Take into account that data
	from `ediff-meta-info' properties need not be an overlay.
	From David Ponce <dponce@voila.fr>.

	* isearch.el (isearch-intersects-p): Fix end checks.

2001-09-11  Eli Zaretskii  <a34785@is.elta.co.il>

	* gud.el (dbx) <gud-dbx-use-stopformat-p>: Move this case into the
	`t' branch of `cond', since Irix 6.1 and up is a special case of
	the standard dbx interface.

2001-09-11  Miles Bader  <miles@gnu.org>

	* comint.el (comint-send-input): When waiting for echoed input,
	don't save the expected end position in `echo-end', so that things
	work properly even if the buffer is modified elsewhere at the same
	time [this happens if `comint-truncate-buffer' is used].

2001-09-11  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/outline.el (outline-mode): Use `^' and a shy group
	when constructing imenu-generic-expression from outline-regexp.

2001-09-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* eshell/em-unix.el (eshell-shuffle-files): Compare inodes with
	`equal' instead of `=', since they can be cons cells.  From Nils
	Goesche <cartan@cartan.de>.

2001-09-10  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-annotate): Rewrote doc string.

2001-09-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* time-stamp.el: Update Stephen Gildea's email address.

2001-09-10  Gerd Moellmann  <gerd@gnu.org>

	* mail/sendmail.el (mail-send): Obey mail-send-nonascii when
	enable-multibyte-characters = nil.  From Hallvard B Furuseth
	<h.b.furuseth@usit.uio.no>.

2001-09-09  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-init.el (ediff-highest-priority): Bug fix.

	* viper-cmd.el (viper-special-read-and-insert-char): New function
	that reads a character and uses the current input method or
	iso-accents when appropriate.

	* viper.el and all others: Corrections to the comment blocks at
	the top.

2001-09-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* info.el (Info-goto-node): Doc fix.

2001-09-07  Gerd Moellmann  <gerd@gnu.org>

	* isearch.el (isearch-intersects-p): New function.
	(isearch-close-unnecessary-overlays): Renamed from *unecessary*,
	use isearch-intersects-p, and clean up.

2001-09-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* textmodes/ispell.el (ispell-dictionary-alist-4): Add "german"
	and "german8", for the new German orthography dictionaries,
	(ispell-dictionary-alist-5, ispell-dictionary-alist-6): Rearrange
	the entries, to keep the line length balanced for loaddefs.el.

2001-09-07  Dr Francis J. Wright  <F.J.Wright@qmw.ac.uk>

	* comint.el (comint-send-input): Handle comint-process-echoes
	differently.

2001-09-07  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* locate.el (locate-insert-header): Remove unnecessary whitespace.

2001-09-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* arc-mode.el (archive-dostime): Fix a typo in minutes' computation.

2001-09-07  Gerd Moellmann  <gerd@gnu.org>

	* server.el (server-switch-buffer):
	* textmodes/refer.el (refer-find-entry-internal):
	* term/sup-mouse.el (sup-pos-to-window):
	* term/bg-mouse.el (bg-window-from-x-y):
	* emacs-lisp/edebug.el (edebug-window-live-p):
	Use get-window-with-predicate.

	* window.el (get-window-with-predicate): Renamed from some-window.
	(some-window): Make it an alias.

2001-09-06  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (undo): Remove positions from buffer-undo-list up to
	the next undo boundary only.

2001-09-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* makefile.nt (install): Don't copy sc.el.  Reported by Richard
	Kim <ryk@dspwiz.com>

	* cus-edit.el (custom-buffer-create-internal): Remove "100%" from
	the message "Creating customization items...done".

2001-09-05  Gerd Moellmann  <gerd@gnu.org>

	* font-lock.el (toplevel): Require `jit-lock' only if
	font-lock-support-mode is set to jit-lock-mode.

2001-09-05  Eli Zaretskii  <eliz@is.elta.co.il>

	* international/quail.el (quail-use-package, quail-inactivate)
	(quail-activate): Mention the hooks these functions run in their
	doc strings.

2001-09-05  Edward M. Reingold <reingold@iit.edu>

	* cal-menu.el (calendar-mouse-view-other-diary-entries): Fix name
	of file in header of menu.

2001-09-04  Gerd Moellmann  <gerd@gnu.org>

	* env.el (setenv): Interactively, if VARIABLE has a current value,
	add that to the front of the history, as the doc string says.

	* comint.el (comint-send-input): Change help-echo.
	From "Dr Francis J. Wright" <F.J.Wright@qmw.ac.uk>.

	* bookmark.el (bookmark-write-file): Bind print-length and
	print-level to nil.  From Tom Capey <tomc@edina.co.uk>.

	* obsolete/uncompress.el: Moved there from lisp/.

	* comint.el (comint-insert-clicked-input): Goto point-max before
	deleting previous input.  From "Dr Francis J. Wright"
	<F.J.Wright@qmw.ac.uk>.

	* simple.el (backward-word): Doc fix.

2001-09-03  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* emacs-lisp/levents.el, emacs-lisp/lucid.el, emacs-lisp/pp.el
	* uncompress.el, uniquify.el, vc.el, view.el, window.el
	* w32-fns.el: Add Keywords header.

2001-09-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el: Fix separators in the Edit menu.  Bring "Fill" near
	"Text Properties".  Suggested by Simon Marshall
	<Simon.Marshall@midas-kapiti.com>.

2001-09-04  Andrew Choi  <akochoi@cse.cuhk.edu.hk>

	* term/mac-win.el (mac-drag-n-drop): Decode file name by
	consulting the value of file-name-coding-system.

2001-09-03  Stefan Monnier  <monnier@cs.yale.edu>

	* help.el (describe-function-1): Save precomputed `file-name' rather
	than recomputing it (incorrectly) with `symbol-file'.

2001-09-03  Gerd Moellmann  <gerd@gnu.org>

	* international/isearch-x.el (isearch-exit-recursive-edit):
	Take three parameters, since it's used as an after-change-function.

	* emacs-lisp/backquote.el (backquote-backquote-symbol)
	(backquote-unquote-symbol, backquote-splice-symbol): Remove `*'
	from doc strings.

2001-09-02  Milan Zamazal  <pdm@zamazal.org>

	* progmodes/glasses.el (glasses-convert-to-unreadable):
	Consider underscores as in `glasses-make-readable'.

2001-09-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/cmacexp.el (c-macro-preprocessor): Use "gcc -E" for
	MS-DOS, since cpp might not be available.

	* menu-bar.el (menu-bar-edit-menu) <yank-menu, yank>:
	Mention "yank" in the help-echo text.
	Suggested by Pavel Jan,Am(Bk <Pavel@Janik.cz>.

2001-09-01  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el (comment-indent): Insert spaces more carefully.

2001-08-31  Eli Zaretskii  <eliz@is.elta.co.il>

	* mail/emacsbug.el (report-emacs-bug): Make sure *Messages*
	exists.  From Andy Petrusenco <andy@int.spb.ru>.

	* hi-lock.el (hi-lock-unface-buffer): Don't call x-popup-menu if
	display-popup-menus-p returns nil.  Suggested by Andy Petrusenco
	<andy@int.spb.ru>.

2001-08-31  Gerd Moellmann  <gerd@gnu.org>

	* isearch.el (isearch-mouse-2): Renamed from isearch-mouse-yank.
	Instead of running mouse-yank-at-click, see what the event is
	bound to outside Isearch and run that.

2001-08-31  Eli Zaretskii  <eliz@is.elta.co.il>

	* menu-bar.el (menu-bar-options-menu) <transient-mark-mode>:
	Fix the menu entry to mention transient-mark-mode.

2001-08-30  Gerd Moellmann  <gerd@gnu.org>

	* simple.el (eval-expression-print-level): Fix last change.

	* bindings.el (mode-line-coding-system-map): New variable.
	(mode-line-mule-info): Give the "%Z" a local-map keymap.

	* simple.el (eval-expression-print-level): Change the type
	of the defcustom to allow nil.

	* emacs-lisp/find-gc.el: Moved here from lisp/.

	* international/quail.el (quail-completion-1):
	Reverse the ((CHAR . DEFN) ...) list before processing it.
	From Kenichi Handa <handa@etl.go.jp>.

	* obsolete/rsz-mini.el, obsolete/sun-curs.el, obsolete/sun-fns.el
	* obsolete/x-apollo.el, obsolete/x-menu.el: Moved here from lisp/.

2001-08-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* toolbar/tool-bar.el (tool-bar-mode): Make it a no-op if images
	aren't supported.  This avoids the annoying gray strip drawn by
	the Windows version instead of the missing tool bar.

2001-08-29  Gerd Moellmann  <gerd@gnu.org>

	* menu-bar.el (menu-bar-options-menu): Make option text, messages
	and tooltips more consistent.  From "Marshall, Simon"
	<Simon.Marshall@midas-kapiti.com>.

	* startup.el (fancy-splash-screens): Temporarily set
	minor-mode-map-alist to nil while displaying splash screens.

2001-08-29  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* buff-menu.el: Add Keywords header.
	Doc fix (C-x C-b is bound to list-buffers).

	* dired-x.el: Add keyword files to get listed in finder.
	Remove confusing notes about GNU Emacs 19.

	* dired.el, dired-aux.el: Add Keywords header.

2001-08-28  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-revert-file): Call the backend even if the FILE's
	contents can be reverted locally; pass new arg CONTENTS-DONE
	down to the backend.

	* vc-cvs.el, vc-rcs.el, vc-sccs.el (vc-*-revert-file): Handle new
	optional arg CONTENTS-DONE.

2001-08-28  Andrew Innes  <andrewi@gnu.org>

	* makefile.nt (DONTCOMPILE): Sync list from makefile.w32-in.

2001-08-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* makefile.nt (install): Copy more *.el files.

2001-08-28  Gerd Moellmann  <gerd@gnu.org>

	* dired.el (dired-mode-map): Bind `y' to dired-show-file-type
	instead of `w' which is already in use.

	* gs.el (gs-load-image): Use sleep-for.
	From David.Kastrup@neuroinformatik.ruhr-uni-bochum.de.

2001-08-28  Miles Bader  <miles@gnu.org>

	* replace.el (query-replace-regexp-eval): Return args from
	`interactive' form in correct order.

2001-08-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* mouse.el (mouse-buffer-menu): If the buffer menu is split by
	major modes, don't create panes for modes for which
	mouse-buffer-menu-alist returns an empty alist.

2001-08-28  Thien-Thi Nguyen  <ttn@gnu.org>

	* progmodes/hideshow.el: Update first-line description.
	Sync comments w/ maintainer version 5.31.

	(hs-isearch-open): Default value now `code'.
	Fix docstring to use "code blocks" vs "comment blocks",
	as opposed to "block" vs "comment".
	(hs-flag-region): Accept `hs-isearch-open' value
	of `block' as synonymous w/ `code'.
	(hs-hide-block-at-point): For code blocks, pass `code'
	to `hs-flag-region' instead of `block'.

2001-08-28  Miles Bader  <miles@gnu.org>

	* comint.el (comint-next-prompt): Don't loop infinitely if
	{next,previous}-single-char-property-change returns its input
	position when the search fails.

2001-08-27  Miles Bader  <miles@gnu.org>

	* comint.el (comint-get-old-input-default): Don't signal an error
	if point is not on an input field; instead, return the current
	line (using `comint-bol' to skip any prompt, in case we're not
	using fields at all).

	* man.el (Man-mode-line-format): Variable removed.
	(Man-mode): Change `mode-line-buffer-identification' instead of
	`mode-line-format'.

2001-08-27  Gerd Moellmann  <gerd@gnu.org>

	* mail/sendmail.el (mail-send-hook): Remove a duplicate defcustom.
	From Simon Josefsson <jas@extundo.com>.

2001-08-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* textmodes/texnfo-upd.el: Remove dots and exclams at end of error
	messages.  From Pavel Jan,Am(Bk <Pavel@Janik.cz>.

	* emacs-lisp/levents.el: Specify FSF as Maintainer.  From Pavel
	Jan,Am(Bk <Pavel@Janik.cz>.

	* emacs-lisp/lselect.el: Ditto.

	* hexl.el (hexl-insert-multibyte-char, hexl-insert-char):
	Remove periods from the end of error message strings.
	From Pavel Jan,Am(Bk <Pavel@Janik.cz>.

	* progmodes/antlr-mode.el: Add Keywords header.  From Pavel
	Jan,Am(Bk <Pavel@Janik.cz>.

	* net/telnet.el: Ditto.

2001-08-26  Gerd Moellmann  <gerd@gnu.org>

	* hl-line.el (hl-line-mode): Add args INIT-VALUE, LIGHTER, and
	KEYMAP to the call to define-minor-mode.

2001-08-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (IT-character-translations) <hebrew-iso8859-8>:
	Replace some of the undefined characters with emulations of bidi
	formatting characters and Niqud as per SI 1311-1.
	(IT-unicode-translations): Ditto.
	(IT-display-table-setup, IT-setup-unicode-display):
	Fill characters without translations with dos-unsupported-char-glyph.

2001-08-24  Simon Josefsson  <jas@extundo.com>

	* hl-line.el (hl-line-mode): Don't be a global mode.
	(global-hl-line-mode): New function.

2001-08-24  Gerd Moellmann  <gerd@gnu.org>

	* gs.el (gs-load-image): Wait for GHOSTVIEW window property
	being reset by Ghostscript.  Don't kill the gs process.
	From David.Kastrup@neuroinformatik.ruhr-uni-bochum.de.

2001-08-24  Andrew Choi  <akochoi@cse.cuhk.edu.hk>

	* term/mac-win.el: Require scroll-bar.

2001-08-23  Stefan Monnier  <monnier@cs.yale.edu>

	* ebuff-menu.el (electric-buffer-list): Use list-buffers-noselect.

2001-08-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* hexl.el (hexl-insert-multibyte-char) New function.
	(hexl-quoted-insert, hexl-self-insert-command)
	(hexl-insert-hex-char, hexl-insert-decimal-char)
	(hexl-insert-octal-char): Call it instead of hexl-insert-char.
	Fix the doc strings accordingly.
	(hexl-insert-char): Reject characters whose code is above 255.
	Doc fix.
	(hexl-mode-map): Copy the global keymap instead of creating a
	sparse keymap, and bind all self-inserting characters to
	hexl-self-insert-command.

2001-08-22  Stefan Monnier  <monnier@cs.yale.edu>

	* wid-edit.el (text): Re-order docstring correctly.

	* mail/sendmail.el (mail-mode): Use adaptive-fill-regexp.

	* textmodes/fill.el (adaptive-fill-regexp): Admit tabs as well.

2001-08-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* simple.el (line-number-mode): Mention the variable
	line-number-display-limit-width in the doc string.

2001-08-22  Gerd Moellmann  <gerd@gnu.org>

	* bindings.el (mode-line-unbury-buffer): Add EVENT parameter.
	Temporarily select EVENT's window for switching buffers.
	(mode-line-bury-buffer): New function.
	(mode-line-buffer-identification-keymap): Use it instead of
	bury-buffer.  Bind down-mouse events to prevent global down-mouse
	events from shining through.

2001-08-21  Stefan Monnier  <monnier@cs.yale.edu>

	* newcomment.el (comment-beginning): Make sure the comment-start
	we found isn't a comment-end (in cases where confusion is possible).

2001-08-22  Miles Bader  <miles@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-file): Remove TARGET-FILE
	before writing it, so that hard-links don't see new version.

2001-08-21  Gerd Moellmann  <gerd@gnu.org>

	* gs.el (gs-set-ghostview-colors-window-prop):
	Call x-change-window-property with 3rd arg FRAME.
	(gs-load-image): Wait for a previous Ghostscript process
	to complete before starting a new one.

	* image.el (image-type-regexps): Make sure that the TIFF
	pattern is only matched at the beginning of a string.
	From Markus Rost <rost@math.ohio-state.edu>.

	* international/swedish.el: Pre-Mule file removed.  From Jonas
	Oberg <jonas@gnu.org>.

2001-08-20  Rajesh Vaidheeswarran  <rv@gnu.org>

	* whitespace.el (whitespace-abort-on-error): Add custom variable
	to whitespace to abort a write-file if whitespace is detected in file.

	* whitespace.el (whitespace-write-file-hook): Hook to be called
	when writing a file. If `whitespace-abort-on-error' is set, the
	write will abort on detecting whitespaces.
	If `whitespace-auto-cleanup' is set, the file will be cleaned
	automatically prior to writing.

	* whitespace.el (whitespace-buffer-search): Let's not insert bogus
	whitespaces in the error output!

	* whitespace.el (whitespace-check-indent-whitespace): Defaults to
	`indent-tabs-mode', since the latter notes user preferences on
	TABs anyway.

	* whitespace.el (whitespace-version): 3.1. All of the above issues
	were raised by Fran,Ag(Bois Pinard, which led to the fixes described.

2001-08-20  Gerd Moellmann  <gerd@gnu.org>

	* textmodes/texnfo-upd.el (texinfo-every-node-update): Remove
	some spaces from a message.  From Pavel Jan,Am(Bk  <Pavel@Janik.cz>.

	* whitespace.el (whitespace-global-mode): Add autoload cookie.

2001-08-20  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-db2): Doc change.

2001-08-20  Alex Schroeder  <alex@gnu.org>

	* sql.el (sql-postgres): Add the database at the end of the
	parameters instead of at the beginning.
	(sql-postgres-options): Doc change.

2001-08-17  Gerd Moellmann  <gerd@gnu.org>

	* custom.el (defcustom): Doc fix.

2001-08-16  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-mule.el (find-composition): Check if (char-after POS)
	returns a valid character.

2001-08-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* hexl.el (hexl-mode, hexl-mode-exit): Adjust hexl-max-address and
	original-point for extra CR characters that are added/removed when
	the buffer is written/read whose EOL type is -dos.

2001-08-16  Miles Bader  <miles@gnu.org>

	* simple.el (line-move): Undo previous change.

	* comint.el (comint-send-input): Add `inhibit-line-move-field-capture'
	property to input-terminating `boundary' overlays to avoid
	line-move wierdness.

2001-08-16  Gerd Moellmann  <gerd@gnu.org>

	* lazy-lock.el (lazy-lock-fontify-region): Widen the current
	buffer in a save-restriction.  Under one test case with Ediff,
	window-scroll-functions are run with a window start that's
	temporarily outside of the restriction.

2001-08-16  Robert J. Chassell <bug-texinfo@gnu.org>

	* textmodes/texnfo-upd.el: Update copyright notice, fix minor typos.
	(texinfo-find-lower-level-node, texinfo-find-higher-level-node)
	(texinfo-menu-locate-entry-p, texinfo-start-menu-description)
	(texinfo-update-menu-region-beginning)
	(texinfo-update-menu-region-end, texinfo-find-pointer): Add new
	command, @ifnottex, to regexps, so it is found.

2001-08-16  Andrew Innes  <andrewi@gnu.org>

	* makefile.nt (DONTCOMPILE): Omit bindings.el.
	(DONTCOMPILE): Omit sc.el.

	* makefile.w32-in (DONTCOMPILE): Omit bindings.el.
	(DONTCOMPILE): Omit sc.el.

2001-08-16  Gerd Moellmann  <gerd@gnu.org>

	* replace.el (occur): Bind inhibit-read-only to t.

2001-08-16  Miles Bader  <miles@gnu.org>

	* simple.el (line-move): Pass an ESCAPE-FROM-EDGE argument of t when
	calling `constrain-to-field', to avoid problems with comint prompts.

2001-08-15  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/cl-indent.el (lisp-indent-defmethod): New function.
	(toplevel): Set it as `common-lisp-indent-function' for `defmethod'.

	* ediff-mult.el (ediff-get-meta-info): Fix the condition
	of a while-loop.

	* Makefile.in (DONTCOMPILE): Remove sc.el.

	* Makefile.in (finder_setwins): Renamed from nonobsolete_setwins.
	Don't include term/.

	* mail/sc.el:  Moved to obsolete/.

2001-08-14  Vinicius Jose Latorre  <vinicius@cpqd.com.br>

	* ps-print.el: Change error function arguments to follow Emacs
	message convention.  Doc fix.
	(ps-print-version): New version number (6.5.4).
	(coding-system-for-write): Change declaration position to avoid
	XEmacs compilation gripes.
	(coding-system-for-read, buffer-file-coding-system):
	Declarations to avoid XEmacs compilation gripes.

	* ps-mule.el: Doc fix.
	(ps-mule-encode-header-string): If STRING is not a string, replace
	STRING by empty string.

2001-08-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.el (show-trailing-whitespace): Doc fix.

2001-08-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* desktop.el (desktop-save): Insert the coding: tag before
	desktop-header.

2001-08-13  Gerd Moellmann  <gerd@gnu.org>

	* Makefile.in (TAGS, TAGS-LISP): Remove "loaddefs.el" including
	its path from $els.

	* image.el (image-jpeg-p): Fix call of substring.

2001-08-10  Gerd Moellmann  <gerd@gnu.org>

	* play/animate.el (animate-string): Doc fix.  Use a buffer
	name with stars in it.
	(animate-sequence): New function.
	From Richard Stallman <rms@gnu.org>.

	* frame.el (select-frame-set-input-focus): New function
	extracted from other-frame.
	(other-frame): Use it.
	(next-multiframe-window, previous-multiframe-window): Use it.

	* isearch.el (isearch-other-meta-char): Don't switch to the
	buffer of a window clicked on, when the current buffer is
	in Isearch mode.

	* image.el (image-jpeg-p): Test for APPn markers in the range
	#xe0..#xef.

2001-08-09  Gerd Moellmann  <gerd@gnu.org>

	* desktop.el (desktop-save): Don't use concat to form a file
	name, use expand-file-name.

	* mouse.el (mouse-delete-window): Do nothing if frame has just
	one window.

	* bindings.el (minor-mode-alist): Use mode-line-minor-mode-keymap
	for the minor mode name.

	* view.el (toplevel): Use mode-line-minor-mode-keymap for the
	minor mode name.

	* time.el (display-time-string-forms): Use make-mode-line-mouse-map
	instead of make-mode-line-mouse2-map.

	* subr.el (add-minor-mode): Use mode-line-minor-mode-keymap for
	the minor mode name.

	* emacs-lisp/easy-mmode.el (define-minor-mode):
	Use  mode-line-minor-mode-keymap for the minor mode name.

	* calendar/calendar.el (calendar-mode-line-format):
	Use make-mode-line-mouse-map instead of make-mode-line-mouse2-map.

	* bindings.el (make-mode-line-mouse-map): Renamed from
	make-mode-line-mouse2-map.  Take additional arg MOUSE.
	(mode-line-modified): Use mouse-3 instead of mouse-2.
	(mode-line-buffer-identification-keymap): Bind keys differently.
	(propertized-buffer-identification): Adapt help-echo to new bindings.

	* bindings.el (mode-line-format): Specify help-echo for line
	number, column number and buffer-percent part of the mode-line.

	* image.el (image-type-regexps): Allow whitespace at the start
	of the image data for XPM, XBM and Postscript, which are
	text files.
	(image-jpeg-p): Correct calculation of next field offset.

2001-08-08  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* battery.el: Fix typo.

2001-08-08  Gerd Moellmann  <gerd@gnu.org>

	* image.el (image-type-regexps): Allow predicates.  Change the way
	JPEG images are recognized.
	(image-jpeg-p): New function.
	(image-type-from-data): Handle predicates in image-type-regexps.

	* emacs-lisp/edebug.el (edebug-read-function): Fix handling of
	#:, #x, #o, and similar constructs.

2001-08-07  Gerd Moellmann  <gerd@gnu.org>

	* vc.el (vc-transfer-file): Fix malformed autoload cookie.

	* emulation/viper-util.el (viper-file-checked-in-p): Use `and'
	instead of `progn'.

	* tar-mode.el (tar-extract): Avoid generating a new buffer
	for each file visited.  From Markus Rost <rost@math.ohio-state.edu>.

	* textmodes/paragraphs.el (forward-sentence): Avoid building
	a regexp from sentence-end.  From Kenichi Handa <handa@etl.go.jp>.

	* progmodes/executable.el (executable-set-magic):
	If executable-find returns a quoted file name, unquote it before
	inserting it.

	* image.el (image-type-regexps): For JPEG files, use a regexp
	derived from the JFIF spec.

	* image.el (image-type-regexps): Use `\`' instead of `^' in
	most regular expressions.

2001-08-06  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* play/animate.el: Re-insert a reference to re-inserted function.

2001-08-06  Gerd Moellmann  <gerd@gnu.org>

	* help.el (describe-function-1): Use find-function-search-for-symbol
	instead of find-function-noselect because the latter follows aliases.

	* play/animate.el (animate-birthday-present): Re-insert.

	* toolbar/tool-bar.el (tool-bar-add-item-from-menu):
	Handle old-style menu definitions.

2001-08-06  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* textmodes/makeinfo.el, textmodes/page-ext.el, textmodes/page.el,
	* textmodes/text-mode.el, textmodes/two-column.el: Keywords added.

	* play/studly.el, mail/unrmail.el, emacs-lisp/lucid.el,
	* emulation/pc-mode.el, diff.el, textmodes/fill.el, abbrev.el,
	* add-log.el, faces.el, mail/sc.el: Specify FSF as Maintainer.

2001-08-05  Pavel Jan,Am(Bk  <Pavel@Janik.cz>

	* textmodes/tildify.el: Milan Zamazal has new address.

2001-08-03  Gerd Moellmann  <gerd@gnu.org>

	* custom.el (custom-set-variables): Don't test `custom-requests'
	properties, check the third element of the options passed to
	custom-set-variables instead.

	* info.el (info-insert-file-contents): Use info-file-exists-p
	instead of file-exists-p.

	* play/zone.el (zone-pgm-stress): Use unwind-protect to make sure
	the mode-line face is restored.  Fix several bugs.

	* replace.el (perform-replace): Doc fix.

2001-08-02  Francesco Potorti`  <pot@gnu.org>

	* uniquify.el (uniquify-ref-base, uniquify-ref-filename)
	(uniquify-ref-buffer, uniquify-ref-proposed): New functions.
	(uniquify-fix-item-base, uniquify-fix-item-filename)
	(uniquify-fix-item-buffer, uniquify-fix-item-proposed): Deleted.
	Callers changed.
	(uniquify-set-proposed): Changed to work with a vector item.
	(uniquify-rationalize-file-buffer-names): Use a list of arrays for
	the fix list, and a list of strings for the non-file buffer
	names.  Both changes reduce consing.
	(uniquify-rationalize-a-list): Local variable renaming.
	(uniquify-rationalize-conflicting-sublist): Use member instead of
	assoc.
	(uniquify-rename-buffer): Use unless instead of if not.

2001-08-02  Gerd Moellmann  <gerd@gnu.org>

	* recentf.el (recentf-dump-variable): Handle a value of nil correctly.

	* custom.el (custom-set-variables): Set options with :require
	clauses last.

	* custom.el (defcustom): Doc fix.

	* Makefile.in (TAGS, TAGS-LISP): Exclude loaddefs.el.

2001-08-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* man.el (man): Mention Man-switches in the doc string.
	(Man-switches): Mention -a in the doc string.

	* textmodes/ispell.el (ispell-alternate-dictionary):
	Add /usr/share/lib/dict/words, for Irix.

	* bindings.el: Bind shifted and control-shifted kp-* keys to the
	corresponding non-kp keys.  Suggested by Stephen Gildea
	<gildea@stop.mail-abuse.org>.

2001-08-01  Francesco Potorti`  <pot@gnu.org>

	* uniquify.el: These changes correct a corner case that the old
	code managed correctly.
	(uniquify-fix-item-proposed): Renamed from
	uniquify-fix-item-min-proposed.
	(uniquify-set-proposed): New function.
	(uniquify-rationalize-file-buffer-names): Code reshuffled for
	clarity and speed.
	(uniquify-item-greaterp): Substitutes uniquify-item-lessp.
	This is equivalent to what the old code did.
	(uniquify-rationalize-a-list): Never recompute the proposed
	name.  Sort the conflicting sublist before rationalising it: this
	is equivalent to what the old code did, but one directory element
	at a time, and only when necessary.
	(uniquify-rationalize-conflicting-sublist): Recompute here the
	proposed name.

2001-08-01  Gerd Moellmann  <gerd@gnu.org>

	* play/animate.el: Add Keywords and Maintainer.  Remove a
	reference to a removed function.

	* play/animate.el (animate-string): Handle case that the string is
	longer than the window is wide.

2001-07-31  Gerd Moellmann  <gerd@gnu.org>

	* desktop.el (desktop-save): Bind coding-system-for-write to
	`emacs-mule' for write-region.

	* delsel.el (delete-selection-pre-hook): Don't set this-command
	to `ignore' if the region is empty.

	* international/mule.el (set-keyboard-coding-system):
	Set keyboard-coding-system.

	* smerge-mode.el (smerge-mode): Check if `font-lock-mode' is bound
	before accessing it.

2001-07-30  Andreas Schwab  <schwab@suse.de>

	* menu-bar.el (toggle-highlight-paren-mode):
	Use `(show-paren-mode)' as body.

2001-07-30  Andre Spiegel  <spiegel@gnu.org>

	* vc.el (vc-checkout-hook): New hook.
	(vc-checkout): Run it.

2001-07-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* progmodes/make-mode.el (makefile-macroassign-regex):
	Recognize the ?= operator.  From Jonathan Kamens <jik@curl.com>.

2001-07-30  Gerd Moellmann  <gerd@gnu.org>

	* vc.el (vc-switch-backend): Fix autoload cookie.

	* desktop.el (desktop-save): Add `-*- coding: emacs-mule -*-' to
	the desktop file.

2001-07-30  Simon Josefsson  <jas@extundo.com>

	* mail/mail-utils.el (mail-strip-quoted-names): Replace text
	literally.  Reported by Sean Rima <sean@**Delete**.tcob1.net>.

2001-07-27  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/lisp-mode.el (last-sexp-setup-props): New function.
	(last-sexp-toggle-display): Renamed from last-sexp-print.
	(last-sexp-toggle-display, eval-last-sexp-1):
	Use last-sexp-setup-props.

	* mwheel.el (mouse-wheel-down-button, mouse-wheel-up-button):
	New user-options.
	(mouse-wheel-change-button): New function.
	(mouse-wheel-mode): Use mouse-wheel-{up,down}-button.
	(mwheel-scroll): Ditto.

2001-07-26  Gerd Moellmann  <gerd@gnu.org>

	* emacs-lisp/lisp-mode.el (eval-last-sexp-1): Don't search for
	`...', compare with unabbreviated printed representation instead.
	(last-sexp-print): Bind print-length and print-level to nil.

	* emacs-lisp/lisp-mode.el (eval-last-sexp-1): Look for a `...'
	before assigning text properties.  Make properties rear-nonsticky.

	* emacs-lisp/lisp-mode.el (last-sexp-print): New function.
	(eval-last-sexp-1): Give printed text a `keymap' property and bind
	<mouse-2> and <RET> in that map to a function printing the
	unabbreviated value.

	* emacs-lisp/lisp-mode.el (eval-last-sexp-1): If standard-output
	is a buffer, put a text property `printed-value' on the printed
	representation, with the Lisp object printed as value.

2001-07-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* emacs-lisp/lisp-mode.el (eval-print-last-sexp, eval-defun):
	Mention the effect of eval-expression-print-length and
	eval-expression-print-level in the doc strings.  Suggested by
	Kevin Gallagher <kevingal@onramp.net>.

2001-07-25  Gerd Moellmann  <gerd@gnu.org>

	* xt-mouse.el (xterm-mouse-event): Recognize control sequences
	for buttons > 3.
	(xterm-mouse-translate): Handle the case that we don't get a
	down-event.

	* emacs-lisp/find-func.el (find-function-regexp):
	Add easy-mmode-define-global-mode to the regexp.  Allow newlines
	in front of the function name.

	* isearch.el (isearch-other-meta-char): Fix last change.

	* isearch.el (isearch-other-meta-char): Don't modify mode-line and
	similar events for which fake prefix keys are generated.  It's no
	longer necessary since read_key_sequence doesn't modify these
	events for internal purposes anymore.

	* files.el (auto-mode-alist): Use nroff-mode for files ending
	in `.9'.  From Assar Westerlund  <assar@stacken.kth.se>.

2001-07-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* avoid.el (mouse-avoidance-too-close-p): If the frame lacks a
	tool-bar-lines parameter, behave as if its value were zero.
	(mouse-avoidance-set-pointer-shape): Don't do anything if
	x-pointer-shape is not boundp.

2001-07-23  Francesco Potorti`  <pot@gnu.org>

	* uniquify.el: Overall speedup changes when using many buffers.
	(uniquify-fix-item-base, uniquify-fix-item-filename)
	(uniquify-fix-item-buffer): Changed defmacro to defalias (cosmetic).
	(uniquify-fix-item-unrationalized-buffer): Deleted: was the fourth
	place in the item, but was never used.
	(uniquify-fix-item-min-proposed): New defalias: the fourth place
	in the item is now used as cache for the proposed name.
	(uniquify-rationalize-file-buffer-names): Move computation made on
	newbuffile out of the loop, in the newbuffile-nd local var.
	Use dolist (cosmetic change).  Compute the proposed name for the most
	common case and cache it in the fourth place in the item.
	(uniquify-rationalize-file-buffer-names): Used to return a a list
	of buffer whose name was changed, but that return value was never used.
	(uniquify-item-lessp): Replaces uniquify-filename-lessp, works on
	the cached proposed name, does much less consing and is quicker.
	(uniquify-filename-lessp): Deleted.
	(uniquify-rationalize-a-list): Use dolist (cosmetic change).
	Do not bind locally the uniquify-possibly-resolvable flag.  Use the
	cached proposed name is possible.
	(uniquify-get-proposed-name): Arguments changed, callers changed.
	(uniquify-rationalize-conflicting-sublist): Explicitely reset the
	uniquify-possibly-resolvable flag, which is no more bound locally.
	(uniquify-rename-buffer): Do not set the old unrationalised-buffer
	flag, which does not exist any more.

2001-07-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* term/internal.el (IT-unicode-translations): Fix the appearance of
	"6`".

	* progmodes/compile.el (compile-internal): If EMACS is already
	defined in the environment, don't override its value.

2001-07-23  Gerd Moellmann  <gerd@gnu.org>

	* play/fortune.el: Undo change of 2001-07-13.
	Fix autoload cookies.  Add types to defcustoms.
	(fortune) <defgroup>: Add :link.
	(fortune-from-region): Use eq, not eql.
	From Dave Love <fx@gnu.org>.

	* play/animate.el (animate-birthday-present): Function removed.

	* play/animate.el: New file.

2001-07-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* startup.el (normal-top-level-add-subdirs-to-load-path):
	On Windows, put into normal-top-level-add-subdirs-inode-list the
	canonicalized names of the directories instead of inode numbers.

2001-07-21  Michael Kifer  <kifer@cs.sunysb.edu>

	* ediff-util.el: Copyright years.
	(ediff-choose-syntax-table): New function.
	(ediff-setup): Use ediff-choose-syntax-table.
	(ediff-file-checked-out-p,ediff-file-checked-in-p): Check if
	vc-state is available.
	(ediff-make-temp-file): Use ediff-coding-system-for-write.

	* ediff-init.el (ediff-with-syntax-table): New macro, uses
	with-syntax-table.
